#include "controller.h"
# 369 "/h/27/yijun/software/vim62/src/option.h"
extern char_u *p_dip;
# 4 "/h/27/yijun/software/vim62/src/proto/diff.pro"
void diff_buf_add (buf_T *buf);
# 7 "/h/27/yijun/software/vim62/src/proto/eval.pro"
void eval_diff (char_u *origfile, char_u *newfile, char_u *outfile);
# 8 "/h/27/yijun/software/vim62/src/proto/eval.pro"
void eval_patch (char_u *origfile, char_u *difffile, char_u *outfile);
# 34 "/h/27/yijun/software/vim62/src/diff.cpp.c"
typedef struct diffblock diff_T;
# 35 "/h/27/yijun/software/vim62/src/diff.cpp.c"
struct diffblock
{
    diff_T *df_next;
    linenr_T df_lnum[4];
    linenr_T df_count[4];
};
# 42 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static diff_T *first_diff = ((void *)0);
# 44 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static buf_T *(diffbuf[4]);
# 46 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static int diff_invalid = 1;
# 48 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static int diff_busy = 0;
# 54 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static int diff_flags = 1;
# 58 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static int diff_a_works = 2;
# 61 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static int diff_buf_idx (buf_T *buf);
# 62 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static void diff_check_unchanged (diff_T *dp);
# 63 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static int diff_check_sanity (diff_T *dp);
# 64 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static void diff_redraw (int dofold);
# 65 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static void diff_file (char_u *tmp_orig, char_u *tmp_new, char_u *tmp_diff);
# 66 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static void diff_clear (void);
# 67 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static int diff_equal_entry (diff_T *dp, int idx1, int idx2);
# 68 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static int diff_cmp (char_u *s1, char_u *s2);
# 70 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static void diff_fold_update (diff_T *dp, int skip_idx);
# 72 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static void diff_read (int idx_orig, int idx_new, char_u *fname);
# 73 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static void diff_copy_entry (diff_T *dprev, diff_T *dp, int idx_orig, int idx_new);
# 74 "/h/27/yijun/software/vim62/src/diff.cpp.c"
static diff_T *diff_alloc_new (diff_T *dprev, diff_T *dp);
# 88 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    void diff_new_buffer()
{
    if (curwin->w_onebuf_opt.wo_diff)
        diff_buf_add(curbuf);
}
# 100 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    void diff_buf_delete(buf)
    buf_T *buf;
{
    int i;

    i = diff_buf_idx(buf);
    if (i != 4)
    {
        diffbuf[i] = ((void *)0);
        diff_invalid = 1;
    }
}
# 117 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    void diff_buf_add(buf)
    buf_T *buf;
{
    int i;

    if (diff_buf_idx(buf) != 4)
        return;

    for (i = 0; i < 4; ++i)
        if (diffbuf[i] == ((void *)0))
        {
            diffbuf[i] = buf;
            diff_invalid = 1;
            return;
        }

    emsg2((char_u *)(((char *)("E96: Can not diff more than %ld buffers"))), (char_u *)(4));
}
# 141 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    static int diff_buf_idx(buf)
    buf_T *buf;
{
    int idx;

    for (idx = 0; idx < 4; ++idx)
        if (diffbuf[idx] == buf)
            break;
    return idx;
}
# 156 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    void diff_invalidate()
{
    if (curwin->w_onebuf_opt.wo_diff)
    {
        diff_invalid = 1;
        diff_redraw(1);
    }
}
# 173 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    void diff_mark_adjust(line1, line2, amount, amount_after)
    linenr_T line1;
    linenr_T line2;
    long amount;
    long amount_after;
{
    diff_T *dp;
    diff_T *dprev;
    diff_T *dnext;
    int idx;
    int i;
    int inserted, deleted;
    int n, off;
    linenr_T last;
    linenr_T lnum_deleted = line1;
    int check_unchanged;


    idx = diff_buf_idx(curbuf);
    if (idx == 4)
        return;

    if (line2 == (0x7fffffffL))
    {

        inserted = amount;
        deleted = 0;
    }
    else if (amount_after > 0)
    {

        inserted = amount_after;
        deleted = 0;
    }
    else
    {

        inserted = 0;
        deleted = -amount_after;
    }

    dprev = ((void *)0);
    dp = first_diff;
    for (;;)
    {



        if ((dp == ((void *)0) || dp->df_lnum[idx] - 1 > line2
                    || (line2 == (0x7fffffffL) && dp->df_lnum[idx] > line1))
                && (dprev == ((void *)0)
                    || dprev->df_lnum[idx] + dprev->df_count[idx] < line1)
                && !diff_busy)
        {
            dnext = diff_alloc_new(dprev, dp);
            if (dnext == ((void *)0))
                return;

            dnext->df_lnum[idx] = line1;
            dnext->df_count[idx] = inserted;
            for (i = 0; i < 4; ++i)
                if (diffbuf[i] != ((void *)0) && i != idx)
                {
                    if (dprev == ((void *)0))
                        dnext->df_lnum[i] = line1;
                    else
                        dnext->df_lnum[i] = line1
                            + (dprev->df_lnum[i] + dprev->df_count[i])
                            - (dprev->df_lnum[idx] + dprev->df_count[idx]);
                    dnext->df_count[i] = deleted;
                }
        }


        if (dp == ((void *)0))
            break;
        last = dp->df_lnum[idx] + dp->df_count[idx] - 1;


        if (last >= line1 - 1)
        {


            if (dp->df_lnum[idx] - (deleted + inserted != 0) > line2)
            {
                if (amount_after == 0)
                    break;
                dp->df_lnum[idx] += amount_after;
            }
            else
            {
                check_unchanged = 0;


                if (deleted > 0)
                {
                    if (dp->df_lnum[idx] >= line1)
                    {
                        off = dp->df_lnum[idx] - lnum_deleted;
                        if (last <= line2)
                        {

                            if (dp->df_next != ((void *)0)
                                    && dp->df_next->df_lnum[idx] - 1 <= line2)
                            {


                                n = dp->df_next->df_lnum[idx] - lnum_deleted;
                                deleted -= n;
                                n -= dp->df_count[idx];
                                lnum_deleted = dp->df_next->df_lnum[idx];
                            }
                            else
                                n = deleted - dp->df_count[idx];
                            dp->df_count[idx] = 0;
                        }
                        else
                        {

                            n = off;
                            dp->df_count[idx] -= line2 - dp->df_lnum[idx] + 1;
                            check_unchanged = 1;
                        }
                        dp->df_lnum[idx] = line1;
                    }
                    else
                    {
                        off = 0;
                        if (last < line2)
                        {

                            dp->df_count[idx] -= last - lnum_deleted + 1;
                            if (dp->df_next != ((void *)0)
                                    && dp->df_next->df_lnum[idx] - 1 <= line2)
                            {


                                n = dp->df_next->df_lnum[idx] - 1 - last;
                                deleted -= dp->df_next->df_lnum[idx]
                                                               - lnum_deleted;
                                lnum_deleted = dp->df_next->df_lnum[idx];
                            }
                            else
                                n = line2 - last;
                            check_unchanged = 1;
                        }
                        else
                        {

                            n = 0;
                            dp->df_count[idx] -= deleted;
                        }
                    }

                    for (i = 0; i < 4; ++i)
                        if (diffbuf[i] != ((void *)0) && i != idx)
                        {
                            dp->df_lnum[i] -= off;
                            dp->df_count[i] += n;
                        }
                }
                else
                {
                    if (dp->df_lnum[idx] <= line1)
                    {

                        dp->df_count[idx] += inserted;
                        check_unchanged = 1;
                    }
                    else

                        dp->df_lnum[idx] += inserted;
                }

                if (check_unchanged)



                    diff_check_unchanged(dp);
            }
        }


        if (dprev != ((void *)0) && dprev->df_lnum[idx] + dprev->df_count[idx]
                                                          == dp->df_lnum[idx])
        {
            for (i = 0; i < 4; ++i)
                if (diffbuf[i] != ((void *)0))
                    dprev->df_count[i] += dp->df_count[i];
            dprev->df_next = dp->df_next;
            vim_free(dp);
            dp = dprev->df_next;
        }
        else
        {

            dprev = dp;
            dp = dp->df_next;
        }
    }

    dprev = ((void *)0);
    dp = first_diff;
    while (dp != ((void *)0))
    {

        for (i = 0; i < 4; ++i)
            if (diffbuf[i] != ((void *)0) && dp->df_count[i] != 0)
                break;
        if (i == 4)
        {
            dnext = dp->df_next;
            vim_free(dp);
            dp = dnext;
            if (dprev == ((void *)0))
                first_diff = dnext;
            else
                dprev->df_next = dnext;
        }
        else
        {

            dprev = dp;
            dp = dp->df_next;
        }

    }
    diff_redraw(1);
}
# 420 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    static diff_T * diff_alloc_new(dprev, dp)
    diff_T *dprev;
    diff_T *dp;
{
    diff_T *dnew;

    dnew = (diff_T *)alloc((unsigned)sizeof(diff_T));
    if (dnew != ((void *)0))
    {
        dnew->df_next = dp;
        if (dprev == ((void *)0))
            first_diff = dnew;
        else
            dprev->df_next = dnew;
    }
    return dnew;
}
# 445 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    static void diff_check_unchanged(dp)
    diff_T *dp;
{
    int i_org;
    int i_new;
    int off_org, off_new;
    char_u *line_org;
    int dir = 1;



    for (i_org = 0; i_org < 4; ++i_org)
        if (diffbuf[i_org] != ((void *)0))
            break;
    if (i_org == 4)
        return;

    if (diff_check_sanity(dp) == 0)
        return;


    off_org = 0;
    off_new = 0;
    for (;;)
    {


        while (dp->df_count[i_org] > 0)
        {

            if (dir == (-1))
                off_org = dp->df_count[i_org] - 1;
            line_org = vim_strsave(ml_get_buf(diffbuf[i_org],
                                        dp->df_lnum[i_org] + off_org, 0));
            if (line_org == ((void *)0))
                return;
            for (i_new = i_org + 1; i_new < 4; ++i_new)
            {
                if (diffbuf[i_new] == ((void *)0))
                    continue;
                if (dir == (-1))
                    off_new = dp->df_count[i_new] - 1;

                if (off_new < 0 || off_new >= dp->df_count[i_new])
                    break;
                if (diff_cmp(line_org, ml_get_buf(diffbuf[i_new],
                                   dp->df_lnum[i_new] + off_new, 0)) != 0)
                    break;
            }
            vim_free(line_org);


            if (i_new != 4)
                break;


            for (i_new = i_org; i_new < 4; ++i_new)
                if (diffbuf[i_new] != ((void *)0))
                {
                    if (dir == 1)
                        ++dp->df_lnum[i_new];
                    --dp->df_count[i_new];
                }
        }
        if (dir == (-1))
            break;
        dir = (-1);
    }
}
# 520 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    static int diff_check_sanity(dp)
    diff_T *dp;
{
    int i;

    for (i = 0; i < 4; ++i)
        if (diffbuf[i] != ((void *)0))
            if (dp->df_lnum[i] + dp->df_count[i] - 1
                                             > diffbuf[i]->b_ml.ml_line_count)
                return 0;
    return 1;
}
# 537 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    static void diff_redraw(dofold)
    int dofold;
{
    win_T *wp;

    for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
        if (wp->w_onebuf_opt.wo_diff)
        {
            redraw_win_later(wp, 40);

            if (dofold && foldmethodIsDiff(wp))
                foldUpdateAll(wp);

        }
}
# 561 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    void ex_diffupdate(eap)
    exarg_T *eap;
{
    buf_T *buf;
    int idx_orig;
    int idx_new;
    char_u *tmp_orig;
    char_u *tmp_new;
    char_u *tmp_diff;
    FILE *fd;
    int ok = 0;


    diff_clear();
    diff_invalid = 0;


    for (idx_orig = 0; idx_orig < 4; ++idx_orig)
        if (diffbuf[idx_orig] != ((void *)0))
            break;
    if (idx_orig == 4)
        return;


    for (idx_new = idx_orig + 1; idx_new < 4; ++idx_new)
        if (diffbuf[idx_new] != ((void *)0))
            break;
    if (idx_new == 4)
        return;


    tmp_orig = vim_tempname('o');
    tmp_new = vim_tempname('n');
    tmp_diff = vim_tempname('d');
    if (tmp_orig == ((void *)0) || tmp_new == ((void *)0) || tmp_diff == ((void *)0))
        goto theend;







    for (;;)
    {
        fd = fopen((char *)tmp_orig, "w");
        if (fd != ((void *)0))
        {
            fwrite("line1\n", (size_t)6, (size_t)1, fd);
            fclose(fd);
            fd = fopen((char *)tmp_new, "w");
            if (fd != ((void *)0))
            {
                fwrite("line2\n", (size_t)6, (size_t)1, fd);
                fclose(fd);
                diff_file(tmp_orig, tmp_new, tmp_diff);
                fd = fopen((char *)tmp_diff, "r");
                if (fd != ((void *)0))
                {
                    char_u linebuf[50];

                    for (;;)
                    {

                        if (vim_fgets(linebuf, 50, fd))
                            break;
                        if (strncmp((char *)(linebuf), (char *)("1c1"), (size_t)(3)) == 0)
                            ok = 1;
                    }
                    fclose(fd);
                }
                unlink((char *)(tmp_diff));
                unlink((char *)(tmp_new));
            }
            unlink((char *)(tmp_orig));
        }


        if (diff_a_works != 2

                || *p_dex != '\000'

                )
                break;
        diff_a_works = ok;
        if (ok)
            break;
    }
    if (!ok)
    {
        emsg((char_u *)(((char *)("E97: Cannot create diffs"))));
        diff_a_works = 2;
        goto theend;
    }


    buf = diffbuf[idx_orig];
    if (buf_write(buf, tmp_orig, ((void *)0), (linenr_T)1, buf->b_ml.ml_line_count,
                                     ((void *)0), 0, 0, 0, 1) == 0)
        goto theend;


    for (idx_new = idx_orig + 1; idx_new < 4; ++idx_new)
    {
        buf = diffbuf[idx_new];
        if (buf == ((void *)0))
            continue;
        if (buf_write(buf, tmp_new, ((void *)0), (linenr_T)1, buf->b_ml.ml_line_count,
                                     ((void *)0), 0, 0, 0, 1) == 0)
            continue;
        diff_file(tmp_orig, tmp_new, tmp_diff);


        diff_read(idx_orig, idx_new, tmp_diff);
        unlink((char *)(tmp_diff));
        unlink((char *)(tmp_new));
    }
    unlink((char *)(tmp_orig));

    diff_redraw(1);

theend:
    vim_free(tmp_orig);
    vim_free(tmp_new);
    vim_free(tmp_diff);
}
# 692 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    static void diff_file(tmp_orig, tmp_new, tmp_diff)
    char_u *tmp_orig;
    char_u *tmp_new;
    char_u *tmp_diff;
{
    char_u *cmd;


    if (*p_dex != '\000')

        eval_diff(tmp_orig, tmp_new, tmp_diff);
    else

    {
        cmd = alloc((unsigned)(strlen((char *)(tmp_orig)) + strlen((char *)(tmp_new))
                                + strlen((char *)(tmp_diff)) + strlen((char *)(p_srr)) + 17));
        if (cmd != ((void *)0))
        {



            sprintf((char *)cmd, "diff %s%s%s%s %s",
                    diff_a_works == 0 ? "" : "-a ",
                    (diff_flags & 4) ? "-b " : "",
                    (diff_flags & 2) ? "-i " : "",
                    tmp_orig, tmp_new);
            append_redir(cmd, p_srr, tmp_diff);
            (void)call_shell(cmd, 1|16|8);
            vim_free(cmd);
        }
    }
}
# 731 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    void ex_diffpatch(eap)
    exarg_T *eap;
{
    char_u *tmp_orig;
    char_u *tmp_new;
    char_u *buf = ((void *)0);
    win_T *old_curwin = curwin;
    char_u *newname = ((void *)0);

    char_u dirbuf[1024];
    char_u *fullname = ((void *)0);


    char_u *browseFile = ((void *)0);



    if (cmdmod.browse)
    {
        browseFile = do_browse(0, (char_u *)((char *)("Patch file")),
                         eap->arg, ((void *)0), ((void *)0), (char_u *)"All Files (*)\t*\n", ((void *)0));
        if (browseFile == ((void *)0))
            return;
        eap->arg = browseFile;
    }



    tmp_orig = vim_tempname('o');
    tmp_new = vim_tempname('n');
    if (tmp_orig == ((void *)0) || tmp_new == ((void *)0))
        goto theend;


    if (buf_write(curbuf, tmp_orig, ((void *)0),
                (linenr_T)1, curbuf->b_ml.ml_line_count,
                                     ((void *)0), 0, 0, 0, 1) == 0)
        goto theend;



    fullname = FullName_save(eap->arg, 0);

    buf = alloc((unsigned)(strlen((char *)(tmp_orig)) + (

                    fullname != ((void *)0) ? strlen((char *)(fullname)) :

                    strlen((char *)(eap->arg))) + strlen((char *)(tmp_new)) + 16));
    if (buf == ((void *)0))
        goto theend;







    if (mch_dirname(dirbuf, 1024) != 1 || chdir((char *)dirbuf) != 0)
        dirbuf[0] = '\000';
    else
    {

        if (vim_tempdir != ((void *)0))
            chdir((char *)vim_tempdir);
        else

            chdir("/tmp");
        shorten_fnames(1);
    }



    if (*p_pex != '\000')

        eval_patch(tmp_orig,

                fullname != ((void *)0) ? fullname :

                eap->arg, tmp_new);
    else

    {


        sprintf((char *)buf, "patch -o %s %s < \"%s\"", tmp_new, tmp_orig,

                fullname != ((void *)0) ? fullname :

                eap->arg);
        (void)call_shell(buf, 1 | 4);
    }


    if (dirbuf[0] != '\000')
    {
        if (chdir((char *)dirbuf) != 0)
            emsg((char_u *)(((char *)(e_prev_dir))));
        shorten_fnames(1);
    }



    redraw_later(50);


    strcpy((char *)(buf), (char *)(tmp_new));
    strcat((char *)(buf), (char *)(".orig"));
    unlink((char *)(buf));
    strcpy((char *)(buf), (char *)(tmp_new));
    strcat((char *)(buf), (char *)(".rej"));
    unlink((char *)(buf));

    if (curbuf->b_fname != ((void *)0))
    {
        newname = vim_strnsave(curbuf->b_fname,
                                          (int)(strlen((char *)(curbuf->b_fname)) + 4));
        if (newname != ((void *)0))
            strcat((char *)(newname), (char *)(".new"));
    }


    need_mouse_correct = 1;

    if (win_split(0, 0) != 0)
    {

        eap->cmdidx = CMD_split;
        eap->arg = tmp_new;
        do_exedit(eap, old_curwin);

        if (curwin != old_curwin)
        {

            diff_win_options(curwin, 1);
            diff_win_options(old_curwin, 1);

            if (newname != ((void *)0))
            {

                eap->arg = newname;
                ex_file(eap);



                do_cmdline_cmd((char_u *)":doau filetypedetect BufRead");

            }
        }
    }

theend:
    if (tmp_orig != ((void *)0))
        unlink((char *)(tmp_orig));
    vim_free(tmp_orig);
    if (tmp_new != ((void *)0))
        unlink((char *)(tmp_new));
    vim_free(tmp_new);
    vim_free(newname);
    vim_free(buf);

    vim_free(fullname);


    vim_free(browseFile);

}
# 902 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    void ex_diffsplit(eap)
    exarg_T *eap;
{
    win_T *old_curwin = curwin;


    need_mouse_correct = 1;

    if (win_split(0, 0) != 0)
    {

        eap->cmdidx = CMD_split;
        do_exedit(eap, old_curwin);

        if (curwin != old_curwin)
        {

            diff_win_options(curwin, 1);
            diff_win_options(old_curwin, 1);
        }
    }
}
# 930 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    void ex_diffthis(eap)
    exarg_T *eap;
{

    diff_win_options(curwin, 1);
}
# 941 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    void diff_win_options(wp, addbuf)
    win_T *wp;
    int addbuf;
{
    wp->w_onebuf_opt.wo_diff = 1;
    wp->w_onebuf_opt.wo_scb = 1;
    wp->w_onebuf_opt.wo_wrap = 0;

    {
        win_T *old_curwin = curwin;

        curwin = wp;
        curbuf = curwin->w_buffer;
        set_string_option_direct((char_u *)"fdm", -1, (char_u *)"diff",
                                                                   4);
        curwin = old_curwin;
        curbuf = curwin->w_buffer;
        wp->w_onebuf_opt.wo_fdc = 2;
        wp->w_onebuf_opt.wo_fen = 1;
        wp->w_onebuf_opt.wo_fdl = 0;
        foldUpdateAll(wp);
        changed_window_setting();
    }


    if (vim_strchr(p_sbo, 'h') == ((void *)0))
        do_cmdline_cmd((char_u *)"set sbo+=hor");


    if (addbuf)
        diff_buf_add(wp->w_buffer);
    redraw_win_later(wp, 40);
}
# 979 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    static void diff_read(idx_orig, idx_new, fname)
    int idx_orig;
    int idx_new;
    char_u *fname;
{
    FILE *fd;
    diff_T *dprev = ((void *)0);
    diff_T *dp = first_diff;
    diff_T *dn, *dpl;
    long f1, l1, f2, l2;
    char_u linebuf[50];
    int difftype;
    char_u *p;
    long off;
    int i;
    linenr_T lnum_orig, lnum_new;
    long count_orig, count_new;
    int notset = 1;

    fd = fopen((char *)fname, "r");
    if (fd == ((void *)0))
    {
        emsg((char_u *)(((char *)("E98: Cannot read diff output"))));
        return;
    }

    for (;;)
    {
        if (vim_fgets(linebuf, 50, fd))
            break;
        if (!(__ctype_b[(int) ((*linebuf))] & (unsigned short int) _ISdigit))
            continue;






        p = linebuf;
        f1 = getdigits(&p);
        if (*p == ',')
        {
            ++p;
            l1 = getdigits(&p);
        }
        else
            l1 = f1;
        if (*p != 'a' && *p != 'c' && *p != 'd')
            continue;
        difftype = *p++;
        f2 = getdigits(&p);
        if (*p == ',')
        {
            ++p;
            l2 = getdigits(&p);
        }
        else
            l2 = f2;
        if (l1 < f1 || l2 < f2)
            continue;

        if (difftype == 'a')
        {
            lnum_orig = f1 + 1;
            count_orig = 0;
        }
        else
        {
            lnum_orig = f1;
            count_orig = l1 - f1 + 1;
        }
        if (difftype == 'd')
        {
            lnum_new = f2 + 1;
            count_new = 0;
        }
        else
        {
            lnum_new = f2;
            count_new = l2 - f2 + 1;
        }



        while (dp != ((void *)0)
                && lnum_orig > dp->df_lnum[idx_orig] + dp->df_count[idx_orig])
        {
            if (notset)
                diff_copy_entry(dprev, dp, idx_orig, idx_new);
            dprev = dp;
            dp = dp->df_next;
            notset = 1;
        }

        if (dp != ((void *)0)
                && lnum_orig <= dp->df_lnum[idx_orig] + dp->df_count[idx_orig]
                && lnum_orig + count_orig >= dp->df_lnum[idx_orig])
        {


            for (dpl = dp; dpl->df_next != ((void *)0); dpl = dpl->df_next)
                if (lnum_orig + count_orig < dpl->df_next->df_lnum[idx_orig])
                    break;



            off = dp->df_lnum[idx_orig] - lnum_orig;
            if (off > 0)
            {
                for (i = idx_orig; i < idx_new; ++i)
                    if (diffbuf[i] != ((void *)0))
                        dp->df_lnum[i] -= off;
                dp->df_lnum[idx_new] = lnum_new;
                dp->df_count[idx_new] = count_new;
            }
            else if (notset)
            {

                dp->df_lnum[idx_new] = lnum_new + off;
                dp->df_count[idx_new] = count_new - off;
            }
            else

                dp->df_count[idx_new] += count_new - count_orig;



            off = (lnum_orig + count_orig)
                         - (dpl->df_lnum[idx_orig] + dpl->df_count[idx_orig]);
            if (off < 0)
            {


                if (notset)
                    dp->df_count[idx_new] += -off;
                off = 0;
            }
            for (i = idx_orig; i < idx_new + !notset; ++i)
                if (diffbuf[i] != ((void *)0))
                    dp->df_count[i] = dpl->df_lnum[i] + dpl->df_count[i]
                                                       - dp->df_lnum[i] + off;


            dn = dp->df_next;
            dp->df_next = dpl->df_next;
            while (dn != dp->df_next)
            {
                dpl = dn->df_next;
                vim_free(dn);
                dn = dpl;
            }
        }
        else
        {

            dp = diff_alloc_new(dprev, dp);
            if (dp == ((void *)0))
                return;

            dp->df_lnum[idx_orig] = lnum_orig;
            dp->df_count[idx_orig] = count_orig;
            dp->df_lnum[idx_new] = lnum_new;
            dp->df_count[idx_new] = count_new;




            for (i = idx_orig + 1; i < idx_new; ++i)
                if (diffbuf[i] != ((void *)0))
                    diff_copy_entry(dprev, dp, idx_orig, i);
        }
        notset = 0;
    }


    while (dp != ((void *)0))
    {
        if (notset)
            diff_copy_entry(dprev, dp, idx_orig, idx_new);
        dprev = dp;
        dp = dp->df_next;
        notset = 1;
    }

    fclose(fd);
}
# 1170 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    static void diff_copy_entry(dprev, dp, idx_orig, idx_new)
    diff_T *dprev;
    diff_T *dp;
    int idx_orig;
    int idx_new;
{
    long off;

    if (dprev == ((void *)0))
        off = 0;
    else
        off = (dprev->df_lnum[idx_orig] + dprev->df_count[idx_orig])
            - (dprev->df_lnum[idx_new] + dprev->df_count[idx_new]);
    dp->df_lnum[idx_new] = dp->df_lnum[idx_orig] - off;
    dp->df_count[idx_new] = dp->df_count[idx_orig];
}
# 1191 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    static void diff_clear()
{
    diff_T *p, *next_p;

    for (p = first_diff; p != ((void *)0); p = next_p)
    {
        next_p = p->df_next;
        vim_free(p);
    }
    first_diff = ((void *)0);
}
# 1213 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    int diff_check(wp, lnum)
    win_T *wp;
    linenr_T lnum;
{
    int idx;
    diff_T *dp;
    int maxcount;
    int i;
    buf_T *buf = wp->w_buffer;
    int cmp;

    if (diff_invalid)
        ex_diffupdate(((void *)0));

    if (first_diff == ((void *)0) || !wp->w_onebuf_opt.wo_diff)
        return 0;


    if (lnum < 1 || lnum > buf->b_ml.ml_line_count + 1)
        return 0;

    idx = diff_buf_idx(buf);
    if (idx == 4)
        return 0;



    if (hasFoldingWin(wp, lnum, ((void *)0), ((void *)0), 1, ((void *)0)))
        return 0;



    for (dp = first_diff; dp != ((void *)0); dp = dp->df_next)
        if (lnum <= dp->df_lnum[idx] + dp->df_count[idx])
            break;
    if (dp == ((void *)0) || lnum < dp->df_lnum[idx])
        return 0;

    if (lnum < dp->df_lnum[idx] + dp->df_count[idx])
    {
        int zero = 0;




        cmp = 0;
        for (i = 0; i < 4; ++i)
            if (i != idx && diffbuf[i] != ((void *)0))
            {
                if (dp->df_count[i] == 0)
                    zero = 1;
                else
                {
                    if (dp->df_count[i] != dp->df_count[idx])
                        return -1;
                    cmp = 1;
                }
            }
        if (cmp)
        {


            for (i = 0; i < 4; ++i)
                if (i != idx && diffbuf[i] != ((void *)0) && dp->df_count[i] != 0)
                    if (!diff_equal_entry(dp, idx, i))
                        return -1;
        }





        if (zero == 0)
            return 0;
        return -2;
    }


    if (!(diff_flags & 1))
        return 0;



    maxcount = 0;
    for (i = 0; i < 4; ++i)
        if (diffbuf[i] != ((void *)0) && dp->df_count[i] > maxcount)
            maxcount = dp->df_count[i];
    return maxcount - dp->df_count[idx];
}
# 1307 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    static int diff_equal_entry(dp, idx1, idx2)
    diff_T *dp;
    int idx1;
    int idx2;
{
    int i;
    char_u *line;
    int cmp;

    if (dp->df_count[idx1] != dp->df_count[idx2])
        return 0;
    if (diff_check_sanity(dp) == 0)
        return 0;
    for (i = 0; i < dp->df_count[idx1]; ++i)
    {
        line = vim_strsave(ml_get_buf(diffbuf[idx1],
                                               dp->df_lnum[idx1] + i, 0));
        if (line == ((void *)0))
            return 0;
        cmp = diff_cmp(line, ml_get_buf(diffbuf[idx2],
                                               dp->df_lnum[idx2] + i, 0));
        vim_free(line);
        if (cmp != 0)
            return 0;
    }
    return 1;
}
# 1340 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    static int diff_cmp(s1, s2)
    char_u *s1;
    char_u *s2;
{
    char_u *p1, *p2;




    if ((diff_flags & (2 | 4)) == 0)
        return strcmp((char *)(s1), (char *)(s2));
    if ((diff_flags & 2) && !(diff_flags & 4))
        return strcasecmp((char *)((s1)), (char *)((s2)));


    p1 = s1;
    p2 = s2;
    while (*p1 != '\000' && *p2 != '\000')
    {
        if (((*p1) == ' ' || (*p1) == '\t') && ((*p2) == ' ' || (*p2) == '\t'))
        {
            p1 = skipwhite(p1);
            p2 = skipwhite(p2);
        }
        else
        {
            {
                if (*p1 != *p2 && (!(diff_flags & 2)
                                     || tolower(*p1) != tolower(*p2)))
                    break;
                ++p1;
                ++p2;
            }
        }
    }


    p1 = skipwhite(p1);
    p2 = skipwhite(p2);
    if (*p1 != '\000' || *p2 != '\000')
        return 1;
    return 0;
}
# 1405 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    int diff_check_fill(wp, lnum)
    win_T *wp;
    linenr_T lnum;
{
    int n;


    if (!(diff_flags & 1))
        return 0;
    n = diff_check(wp, lnum);
    if (n <= 0)
        return 0;
    return n;
}
# 1425 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    void diff_set_topline(fromwin, towin)
    win_T *fromwin;
    win_T *towin;
{
    buf_T *buf = fromwin->w_buffer;
    linenr_T lnum = fromwin->w_topline;
    int idx;
    diff_T *dp;
    int i;

    idx = diff_buf_idx(buf);
    if (idx == 4)
        return;

    if (diff_invalid)
        ex_diffupdate(((void *)0));

    towin->w_topfill = 0;


    for (dp = first_diff; dp != ((void *)0); dp = dp->df_next)
        if (lnum <= dp->df_lnum[idx] + dp->df_count[idx])
            break;
    if (dp == ((void *)0))
    {


        towin->w_topline = towin->w_buffer->b_ml.ml_line_count
                                           - (buf->b_ml.ml_line_count - lnum);
    }
    else
    {

        i = diff_buf_idx(towin->w_buffer);
        if (i == 4)
            return;

        towin->w_topline = lnum + (dp->df_lnum[i] - dp->df_lnum[idx]);
        if (lnum >= dp->df_lnum[idx])
        {

            if (dp->df_count[i] == dp->df_count[idx])
                towin->w_topfill = fromwin->w_topfill;
            else if (dp->df_count[i] > dp->df_count[idx])
            {
                if (lnum == dp->df_lnum[idx] + dp->df_count[idx])
                    towin->w_topline = dp->df_lnum[i] + dp->df_count[i]
                                                         - fromwin->w_topfill;
            }
            else
            {
                if (towin->w_topline >= dp->df_lnum[i] + dp->df_count[i])
                {
                    if (diff_flags & 1)
                        towin->w_topfill = dp->df_lnum[idx]
                                                   + dp->df_count[idx] - lnum;
                    towin->w_topline = dp->df_lnum[i] + dp->df_count[i];
                }
            }
        }
    }


    towin->w_botfill = 0;
    if (towin->w_topline > towin->w_buffer->b_ml.ml_line_count)
    {
        towin->w_topline = towin->w_buffer->b_ml.ml_line_count;
        towin->w_botfill = 1;
    }
    if (towin->w_topline < 1)
    {
        towin->w_topline = 1;
        towin->w_topfill = 0;
    }


    invalidate_botline_win(towin);
    changed_line_abv_curs_win(towin);

    check_topfill(towin, 0);

    (void)hasFoldingWin(towin, towin->w_topline, &towin->w_topline,
                                                            ((void *)0), 1, ((void *)0));

}
# 1515 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    int diffopt_changed()
{
    char_u *p;
    int diff_context_new = 6;
    int diff_flags_new = 0;

    p = p_dip;
    while (*p != '\000')
    {
        if (strncmp((char *)(p), (char *)("filler"), (size_t)(6)) == 0)
        {
            p += 6;
            diff_flags_new |= 1;
        }
        else if (strncmp((char *)(p), (char *)("context:"), (size_t)(8)) == 0 && (__ctype_b[(int) ((p[8]))] & (unsigned short int) _ISdigit))
        {
            p += 8;
            diff_context_new = getdigits(&p);
        }
        else if (strncmp((char *)(p), (char *)("icase"), (size_t)(5)) == 0)
        {
            p += 5;
            diff_flags_new |= 2;
        }
        else if (strncmp((char *)(p), (char *)("iwhite"), (size_t)(6)) == 0)
        {
            p += 6;
            diff_flags_new |= 4;
        }
        if (*p != ',' && *p != '\000')
            return 0;
        if (*p == ',')
            ++p;
    }


    if (diff_flags != diff_flags_new)
        diff_invalid = 1;

    diff_flags = diff_flags_new;
    diff_context = diff_context_new;

    diff_redraw(1);



    check_scrollbind((linenr_T)0, 0L);

    return 1;
}
# 1571 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    int diff_find_change(wp, lnum, startp, endp)
    win_T *wp;
    linenr_T lnum;
    int *startp;
    int *endp;
{
    char_u *line_org;
    char_u *line_new;
    int i;
    int si, ei_org, ei_new;
    diff_T *dp;
    int idx;
    int off;
    int added = 1;


    line_org = vim_strsave(ml_get_buf(wp->w_buffer, lnum, 0));
    if (line_org == ((void *)0))
        return 0;

    idx = diff_buf_idx(wp->w_buffer);
    if (idx == 4)
        return 0;


    for (dp = first_diff; dp != ((void *)0); dp = dp->df_next)
        if (lnum <= dp->df_lnum[idx] + dp->df_count[idx])
            break;
    if (dp == ((void *)0) || diff_check_sanity(dp) == 0)
        return 0;

    off = lnum - dp->df_lnum[idx];

    for (i = 0; i < 4; ++i)
        if (diffbuf[i] != ((void *)0) && i != idx)
        {

            if (off >= dp->df_count[i])
                continue;
            added = 0;
            line_new = ml_get_buf(diffbuf[i], dp->df_lnum[i] + off, 0);


            for (si = 0; line_org[si] != '\000' && line_org[si] == line_new[si]; )
                ++si;
            if (*startp > si)
                *startp = si;


            if (line_org[si] != '\000' || line_new[si] != '\000')
            {
                ei_org = (int)strlen((char *)(line_org));
                ei_new = (int)strlen((char *)(line_new));
                while (ei_org >= *startp && ei_new >= *startp
                        && ei_org >= 0 && ei_new >= 0
                        && line_org[ei_org] == line_new[ei_new])
                {
                    --ei_org;
                    --ei_new;
                }
                if (*endp < ei_org)
                    *endp = ei_org;
            }
        }

    vim_free(line_org);
    return added;
}
# 1647 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    int diff_infold(wp, lnum)
    win_T *wp;
    linenr_T lnum;
{
    int i;
    int idx = -1;
    int other = 0;
    diff_T *dp;


    if (!wp->w_onebuf_opt.wo_diff)
        return 0;

    for (i = 0; i < 4; ++i)
    {
        if (diffbuf[i] == wp->w_buffer)
            idx = i;
        else if (diffbuf[i] != ((void *)0))
            other = 1;
    }


    if (idx == -1 || !other)
        return 0;

    if (diff_invalid)
        ex_diffupdate(((void *)0));


    if (first_diff == ((void *)0))
        return 1;

    for (dp = first_diff; dp != ((void *)0); dp = dp->df_next)
    {

        if (dp->df_lnum[idx] - diff_context > lnum)
            break;

        if (dp->df_lnum[idx] + dp->df_count[idx] + diff_context > lnum)
            return 0;
    }
    return 1;
}
# 1696 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    void nv_diffgetput(put)
    int put;
{
    exarg_T ea;

    ea.arg = (char_u *)"";
    if (put)
        ea.cmdidx = CMD_diffput;
    else
        ea.cmdidx = CMD_diffget;
    ea.addr_count = 0;
    ea.line1 = curwin->w_cursor.lnum;
    ea.line2 = curwin->w_cursor.lnum;
    ex_diffgetput(&ea);
}
# 1717 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    void ex_diffgetput(eap)
    exarg_T *eap;
{
    linenr_T lnum;
    int count;
    linenr_T off = 0;
    diff_T *dp;
    diff_T *dprev;
    diff_T *dfree;
    int idx_cur;
    int idx_other;
    int idx_from;
    int idx_to;
    int i;
    int added;
    char_u *p;
    aco_save_T aco;
    buf_T *buf;
    int start_skip, end_skip;
    int new_count;


    idx_cur = diff_buf_idx(curbuf);
    if (idx_cur == 4)
    {
        emsg((char_u *)(((char *)("E99: Current buffer is not in diff mode"))));
        return;
    }

    if (*eap->arg == '\000')
    {

        for (idx_other = 0; idx_other < 4; ++idx_other)
            if (diffbuf[idx_other] != curbuf && diffbuf[idx_other] != ((void *)0))
                break;
        if (idx_other == 4)
        {
            emsg((char_u *)(((char *)("E100: No other buffer in diff mode"))));
            return;
        }


        for (i = idx_other + 1; i < 4; ++i)
            if (diffbuf[i] != curbuf && diffbuf[i] != ((void *)0))
            {
                emsg((char_u *)(((char *)("E101: More than two buffers in diff mode, don't know which one to use"))));
                return;
            }
    }
    else
    {

        p = eap->arg + strlen((char *)(eap->arg));
        while (p > eap->arg && ((p[-1]) == ' ' || (p[-1]) == '\t'))
            --p;
        for (i = 0; (__ctype_b[(int) ((eap->arg[i]))] & (unsigned short int) _ISdigit) && eap->arg + i < p; ++i)
            ;
        if (eap->arg + i == p)
            i = atol((char *)eap->arg);
        else
        {
            i = buflist_findpat(eap->arg, p, 0, 1);
            if (i < 0)
                return;
        }
        buf = buflist_findnr(i);
        if (buf == ((void *)0))
        {
            emsg2((char_u *)(((char *)("E102: Can't find buffer \"%s\""))), (char_u *)(eap->arg));
            return;
        }
        idx_other = diff_buf_idx(buf);
        if (idx_other == 4)
        {
            emsg2((char_u *)(((char *)("E103: Buffer \"%s\" is not in diff mode"))), (char_u *)(eap->arg));
            return;
        }
    }

    diff_busy = 1;


    if (eap->addr_count == 0 && eap->line1 > 1)
        --eap->line1;

    if (eap->cmdidx == CMD_diffget)
    {
        idx_from = idx_other;
        idx_to = idx_cur;
    }
    else
    {
        idx_from = idx_cur;
        idx_to = idx_other;



        aucmd_prepbuf(&aco, diffbuf[idx_other]);
    }

    dprev = ((void *)0);
    for (dp = first_diff; dp != ((void *)0); )
    {
        if (dp->df_lnum[idx_cur] > eap->line2 + off)
            break;

        dfree = ((void *)0);
        lnum = dp->df_lnum[idx_to];
        count = dp->df_count[idx_to];
        if (dp->df_lnum[idx_cur] + dp->df_count[idx_cur] > eap->line1 + off
                && u_save(lnum - 1, lnum + count) != 0)
        {

            start_skip = 0;
            end_skip = 0;
            if (eap->addr_count > 0)
            {

                start_skip = eap->line1 + off - dp->df_lnum[idx_cur];
                if (start_skip > 0)
                {

                    if (start_skip > count)
                    {
                        lnum += count;
                        count = 0;
                    }
                    else
                    {
                        count -= start_skip;
                        lnum += start_skip;
                    }
                }
                else
                    start_skip = 0;

                end_skip = dp->df_lnum[idx_cur] + dp->df_count[idx_cur] - 1
                                                         - (eap->line2 + off);
                if (end_skip > 0)
                {

                    if (idx_cur == idx_from)
                    {
                        i = dp->df_count[idx_cur] - start_skip - end_skip;
                        if (count > i)
                            count = i;
                    }
                    else
                    {
                        count -= end_skip;
                        end_skip = dp->df_count[idx_from] - start_skip - count;
                        if (end_skip < 0)
                            end_skip = 0;
                    }
                }
                else
                    end_skip = 0;
            }

            added = 0;
            for (i = 0; i < count; ++i)
            {
                ml_delete(lnum, 0);
                --added;
            }
            for (i = 0; i < dp->df_count[idx_from] - start_skip - end_skip; ++i)
            {
                linenr_T nr;

                nr = dp->df_lnum[idx_from] + start_skip + i;
                if (nr > diffbuf[idx_from]->b_ml.ml_line_count)
                    break;
                p = vim_strsave(ml_get_buf(diffbuf[idx_from], nr, 0));
                if (p != ((void *)0))
                {
                    ml_append(lnum + i - 1, p, 0, 0);
                    vim_free(p);
                    ++added;
                }
            }
            new_count = dp->df_count[idx_to] + added;
            dp->df_count[idx_to] = new_count;

            if (start_skip == 0 && end_skip == 0)
            {


                for (i = 0; i < 4; ++i)
                    if (diffbuf[i] != ((void *)0) && i != idx_from && i != idx_to
                            && !diff_equal_entry(dp, idx_from, i))
                        break;
                if (i == 4)
                {

                    dfree = dp;
                    dp = dp->df_next;
                    if (dprev == ((void *)0))
                        first_diff = dp;
                    else
                        dprev->df_next = dp;
                }
            }


            if (added != 0)
            {
                mark_adjust(lnum, lnum + count - 1, (long)(0x7fffffffL), (long)added);
                if (curwin->w_cursor.lnum >= lnum)
                {


                    if (curwin->w_cursor.lnum >= lnum + count)
                        curwin->w_cursor.lnum += added;
                    else if (added < 0)
                        curwin->w_cursor.lnum = lnum;
                }
            }
            changed_lines(lnum, 0, lnum + count, (long)added);

            if (dfree != ((void *)0))
            {


                diff_fold_update(dfree, idx_to);

                vim_free(dfree);
            }
            else

                dp->df_count[idx_to] = new_count;


            if (idx_cur == idx_to)
                off += added;
        }


        if (dfree == ((void *)0))
        {
            dprev = dp;
            dp = dp->df_next;
        }
    }


    if (idx_other == idx_to)
    {



        if (KeyTyped)
            u_sync();
        aucmd_restbuf(&aco);
    }

    diff_busy = 0;



    check_cursor();
    changed_line_abv_curs();


    diff_redraw(0);
}
# 1990 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    static void diff_fold_update(dp, skip_idx)
    diff_T *dp;
    int skip_idx;
{
    int i;
    win_T *wp;

    for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
        for (i = 0; i < 4; ++i)
            if (diffbuf[i] == wp->w_buffer && i != skip_idx)
                foldUpdate(wp, dp->df_lnum[i],
                                            dp->df_lnum[i] + dp->df_count[i]);
}
# 2009 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    int diff_mode_buf(buf)
    buf_T *buf;
{
    return diff_buf_idx(buf) != 4;
}
# 2020 "/h/27/yijun/software/vim62/src/diff.cpp.c"
    int diff_move_to(dir, count)
    int dir;
    long count;
{
    int idx;
    linenr_T lnum = curwin->w_cursor.lnum;
    diff_T *dp;

    idx = diff_buf_idx(curbuf);
    if (idx == 4 || first_diff == ((void *)0))
        return 0;

    if (diff_invalid)
        ex_diffupdate(((void *)0));

    if (first_diff == ((void *)0))
        return 0;

    while (--count >= 0)
    {

        if (dir == (-1) && lnum <= first_diff->df_lnum[idx])
            break;

        for (dp = first_diff; ; dp = dp->df_next)
        {
            if (dp == ((void *)0))
                break;
            if ((dir == 1 && lnum < dp->df_lnum[idx])
                    || (dir == (-1)
                        && (dp->df_next == ((void *)0)
                            || lnum <= dp->df_next->df_lnum[idx])))
            {
                lnum = dp->df_lnum[idx];
                break;
            }
        }
    }


    if (lnum > curbuf->b_ml.ml_line_count)
        lnum = curbuf->b_ml.ml_line_count;


    if (lnum == curwin->w_cursor.lnum)
        return 0;

    setpcmark();
    curwin->w_cursor.lnum = lnum;
    curwin->w_cursor.col = 0;

    return 1;
}
