#include "controller.h"
# 18 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static int linelen (int *has_tab);
# 20 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static void do_filter (linenr_T line1, linenr_T line2, exarg_T *eap, char_u *cmd, int do_in, int do_out);
# 22 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static char_u *viminfo_filename (char_u *);
# 23 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static void do_viminfo (FILE *fp_in, FILE *fp_out, int want_info, int want_marks, int force_read);
# 24 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static int viminfo_encoding (vir_T *virp);
# 25 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static int read_viminfo_up_to_marks (vir_T *virp, int forceit, int writing);
# 28 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static int check_overwrite (exarg_T *eap, buf_T *buf, char_u *fname, char_u *ffname, int other);
# 29 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static int check_readonly (int *forceit, buf_T *buf);
# 31 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static void delbuf_msg (char_u *name);
# 33 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static int do_sub_msg (void);
# 38 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static int         help_compare (const void *s1, const void *s2);
# 45 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void do_ascii(eap)
    exarg_T *eap;
{
    int c;
    char buf1[20];
    char buf2[20];
    char_u buf3[7];
        c = gchar_cursor();
    if (c == '\000')
    {
        msg((char_u *)("NUL"));
        return;
    }





    {
        if (c == '\012')
            c = '\000';
        if (vim_isprintc_strict(c) && (c < ' '

                    || c > '~'

                               ))
        {
            transchar_nonprint(buf3, c);
            sprintf(buf1, "  <%s>", (char *)buf3);
        }
        else
            buf1[0] = '\000';

        if (c >= 0x80)
            sprintf(buf2, "  <M-%s>", transchar(c & 0x7f));
        else

            buf2[0] = '\000';
        sprintf((char *)IObuff, ((char *)("<%s>%s%s  %d,  Hex %02x,  Octal %03o")),
                transchar(c), buf1, buf2, c, c, c);





    }
    msg(IObuff);
}
# 137 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_align(eap)
    exarg_T *eap;
{
    pos_T save_curpos;
    int len;
    int indent = 0;
    int new_indent;
    int has_tab;
    int width;
    width = atoi((char *)eap->arg);
    save_curpos = curwin->w_cursor;
    if (eap->cmdidx == CMD_left)
    {
        if (width >= 0)
            indent = width;
    }
    else
    {





        if (width <= 0)
            width = curbuf->b_p_tw;
        if (width == 0 && curbuf->b_p_wm > 0)
            width = (curwin->w_width) - curbuf->b_p_wm;
        if (width <= 0)
            width = 80;
    }

    if (u_save((linenr_T)(eap->line1 - 1), (linenr_T)(eap->line2 + 1)) == 0)
        return;

    for (curwin->w_cursor.lnum = eap->line1;
                 curwin->w_cursor.lnum <= eap->line2; ++curwin->w_cursor.lnum)
    {
        if (eap->cmdidx == CMD_left)
            new_indent = indent;
        else
        {
            len = linelen(eap->cmdidx == CMD_right ? &has_tab
                                                   : ((void *)0)) - get_indent();

            if (len <= 0)
                continue;

            if (eap->cmdidx == CMD_center)
                new_indent = (width - len) / 2;
            else
            {
                new_indent = width - len;





                if (has_tab)
                    while (new_indent > 0)
                    {
                        (void)set_indent(new_indent, 0);
                        if (linelen(((void *)0)) <= width)
                        {




                            do
                                (void)set_indent(++new_indent, 0);
                            while (linelen(((void *)0)) <= width);
                            --new_indent;
                            break;
                        }
                        --new_indent;
                    }
            }
        }
        if (new_indent < 0)
            new_indent = 0;
        (void)set_indent(new_indent, 0);
    }
    changed_lines(eap->line1, 0, eap->line2 + 1, 0L);
    curwin->w_cursor = save_curpos;
    beginline(1 | 4);
}
# 239 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    static int linelen(has_tab)
    int *has_tab;
{
    char_u *line;
    char_u *first;
    char_u *last;
    int save;
    int len;


    line = ml_get_curline();
    first = skipwhite(line);


    for (last = first + strlen((char *)(first));
                                last > first && ((last[-1]) == ' ' || (last[-1]) == '\t'); --last)
        ;
    save = *last;
    *last = '\000';
    len = linetabsize(line);
    if (has_tab != ((void *)0))
        *has_tab = (vim_strrchr(first, '\011') != ((void *)0));
    *last = save;

    return len;
}
# 270 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_retab(eap)
    exarg_T *eap;
{
    linenr_T lnum;
    int got_tab = 0;
    long num_spaces = 0;
    long num_tabs;
    long len;
    long col;
    long vcol;
    long start_col = 0;
    long start_vcol = 0;
    int temp;
    long old_len;
    char_u *ptr;
    char_u *new_line = (char_u *)1;
    int did_undo;
    int new_ts;
    int save_list;
    linenr_T first_line = 0;
    linenr_T last_line = 0;

    save_list = curwin->w_onebuf_opt.wo_list;
    curwin->w_onebuf_opt.wo_list = 0;

    new_ts = getdigits(&(eap->arg));
    if (new_ts < 0)
    {
        emsg((char_u *)(((char *)(e_positive))));
        return;
    }
    if (new_ts == 0)
        new_ts = curbuf->b_p_ts;
    for (lnum = eap->line1; !got_int && lnum <= eap->line2; ++lnum)
    {
        ptr = ml_get(lnum);
        col = 0;
        vcol = 0;
        did_undo = 0;
        for (;;)
        {
            if (((ptr[col]) == ' ' || (ptr[col]) == '\t'))
            {
                if (!got_tab && num_spaces == 0)
                {

                    start_vcol = vcol;
                    start_col = col;
                }
                if (ptr[col] == ' ')
                    num_spaces++;
                else
                    got_tab = 1;
            }
            else
            {
                if (got_tab || (eap->forceit && num_spaces > 1))
                {



                    len = num_spaces = vcol - start_vcol;
                    num_tabs = 0;
                    if (!curbuf->b_p_et)
                    {
                        temp = new_ts - (start_vcol % new_ts);
                        if (num_spaces >= temp)
                        {
                            num_spaces -= temp;
                            num_tabs++;
                        }
                        num_tabs += num_spaces / new_ts;
                        num_spaces -= (num_spaces / new_ts) * new_ts;
                    }
                    if (curbuf->b_p_et || got_tab ||
                                        (num_spaces + num_tabs < len))
                    {
                        if (did_undo == 0)
                        {
                            did_undo = 1;
                            if (u_save((linenr_T)(lnum - 1),
                                                (linenr_T)(lnum + 1)) == 0)
                            {
                                new_line = ((void *)0);
                                break;
                            }
                        }


                        len = num_spaces + num_tabs;
                        old_len = (long)strlen((char *)(ptr));
                        new_line = lalloc(old_len - col + start_col + len + 1,
                                                                        1);
                        if (new_line == ((void *)0))
                            break;
                        if (start_col > 0)
                            memmove((char *)(new_line), (char *)(ptr), (size_t)start_col);
                        memmove((char *)(new_line + start_col + len), (char *)(ptr + col), (size_t)(old_len - col + 1));

                        ptr = new_line + start_col;
                        for (col = 0; col < len; col++)
                            ptr[col] = (col < num_tabs) ? '\t' : ' ';
                        ml_replace(lnum, new_line, 0);
                        if (first_line == 0)
                            first_line = lnum;
                        last_line = lnum;
                        ptr = new_line;
                        col = start_col + len;
                    }
                }
                got_tab = 0;
                num_spaces = 0;
            }
            if (ptr[col] == '\000')
                break;
            vcol += chartabsize(ptr + col, (colnr_T)vcol);





                ++col;
        }
        if (new_line == ((void *)0))
            break;
        line_breakcheck();
    }
    if (got_int)
        emsg((char_u *)(((char *)(e_interr))));

    if (curbuf->b_p_ts != new_ts)
        redraw_curbuf_later(40);
    if (first_line != 0)
        changed_lines(first_line, 0, last_line + 1, 0L);

    curwin->w_onebuf_opt.wo_list = save_list;

    curbuf->b_p_ts = new_ts;
    coladvance(curwin->w_curswant);

    u_clearline();
}
# 420 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    int do_move(line1, line2, dest)
    linenr_T line1;
    linenr_T line2;
    linenr_T dest;
{
    char_u *str;
    linenr_T l;
    linenr_T extra;
    linenr_T num_lines;
    linenr_T last_line;

    if (dest >= line1 && dest < line2)
    {
        emsg((char_u *)(((char *)("E134: Move lines into themselves"))));
        return 0;
    }

    num_lines = line2 - line1 + 1;





    if (u_save(dest, dest + 1) == 0)
        return 0;
    for (extra = 0, l = line1; l <= line2; l++)
    {
        str = vim_strsave(ml_get(l + extra));
        if (str != ((void *)0))
        {
            ml_append(dest + l - line1, str, (colnr_T)0, 0);
            vim_free(str);
            if (dest < line1)
                extra++;
        }
    }
    last_line = curbuf->b_ml.ml_line_count;
    mark_adjust(line1, line2, last_line - line2, 0L);
    if (dest >= line2)
    {
        mark_adjust(line2 + 1, dest, -num_lines, 0L);
        curbuf->b_op_start.lnum = dest - num_lines + 1;
        curbuf->b_op_end.lnum = dest;
    }
    else
    {
        mark_adjust(dest + 1, line1 - 1, num_lines, 0L);
        curbuf->b_op_start.lnum = dest + 1;
        curbuf->b_op_end.lnum = dest + num_lines;
    }
    curbuf->b_op_start.col = curbuf->b_op_end.col = 0;
    mark_adjust(last_line - num_lines + 1, last_line,
                                             -(last_line - dest - extra), 0L);




    if (u_save(line1 + extra - 1, line2 + extra + 1) == 0)
        return 0;

    for (l = line1; l <= line2; l++)
        ml_delete(line1 + extra, 1);

    if (!global_busy && num_lines > p_report)
    {
        if (num_lines == 1)
            msg((char_u *)(((char *)("1 line moved"))));
        else
            smsg((char_u *)((char *)("%ld lines moved")), num_lines);
    }




    if (dest >= line1)
        curwin->w_cursor.lnum = dest;
    else
        curwin->w_cursor.lnum = dest + (line2 - line1) + 1;

    if (line1 < dest)
        changed_lines(line1, 0, dest + num_lines + 1, 0L);
    else
        changed_lines(dest + 1, 0, line1 + num_lines, 0L);

    return 1;
}
# 527 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_copy(line1, line2, n)
    linenr_T line1;
    linenr_T line2;
    linenr_T n;
{
    linenr_T count;
    char_u *p;

    count = line2 - line1 + 1;
    curbuf->b_op_start.lnum = n + 1;
    curbuf->b_op_end.lnum = n + count;
    curbuf->b_op_start.col = curbuf->b_op_end.col = 0;
    if (u_save(n, n + 1) == 0)
        return;

    curwin->w_cursor.lnum = n;
    while (line1 <= line2)
    {


        p = vim_strsave(ml_get(line1));
        if (p != ((void *)0))
        {
            ml_append(curwin->w_cursor.lnum, p, (colnr_T)0, 0);
            vim_free(p);
        }

        if (line1 == n)
            line1 = curwin->w_cursor.lnum;
        ++line1;
        if (curwin->w_cursor.lnum < line1)
            ++line1;
        if (curwin->w_cursor.lnum < line2)
            ++line2;
        ++curwin->w_cursor.lnum;
    }

    appended_lines_mark(n, count);

    msgmore((long)count);
}
# 590 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void do_bang(addr_count, eap, forceit, do_in, do_out)
    int addr_count;
    exarg_T *eap;
    int forceit;
    int do_in, do_out;
{
    char_u *arg = eap->arg;
    linenr_T line1 = eap->line1;
    linenr_T line2 = eap->line2;
    static char_u *prevcmd = ((void *)0);
    char_u *newcmd = ((void *)0);
    int free_newcmd = 0;
    int ins_prevcmd;
    char_u *t;
    char_u *p;
    char_u *trailarg;
    int len;
    int scroll_save = msg_scroll;






    if (check_restricted() || check_secure())
        return;

    if (addr_count == 0)
    {
        msg_scroll = 0;
        autowrite_all();
        msg_scroll = scroll_save;
    }





    ins_prevcmd = forceit;
    trailarg = arg;
    do
    {
        len = (int)strlen((char *)(trailarg)) + 1;
        if (newcmd != ((void *)0))
            len += (int)strlen((char *)(newcmd));
        if (ins_prevcmd)
        {
            if (prevcmd == ((void *)0))
            {
                emsg((char_u *)(((char *)(e_noprev))));
                vim_free(newcmd);
                return;
            }
            len += (int)strlen((char *)(prevcmd));
        }
        if ((t = alloc(len)) == ((void *)0))
        {
            vim_free(newcmd);
            return;
        }
        *t = '\000';
        if (newcmd != ((void *)0))
            strcat((char *)(t), (char *)(newcmd));
        if (ins_prevcmd)
            strcat((char *)(t), (char *)(prevcmd));
        p = t + strlen((char *)(t));
        strcat((char *)(t), (char *)(trailarg));
        vim_free(newcmd);
        newcmd = t;





        trailarg = ((void *)0);
        while (*p)
        {
            if (*p == '!'



                                        )
            {
                if (p > newcmd && p[-1] == '\\')
                    memmove((char *)(p - 1), (char *)(p), (size_t)(strlen((char *)(p)) + 1));
                else
                {
                    trailarg = p;
                    *trailarg++ = '\000';
                    ins_prevcmd = 1;
                    break;
                }
            }
            ++p;
        }
    } while (trailarg != ((void *)0));

    vim_free(prevcmd);
    prevcmd = newcmd;

    if (bangredo)
    {
        AppendToRedobuffLit(prevcmd);
        AppendToRedobuff((char_u *)"\n");
        bangredo = 0;
    }



    if (*p_shq != '\000')
    {
        newcmd = alloc((unsigned)(strlen((char *)(prevcmd)) + 2 * strlen((char *)(p_shq)) + 1));
        if (newcmd == ((void *)0))
            return;
        strcpy((char *)(newcmd), (char *)(p_shq));
        strcat((char *)(newcmd), (char *)(prevcmd));
        strcat((char *)(newcmd), (char *)(p_shq));
        free_newcmd = 1;
    }
    if (addr_count == 0)
    {

        msg_start();
        msg_putchar(':');
        msg_putchar('!');
        msg_outtrans(newcmd);
        msg_clr_eos();
        windgoto(msg_row, msg_col);

        do_shell(newcmd, 0);
    }
    else


        do_filter(line1, line2, eap, newcmd, do_in, do_out);
    if (free_newcmd)
        vim_free(newcmd);
}
# 743 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    static void do_filter(line1, line2, eap, cmd, do_in, do_out)
    linenr_T line1, line2;
    exarg_T *eap;
    char_u *cmd;
    int do_in, do_out;
{
    char_u *itmp = ((void *)0);
    char_u *otmp = ((void *)0);
    linenr_T linecount;
    pos_T cursor_save;
    char_u *cmd_buf;

    buf_T *old_curbuf = curbuf;


    if (*cmd == '\000')
        return;
    cursor_save = curwin->w_cursor;
    linecount = line2 - line1 + 1;
    curwin->w_cursor.lnum = line1;
    curwin->w_cursor.col = 0;
    changed_line_abv_curs();
    invalidate_botline();
    if ((do_in && (itmp = vim_tempname('i')) == ((void *)0))
            || (do_out && (otmp = vim_tempname('o')) == ((void *)0)))
    {
        emsg((char_u *)(((char *)(e_notmp))));
        goto filterend;
    }





    ++no_wait_return;
    if (do_in && buf_write(curbuf, itmp, ((void *)0), line1, line2, eap,
                                           0, 0, 0, 1) == 0)
    {
        msg_putchar('\n');
        --no_wait_return;

        if (!aborting())

            (void)emsg2((char_u *)(((char *)(e_notcreate))), (char_u *)(itmp));
        goto filterend;
    }

    if (curbuf != old_curbuf)
        goto filterend;


    if (!do_out)
        msg_putchar('\n');

    cmd_buf = make_filter_cmd(cmd, itmp, otmp);
    if (cmd_buf == ((void *)0))
        goto filterend;

    windgoto((int)Rows - 1, 0);
    cursor_on();
    if (!do_out || strcmp((char *)(p_srr), (char *)(">")) == 0 || !do_in)
        redraw_later_clear();
    if (call_shell(cmd_buf, 1 | 4
                                                | (do_out ? 8 : 0)))
    {
        redraw_later_clear();
        wait_return(0);
    }
    vim_free(cmd_buf);

    did_check_timestamps = 0;
    need_check_timestamps = 1;




    ui_breakcheck();
    got_int = 0;

    if (do_out)
    {
        if (u_save((linenr_T)(line2), (linenr_T)(line2 + 1)) == 0)
            goto error;
        redraw_curbuf_later(10);
        if (readfile(otmp, ((void *)0), line2, (linenr_T)0, (linenr_T)(0x7fffffffL), eap,
                                                         0x02) == 0)
        {

            if (!aborting())

            {
                msg_putchar('\n');
                emsg2((char_u *)(((char *)(e_notread))), (char_u *)(otmp));
            }
            goto error;
        }

        if (curbuf != old_curbuf)
            goto filterend;


        if (do_in)
        {




            curwin->w_cursor.lnum = line1;
            del_lines(linecount, 1);
            curbuf->b_op_start.lnum -= linecount;
            curbuf->b_op_end.lnum -= linecount;
            write_lnum_adjust(-linecount);

        }
        else
        {



            curwin->w_cursor.lnum = curbuf->b_op_end.lnum;
            linecount = curbuf->b_op_end.lnum - curbuf->b_op_start.lnum + 1;
        }
        beginline(1 | 4);
        --no_wait_return;

        if (linecount > p_report)
        {
            if (do_in)
            {
                sprintf((char *)msg_buf, ((char *)("%ld lines filtered")),
                                                             (long)linecount);
                if (msg(msg_buf) && !msg_scroll)
                {

                    set_keep_msg(msg_buf);
                    keep_msg_attr = 0;
                }
            }
            else
                msgmore((long)linecount);
        }
    }
    else
    {
error:

        curwin->w_cursor = cursor_save;
        --no_wait_return;
        wait_return(0);
    }

filterend:


    if (curbuf != old_curbuf)
    {
        --no_wait_return;
        emsg((char_u *)(((char *)("E135: *Filter* Autocommands must not change current buffer"))));
    }

    if (itmp != ((void *)0))
        unlink((char *)(itmp));
    if (otmp != ((void *)0))
        unlink((char *)(otmp));
    vim_free(itmp);
    vim_free(otmp);
}
# 953 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void do_shell(cmd, flags)
    char_u *cmd;
    int flags;
{
    buf_T *buf;

    int save_nwr;
    if (check_restricted() || check_secure())
    {
        msg_end();
        return;
    }
    msg_putchar('\r');

    if (!autocmd_busy)

    {



            stoptermcap();
    }



        msg_putchar('\n');


    if (p_warn

                && !autocmd_busy

                && msg_silent == 0)
        for (buf = firstbuf; buf; buf = buf->b_next)
            if (bufIsChanged(buf))
            {




                msg_puts((char_u *)(((char *)("[No write since last change]\n"))));




                break;
            }



    if (!swapping_screen())
        windgoto(msg_row, msg_col);
    cursor_on();
    (void)call_shell(cmd, 4 | flags);
    did_check_timestamps = 0;
    need_check_timestamps = 1;





    if (!swapping_screen())
    {
        msg_row = Rows - 1;
        msg_col = 0;
    }


    if (autocmd_busy)
    {
        if (msg_silent == 0)
            redraw_later_clear();
    }
    else

    {







        if (cmd == ((void *)0)



           )
        {
            if (msg_silent == 0)
                redraw_later_clear();
            need_wait_return = 0;
        }
        else
        {




            save_nwr = no_wait_return;
            if (swapping_screen())
                no_wait_return = 0;



            wait_return(msg_silent == 0);

            no_wait_return = save_nwr;
        }





            starttermcap();
    }


    display_errors();
}
# 1132 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    char_u * make_filter_cmd(cmd, itmp, otmp)
    char_u *cmd;
    char_u *itmp;
    char_u *otmp;
{
    char_u *buf;
    long_u len;

    len = (long_u)strlen((char *)(cmd)) + 3;
    if (itmp != ((void *)0))
        len += (long_u)strlen((char *)(itmp)) + 9;
    if (otmp != ((void *)0))
        len += (long_u)strlen((char *)(otmp)) + (long_u)strlen((char *)(p_srr)) + 2;
    buf = lalloc(len, 1);
    if (buf == ((void *)0))
        return ((void *)0);





    sprintf((char *)buf, "(%s)", (char *)cmd);
    if (itmp != ((void *)0))
    {
        strcat((char *)(buf), (char *)(" < "));
        strcat((char *)(buf), (char *)(itmp));
    }
    if (otmp != ((void *)0))
        append_redir(buf, p_srr, otmp);

    return buf;
}
# 1212 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void append_redir(buf, opt, fname)
    char_u *buf;
    char_u *opt;
    char_u *fname;
{
    char_u *p;

    buf += strlen((char *)(buf));

    for (p = opt; (p = vim_strchr(p, '%')) != ((void *)0); ++p)
        if (p[1] == 's')
            break;
    if (p != ((void *)0))
    {
        *buf = ' ';
        sprintf((char *)buf + 1, (char *)opt, (char *)fname);
    }
    else
        sprintf((char *)buf,


                opt != p_sp ? " %s%s" :

                " %s %s",







                (char *)opt, (char *)fname);
}
# 1248 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static int no_viminfo (void);
# 1249 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static int viminfo_errcnt;
# 1252 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    static int no_viminfo()
{

    return (use_viminfo != ((void *)0) && strcmp((char *)(use_viminfo), (char *)("NONE")) == 0);
}
# 1263 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    int viminfo_error(errnum, message, line)
    char *errnum;
    char *message;
    char_u *line;
{
    sprintf((char *)IObuff, ((char *)("%sviminfo: %s in line: ")), errnum, message);
    strncat((char *)(IObuff), (char *)(line), (size_t)((1024+1) - strlen((char *)(IObuff))));
    emsg(IObuff);
    if (++viminfo_errcnt >= 10)
    {
        emsg((char_u *)(((char *)("E136: viminfo: Too many errors, skipping rest of file"))));
        return 1;
    }
    return 0;
}
# 1284 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    int read_viminfo(file, want_info, want_marks, forceit)
    char_u *file;
    int want_info;
    int want_marks;
    int forceit;
{
    FILE *fp;
    char_u *fname;

    if (no_viminfo())
        return 0;

    fname = viminfo_filename(file);
    if (fname == ((void *)0))
        return 0;
    fp = fopen(((char *)fname), ("r"));

    if (p_verbose > 0)
    {
        char_u *s;

        s = fname;
        if (strlen((char *)(fname)) > (1024+1) - 100)
            s = fname + strlen((char *)(fname)) - ((1024+1) - 100);
        smsg((char_u *)((char *)("Reading viminfo file \"%s\"%s%s%s")), s,
                    want_info ? ((char *)(" info")) : "",
                    want_marks ? ((char *)(" marks")) : "",
                    fp == ((void *)0) ? ((char *)(" FAILED")) : "");
    }

    vim_free(fname);
    if (fp == ((void *)0))
        return 0;

    viminfo_errcnt = 0;
    do_viminfo(fp, ((void *)0), want_info, want_marks, forceit);

    fclose(fp);

    return 1;
}
# 1334 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void write_viminfo(file, forceit)
    char_u *file;
    int forceit;
{
    char_u *fname;
    FILE *fp_in = ((void *)0);
    FILE *fp_out = ((void *)0);
    char_u *tempname = ((void *)0);
    struct stat st_new;
    char_u *wp;

    mode_t umask_save;


    int shortname = 0;
    struct stat st_old;


    if (no_viminfo())
        return;

    fname = viminfo_filename(file);
    if (fname == ((void *)0))
        return;

    fp_in = fopen(((char *)fname), ("r"));
    if (fp_in == ((void *)0))
    {

        if (stat(((char *)fname), (&st_new)) == 0)
            goto end;





        umask_save = umask(077);

        fp_out = fopen(((char *)fname), ("w"));

        (void)umask(umask_save);

    }
    else
    {
        st_old.st_dev = st_old.st_ino = 0;
        st_old.st_mode = 0600;
        if (stat(((char *)fname), (&st_old)) == 0 && getuid() &&
                !(st_old.st_uid == getuid()
                        ? (st_old.st_mode & 0200)
                        : (st_old.st_gid == getgid()
                                ? (st_old.st_mode & 0020)
                                : (st_old.st_mode & 0002))))
        {
            int tt;


            tt = msg_didany;
            emsg2((char_u *)(((char *)("E137: Viminfo file is not writable: %s"))), (char_u *)(fname));
            msg_didany = tt;
            goto end;
        }







        for (;;)
        {
            tempname = buf_modname(

                                    shortname,
                                    fname,






                                    (char_u *)".tmp",


                                    0);
            if (tempname == ((void *)0))
                break;





            if (stat(((char *)tempname), (&st_new)) == 0)
            {







                if (!shortname && st_new.st_dev == st_old.st_dev &&
                        st_new.st_ino == st_old.st_ino)
                {
                    vim_free(tempname);
                    tempname = ((void *)0);
                    shortname = 1;
                    continue;
                }







                wp = tempname + strlen((char *)(tempname)) - 5;
                if (wp < gettail(tempname))
                    wp = gettail(tempname);
                for (*wp = 'z'; stat(((char *)tempname), (&st_new)) == 0;
                                                                    --*wp)
                {




                    if (*wp == 'a')
                    {
                        vim_free(tempname);
                        tempname = ((void *)0);
                        break;
                    }
                }
            }
            break;
        }

        if (tempname != ((void *)0))
        {
            fp_out = fopen(((char *)tempname), ("w"));





            if (fp_out == ((void *)0))
            {
                vim_free(tempname);
                if ((tempname = vim_tempname('o')) != ((void *)0))
                    fp_out = fopen(((char *)tempname), ("w"));
            }





            if (fp_out != ((void *)0))
            {
                (void)mch_setperm(tempname,
                                  (long)((st_old.st_mode & 0777) | 0600));

                (void)chown((char *)tempname, st_old.st_uid, st_old.st_gid);
            }

        }
    }




    if (fp_out == ((void *)0))
    {
        emsg2((char_u *)(((char *)("E138: Can't write viminfo file %s!"))), (char_u *)(fp_in == ((void *)0) ? fname : tempname));

        if (fp_in != ((void *)0))
            fclose(fp_in);
        goto end;
    }

    if (p_verbose > 0)
        msg_str((char_u *)((char *)("Writing viminfo file \"%s\"")), fname);

    viminfo_errcnt = 0;
    do_viminfo(fp_in, fp_out, !forceit, !forceit, 0);

    fclose(fp_out);
    if (fp_in != ((void *)0))
    {
        fclose(fp_in);



        if (viminfo_errcnt || vim_rename(tempname, fname) == -1)
            unlink((char *)(tempname));
    }
end:
    vim_free(fname);
    vim_free(tempname);
}
# 1565 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    static char_u * viminfo_filename(file)
    char_u *file;
{
    if (file == ((void *)0) || *file == '\000')
    {
        if (use_viminfo != ((void *)0))
            file = use_viminfo;
        else if ((file = find_viminfo_parameter('n')) == ((void *)0) || *file == '\000')
        {
                file = (char_u *)"$HOME/.viminfo";
        }
        expand_env(file, NameBuff, 1024);
        file = NameBuff;
    }
    return vim_strsave(file);
}
# 1603 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    static void do_viminfo(fp_in, fp_out, want_info, want_marks, force_read)
    FILE *fp_in;
    FILE *fp_out;
    int want_info;
    int want_marks;
    int force_read;
{
    int count = 0;
    int eof = 0;
    vir_T vir;

    if ((vir.vir_line = alloc(512)) == ((void *)0))
        return;
    vir.vir_fd = fp_in;




    if (fp_in != ((void *)0))
    {
        if (want_info)
            eof = read_viminfo_up_to_marks(&vir, force_read, fp_out != ((void *)0));
        else

            while (!(eof = viminfo_readline(&vir))
                    && vir.vir_line[0] != '>')
                ;
    }
    if (fp_out != ((void *)0))
    {

        fprintf(fp_out, ((char *)("# This viminfo file was generated by Vim %s.\n")),
                                                          "6.2");
        fprintf(fp_out, ((char *)("# You may edit it if you're careful!\n\n")));




        write_viminfo_search_pattern(fp_out);
        write_viminfo_sub_string(fp_out);

        write_viminfo_history(fp_out);

        write_viminfo_registers(fp_out);

        write_viminfo_varlist(fp_out);

        write_viminfo_filemarks(fp_out);
        write_viminfo_bufferlist(fp_out);
        count = write_viminfo_marks(fp_out);
    }
    if (fp_in != ((void *)0) && want_marks)
        copy_viminfo_marks(&vir, fp_out, count, eof);

    vim_free(vir.vir_line);




}
# 1670 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    static int read_viminfo_up_to_marks(virp, forceit, writing)
    vir_T *virp;
    int forceit;
    int writing;
{
    int eof;
    buf_T *buf;


    prepare_viminfo_history(forceit ? 9999 : 0);

    eof = viminfo_readline(virp);
    while (!eof && virp->vir_line[0] != '>')
    {
        switch (virp->vir_line[0])
        {

            case '+':
            case '|':
            case '^':
            case '<':

            case '\000':
            case '\r':
            case '\n':
            case '#':
                eof = viminfo_readline(virp);
                break;
            case '*':
                eof = viminfo_encoding(virp);
                break;
            case '!':

                eof = read_viminfo_varlist(virp, writing);



                break;
            case '%':
                eof = read_viminfo_bufferlist(virp, writing);
                break;
            case '"':
                eof = read_viminfo_register(virp, forceit);
                break;
            case '/':
            case '&':
            case '~':
                eof = read_viminfo_search_pattern(virp, forceit);
                break;
            case '$':
                eof = read_viminfo_sub_string(virp, forceit);
                break;
            case ':':
            case '?':
            case '=':
            case '@':

                eof = read_viminfo_history(virp);



                break;
            case '-':
            case '\'':
                eof = read_viminfo_filemark(virp, forceit);
                break;
            default:
                if (viminfo_error("E575: ", ((char *)("Illegal starting char")),
                            virp->vir_line))
                    eof = 1;
                else
                    eof = viminfo_readline(virp);
                break;
        }
    }



    finish_viminfo_history();



    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
        fmarks_check_names(buf);

    return eof;
}
# 1764 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    static int viminfo_encoding(virp)
    vir_T *virp;
{
    return viminfo_readline(virp);
}
# 1794 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    int viminfo_readline(virp)
    vir_T *virp;
{
    return vim_fgets(virp->vir_line, 512, virp->vir_fd);
}
# 1812 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    char_u * viminfo_readstring(virp, off, convert)
    vir_T *virp;
    int off;
    int convert;
{
    char_u *retval;
    char_u *s, *d;
    long len;

    if (virp->vir_line[off] == 22 && (__ctype_b[(int) ((virp->vir_line[off + 1]))] & (unsigned short int) _ISdigit))
    {
        len = atol((char *)virp->vir_line + off + 1);
        retval = lalloc(len, 1);
        if (retval == ((void *)0))
        {

            (void)vim_fgets(virp->vir_line, 10, virp->vir_fd);
            return ((void *)0);
        }
        (void)vim_fgets(retval, (int)len, virp->vir_fd);
        s = retval + 1;
    }
    else
    {
        retval = vim_strsave(virp->vir_line + off);
        if (retval == ((void *)0))
            return ((void *)0);
        s = retval;
    }


    d = retval;
    while (*s != '\000' && *s != '\n')
    {
        if (s[0] == 22 && s[1] != '\000')
        {
            if (s[1] == 'n')
                *d++ = '\n';
            else
                *d++ = 22;
            s += 2;
        }
        else
            *d++ = *s++;
    }
    *d = '\000';
    return retval;
}
# 1885 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void viminfo_writestring(fd, p)
    FILE *fd;
    char_u *p;
{
    int c;
    char_u *s;
    int len = 0;

    for (s = p; *s != '\000'; ++s)
    {
        if (*s == 22 || *s == '\n')
            ++len;
        ++len;
    }





    if (len > 512 / 2)
        fprintf(fd, "\026%d\n<", len + 3);

    while ((c = *p++) != '\000')
    {
        if (c == 22 || c == '\n')
        {
            _IO_putc (22, fd);
            if (c == '\n')
                c = 'n';
        }
        _IO_putc (c, fd);
    }
    _IO_putc ('\n', fd);
}
# 1929 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void do_fixdel(eap)
    exarg_T *eap;
{
    char_u *p;

    p = find_termcode((char_u *)"kb");
    add_termcode((char_u *)"kD", p != ((void *)0)
            && *p == 0x7f ? (char_u *)"\010" : (char_u *)"\177", 0);
}
# 1940 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void print_line_no_prefix(lnum, use_number)
    linenr_T lnum;
    int use_number;
{
    char_u numbuf[20];

    if (curwin->w_onebuf_opt.wo_nu || use_number)
    {
        sprintf((char *)numbuf, "%7ld ", (long)lnum);
        msg_puts_attr(numbuf, highlight_attr[(int)(HLF_N)]);
    }
    msg_prt_line(ml_get(lnum));
}
# 1958 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void print_line(lnum, use_number)
    linenr_T lnum;
    int use_number;
{
    int save_silent = silent_mode;

    silent_mode = 0;
    msg_start();
    print_line_no_prefix(lnum, use_number);
    if (save_silent)
    {
        msg_putchar('\n');
        cursor_on();
        out_flush();
        silent_mode = save_silent;
    }
}
# 1980 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_file(eap)
    exarg_T *eap;
{
    char_u *fname, *sfname, *xfname;
    buf_T *buf;

    if (*eap->arg != '\000')
    {

        buf = curbuf;
        apply_autocmds(EVENT_BUFFILEPRE, ((void *)0), ((void *)0), 0, curbuf);

        if (buf != curbuf)
            return;

        if (aborting())
            return;







        fname = curbuf->b_ffname;
        sfname = curbuf->b_sfname;
        xfname = curbuf->b_fname;
        curbuf->b_ffname = ((void *)0);
        curbuf->b_sfname = ((void *)0);
        if (setfname(eap->arg, ((void *)0), 1) == 0)
        {
            curbuf->b_ffname = fname;
            curbuf->b_sfname = sfname;
            return;
        }
        curbuf->b_flags |= 0x08;
        buf = buflist_new(fname, xfname, curwin->w_cursor.lnum, 0);
        if (buf != ((void *)0))
            curwin->w_alt_fnum = buf->b_fnum;
        vim_free(fname);
        vim_free(sfname);

        apply_autocmds(EVENT_BUFFILEPOST, ((void *)0), ((void *)0), 0, curbuf);

    }

    fileinfo(0, 0, eap->forceit);
}
# 2033 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_update(eap)
    exarg_T *eap;
{
    if (curbufIsChanged())
        (void)do_write(eap);
}
# 2044 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_write(eap)
    exarg_T *eap;
{
    if (eap->usefilter)
        do_bang(1, eap, 0, 1, 0);
    else
        (void)do_write(eap);
}
# 2062 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    int do_write(eap)
    exarg_T *eap;
{
    int other;
    char_u *fname = ((void *)0);
    char_u *ffname;
    int retval = 0;
    char_u *free_fname = ((void *)0);

    char_u *browse_file = ((void *)0);

    buf_T *alt_buf = ((void *)0);

    if (not_writing())
        return 0;

    ffname = eap->arg;

    if (cmdmod.browse)
    {
        browse_file = do_browse(1, (char_u *)((char *)("Save As")), ffname,
                                                    ((void *)0), ((void *)0), ((void *)0), curbuf);
        if (browse_file == ((void *)0))
            goto theend;
        ffname = browse_file;
    }

    if (*ffname == '\000')
    {
        if (eap->cmdidx == CMD_saveas)
        {
            emsg((char_u *)(((char *)(e_argreq))));
            goto theend;
        }
        other = 0;
    }
    else
    {
        fname = ffname;
        free_fname = fix_fname(ffname);




        if (free_fname != ((void *)0))
            ffname = free_fname;
        other = otherfile(ffname);
    }




    if (other)
    {
        if (vim_strchr(p_cpo, 'A') != ((void *)0)
                                                 || eap->cmdidx == CMD_saveas)
            alt_buf = setaltfname(ffname, fname, (linenr_T)1);
        else
            alt_buf = buflist_findname(ffname);
        if (alt_buf != ((void *)0) && alt_buf->b_ml.ml_mfp != ((void *)0))
        {


            emsg((char_u *)(((char *)("E139: File is loaded in another buffer"))));
            goto theend;
        }
    }






    if (!other && (

                bt_dontwrite_msg(curbuf) ||

                check_fname() == 0 || check_readonly(&eap->forceit, curbuf)))
        goto theend;

    if (!other)
    {
        ffname = curbuf->b_ffname;
        fname = curbuf->b_fname;



        if ( (eap->line1 != 1
                    || eap->line2 != curbuf->b_ml.ml_line_count)
                && !eap->forceit
                && !eap->append
                && !p_wa)
        {

            if (p_confirm || cmdmod.confirm)
            {
                if (vim_dialog_yesno(4, ((void *)0),
                               (char_u *)((char *)("Write partial file?")), 2) != 2)
                    goto theend;
                eap->forceit = 1;
            }
            else

            {
                emsg((char_u *)(((char *)("E140: Use ! to write partial buffer"))));
                goto theend;
            }
        }
    }

    if (check_overwrite(eap, curbuf, fname, ffname, other) == 1)
    {
        if (eap->cmdidx == CMD_saveas && alt_buf != ((void *)0))
        {

            buf_T *was_curbuf = curbuf;

            apply_autocmds(EVENT_BUFFILEPRE, ((void *)0), ((void *)0), 0, curbuf);

            if (curbuf != was_curbuf || aborting())



            {

                retval = 0;
                goto theend;
            }






            fname = alt_buf->b_fname;
            alt_buf->b_fname = curbuf->b_fname;
            curbuf->b_fname = fname;
            fname = alt_buf->b_ffname;
            alt_buf->b_ffname = curbuf->b_ffname;
            curbuf->b_ffname = fname;
            fname = alt_buf->b_sfname;
            alt_buf->b_sfname = curbuf->b_sfname;
            curbuf->b_sfname = fname;
            buf_name_changed();

            apply_autocmds(EVENT_BUFFILEPOST, ((void *)0), ((void *)0), 0, curbuf);
            if (!alt_buf->b_p_bl)
            {
                alt_buf->b_p_bl = 1;
                apply_autocmds(EVENT_BUFADD, ((void *)0), ((void *)0), 0, alt_buf);
            }

            if (curbuf != was_curbuf || aborting())



            {

                retval = 0;
                goto theend;
            }

        }

        retval = buf_write(curbuf, ffname, fname, eap->line1, eap->line2,
                                 eap, eap->append, eap->forceit, 1, 0);
    }

theend:

    vim_free(browse_file);

    vim_free(free_fname);
    return retval;
}
# 2246 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    static int check_overwrite(eap, buf, fname, ffname, other)
    exarg_T *eap;
    buf_T *buf;
    char_u *fname;

    char_u *ffname;
    int other;
{




    if ( (other
                || (buf->b_flags & 0x08)
                || ((buf->b_flags & 0x10)
                    && vim_strchr(p_cpo, 'O') == ((void *)0))
                || (buf->b_flags & 0x40))
            && !eap->forceit
            && !eap->append
            && !p_wa
            && vim_fexists(ffname))
    {


        if (mch_isdir(ffname))
        {
            emsg2((char_u *)(((char *)(e_isadir2))), (char_u *)(ffname));
            return 0;
        }


        if (p_confirm || cmdmod.confirm)
        {
            char_u buff[(1024+1)];

            dialog_msg(buff, ((char *)("Overwrite existing file \"%.*s\"?")), fname);
            if (vim_dialog_yesno(4, ((void *)0), buff, 2) != 2)
                return 0;
            eap->forceit = 1;
        }
        else

        {
            emsg((char_u *)(((char *)(e_exists))));
            return 0;
        }
    }
    return 1;
}
# 2300 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_wnext(eap)
    exarg_T *eap;
{
    int i;

    if (eap->cmd[1] == 'n')
        i = curwin->w_arg_idx + (int)eap->line2;
    else
        i = curwin->w_arg_idx - (int)eap->line2;
    eap->line1 = 1;
    eap->line2 = curbuf->b_ml.ml_line_count;
    if (do_write(eap) != 0)
        do_argfile(eap, i);
}
# 2319 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void do_wqall(eap)
    exarg_T *eap;
{
    buf_T *buf;
    int error = 0;

    if (eap->cmdidx == CMD_xall || eap->cmdidx == CMD_wqall)
        exiting = 1;

    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
    {
        if (bufIsChanged(buf))
        {







            if (not_writing())
            {
                ++error;
                break;
            }


            if (buf->b_ffname == ((void *)0) && cmdmod.browse)
                buf->b_ffname = do_browse(1, (char_u *)((char *)("Save As")), ((void *)0),
                                                       ((void *)0), ((void *)0), ((void *)0), buf);

            if (buf->b_ffname == ((void *)0))
            {
                emsgn((char_u *)(((char *)("E141: No file name for buffer %ld"))), (long)((long)buf->b_fnum));
                ++error;
            }
            else if (check_readonly(&eap->forceit, buf)
                    || check_overwrite(eap, buf, buf->b_fname, buf->b_ffname,
                                                               0) == 0)
            {
                ++error;
            }
            else
            {
                if (buf_write_all(buf, eap->forceit) == 0)
                    ++error;


                if (!buf_valid(buf))
                    buf = firstbuf;

            }
        }
    }
    if (exiting)
    {
        if (!error)
            getout(0);
        not_exiting();
    }
}
# 2386 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    int not_writing()
{
    if (p_write)
        return 0;
    emsg((char_u *)(((char *)("E142: File not written: Writing is disabled by 'write' option"))));
    return 1;
}
# 2399 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    static int check_readonly(forceit, buf)
    int *forceit;
    buf_T *buf;
{
    if (!*forceit && buf->b_p_ro)
    {

        if ((p_confirm || cmdmod.confirm) && buf->b_fname != ((void *)0))
        {
            char_u buff[(1024+1)];

            dialog_msg(buff, ((char *)("'readonly' option is set for \"%.*s\".\nDo you wish to write anyway?")),
                    buf->b_fname);

            if (vim_dialog_yesno(4, ((void *)0), buff, 2) == 2)
            {

                *forceit = 1;
                return 0;
            }
            else
                return 1;
        }
        else

            emsg((char_u *)(((char *)(e_readonly))));
        return 1;
    }
    return 0;
}
# 2439 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    int getfile(fnum, ffname, sfname, setpm, lnum, forceit)
    int fnum;
    char_u *ffname;
    char_u *sfname;
    int setpm;
    linenr_T lnum;
    int forceit;
{
    int other;
    int retval;
    char_u *free_me = ((void *)0);


    if (cmdwin_type != 0)
        return 1;


    if (fnum == 0)
    {
        fname_expand(&ffname, &sfname);
        other = otherfile(ffname);
        free_me = ffname;
    }
    else
        other = (fnum != curbuf->b_fnum);

    if (other)
        ++no_wait_return;
    if (other && !forceit && curbuf->b_nwindows == 1 && !(buf_hide(curbuf))
                   && curbufIsChanged() && autowrite(curbuf, forceit) == 0)
    {
        if (other)
            --no_wait_return;
        emsg((char_u *)(((char *)(e_nowrtmsg))));
        retval = 2;
        goto theend;
    }
    if (other)
        --no_wait_return;
    if (setpm)
        setpcmark();
    if (!other)
    {
        if (lnum != 0)
            curwin->w_cursor.lnum = lnum;
        check_cursor_lnum();
        beginline(2 | 4);
        retval = 0;
    }
    else if (do_ecmd(fnum, ffname, sfname, ((void *)0), lnum,
                ((buf_hide(curbuf)) ? 0x01 : 0) + (forceit ? 0x08 : 0)) == 1)
        retval = -1;
    else
        retval = 1;

theend:
    vim_free(free_me);
    return retval;
}
# 2526 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    int do_ecmd(fnum, ffname, sfname, eap, newlnum, flags)
    int fnum;
    char_u *ffname;
    char_u *sfname;
    exarg_T *eap;
    linenr_T newlnum;
    int flags;
{
    int other_file;
    int oldbuf;

    int auto_buf = 0;

    char_u *new_name = ((void *)0);

    buf_T *buf;

    buf_T *old_curbuf = curbuf;

    char_u *free_fname = ((void *)0);

    char_u *browse_file = ((void *)0);

    int retval = 0;
    long n;
    linenr_T lnum;
    linenr_T topline = 0;
    int newcol = -1;
    int solcol = -1;
    pos_T *pos;



    char_u *command = ((void *)0);

    if (eap != ((void *)0))
        command = eap->do_ecmd_cmd;

    if (fnum != 0)
    {
        if (fnum == curbuf->b_fnum)
            return 1;
        other_file = 1;
    }
    else
    {

        if (cmdmod.browse)
        {
            browse_file = do_browse(0, (char_u *)((char *)("Edit File")), ffname,
                                                    ((void *)0), ((void *)0), ((void *)0), curbuf);
            if (browse_file == ((void *)0))
                goto theend;
            ffname = browse_file;
        }


        if (sfname == ((void *)0))
            sfname = ffname;
        if ((flags & 0x10) && (ffname == ((void *)0) || *ffname == '\000'))
            goto theend;


        if (ffname == ((void *)0))
            other_file = 1;

        else if (*ffname == '\000' && curbuf->b_ffname == ((void *)0))
            other_file = 0;
        else
        {
            if (*ffname == '\000')
            {
                ffname = curbuf->b_ffname;
                sfname = curbuf->b_fname;
            }
            free_fname = fix_fname(ffname);
            if (free_fname != ((void *)0))
                ffname = free_fname;
            other_file = otherfile(ffname);




        }
    }






    if ( ((!other_file && !(flags & 0x04))
            || (curbuf->b_nwindows == 1
                && !(flags & (0x01 | 0x10))))
        && check_changed(curbuf, p_awa, !other_file,
                                        (flags & 0x08), 0))
    {
        if (fnum == 0 && other_file && ffname != ((void *)0))
            (void)setaltfname(ffname, sfname, newlnum < 0 ? 0 : newlnum);
        goto theend;
    }






    reset_VIsual();






    if (other_file)
    {

        if (!(flags & 0x10))

        {
            curwin->w_alt_fnum = curbuf->b_fnum;
            buflist_altfpos();
        }

        if (fnum)
            buf = buflist_findnr(fnum);
        else
        {

            if (flags & 0x10)
            {
                linenr_T tlnum = 1L;

                if (command != ((void *)0))
                {
                    tlnum = atol((char *)command);
                    if (tlnum <= 0)
                        tlnum = 1L;
                }
                (void)buflist_new(ffname, sfname, tlnum, 2);
                goto theend;
            }

            buf = buflist_new(ffname, sfname, 0L,
                    1 | ((flags & 0x02) ? 0 : 2));
        }
        if (buf == ((void *)0))
            goto theend;
        if (buf->b_ml.ml_mfp == ((void *)0))
        {
            oldbuf = 0;
            buf->b_nwindows = 0;
        }
        else
        {
            oldbuf = 1;
            (void)buf_check_timestamp(buf, 0);

            if (!buf_valid(buf))
                goto theend;

            if (aborting())
                goto theend;

        }



        if ((oldbuf && newlnum == (linenr_T)0) || newlnum == (linenr_T)-1)
        {
            pos = buflist_findfpos(buf);
            newlnum = pos->lnum;
            solcol = pos->col;
        }







        if (buf != curbuf)
        {
            if (buf->b_fname != ((void *)0))
                new_name = vim_strsave(buf->b_fname);
            au_new_curbuf = buf;
            apply_autocmds(EVENT_BUFLEAVE, ((void *)0), ((void *)0), 0, curbuf);
            if (!buf_valid(buf))
            {
                delbuf_msg(new_name);
                goto theend;
            }

            if (aborting())
            {
                vim_free(new_name);
                goto theend;
            }

            if (buf == curbuf)
                auto_buf = 1;
            else
            {
                if (curbuf == old_curbuf)

                    buf_copy_options(buf, 1);


                close_buffer(curwin, curbuf,
                                      (flags & 0x01) ? 0 : 2);



            if (aborting())
            {
                vim_free(new_name);
                goto theend;
            }


                if (!buf_valid(buf))
                {
                    delbuf_msg(new_name);
                    goto theend;
                }
                if (buf == curbuf)
                    auto_buf = 1;
                else


                {
                    curwin->w_buffer = buf;
                    curbuf = buf;
                    ++curbuf->b_nwindows;

                    if (*p_ffs && !oldbuf)
                        set_fileformat(default_fileformat(), 4);
                }





                get_winopts(buf);


            }
            vim_free(new_name);
            au_new_curbuf = ((void *)0);

        }
        else
            ++curbuf->b_nwindows;

        curwin->w_pcmark.lnum = 1;
        curwin->w_pcmark.col = 0;
    }
    else
    {
        if (

                (flags & 0x10) ||

                check_fname() == 0)
            goto theend;
        oldbuf = (flags & 0x04);
    }

    if ((flags & 0x02) || keep_help_flag)
    {
        curbuf->b_help = 1;

        set_string_option_direct((char_u *)"buftype", -1,
                                       (char_u *)"help", 1 |4);

        curbuf->b_p_ma = 0;
        curbuf->b_p_bin = 0;
        curwin->w_onebuf_opt.wo_nu = 0;

        curwin->w_onebuf_opt.wo_scb = 0;
        curwin->w_onebuf_opt.wo_fen = 0;


        curwin->w_onebuf_opt.wo_diff = 0;



        buf = curbuf;

        set_buflisted(0);
    }
    else
    {

        buf = curbuf;

        set_buflisted(1);
    }




    if (buf != curbuf)
        goto theend;

    if (aborting())
        goto theend;





    did_filetype = 0;
    if (!other_file && !oldbuf)
    {
        set_last_cursor(curwin);
        if (newlnum == (linenr_T)-1 || newlnum == (linenr_T)0)
        {
            newlnum = curwin->w_cursor.lnum;
            solcol = curwin->w_cursor.col;
        }

        buf = curbuf;
        if (buf->b_fname != ((void *)0))
            new_name = vim_strsave(buf->b_fname);
        else
            new_name = ((void *)0);

        buf_freeall(curbuf, 0, 0);



        if (!buf_valid(buf))
        {
            delbuf_msg(new_name);
            goto theend;
        }
        vim_free(new_name);




        if (buf != curbuf)
            goto theend;

        if (aborting())
            goto theend;


        buf_clear_file(curbuf);
        curbuf->b_op_start.lnum = 0;
        curbuf->b_op_end.lnum = 0;
    }





    ++RedrawingDisabled;


    retval = 1;




    check_cursor();




    check_arg_idx(curwin);


    if (!auto_buf)

    {





        win_init(curwin);




        foldUpdateAll(curwin);



        if (p_acd && curbuf->b_ffname != ((void *)0)
                                     && vim_chdirfile(curbuf->b_ffname) == 1)
            shorten_fnames(1);





        lnum = curwin->w_cursor.lnum;
        topline = curwin->w_topline;
        if (!oldbuf)
        {

            swap_exists_action = 1;

            curbuf->b_flags |= 0x02;





            if (should_abort(open_buffer(0, eap)))
                retval = 0;





            if (swap_exists_action == 2)
                retval = 0;
            handle_swap_exists(old_curbuf);

        }

        else
        {
            apply_autocmds_retval(EVENT_BUFENTER, ((void *)0), ((void *)0), 0, curbuf,
                                                                    &retval);
            apply_autocmds_retval(EVENT_BUFWINENTER, ((void *)0), ((void *)0), 0, curbuf,
                                                                    &retval);
        }
        check_arg_idx(curwin);






        if (curwin->w_cursor.lnum != lnum)
        {
            newlnum = curwin->w_cursor.lnum;
            newcol = curwin->w_cursor.col;
        }
        if (curwin->w_topline == topline)
            topline = 0;


        changed_line_abv_curs();


        maketitle();

    }





    diff_new_buffer();
    diff_invalidate();


    if (command == ((void *)0))
    {
        if (newcol >= 0)
        {
            curwin->w_cursor.lnum = newlnum;
            curwin->w_cursor.col = newcol;
            check_cursor();
        }
        else if (newlnum > 0)
        {
            curwin->w_cursor.lnum = newlnum;
            check_cursor_lnum();
            if (solcol >= 0 && !p_sol)
            {

                curwin->w_cursor.col = solcol;
                check_cursor_col();

                curwin->w_cursor.coladd = 0;

                curwin->w_set_curswant = 1;
            }
            else
                beginline(2 | 4);
        }
        else
        {
            if (exmode_active)
                curwin->w_cursor.lnum = curbuf->b_ml.ml_line_count;
            beginline(1 | 4);
        }
    }



    check_lnums(0);






    if (oldbuf

                && !auto_buf

                            )
    {
        int msg_scroll_save = msg_scroll;



        if (shortmess('O') && !exiting && p_verbose == 0)
            msg_scroll = 0;
        if (!msg_scroll)
            check_for_delay(0);
        msg_start();
        msg_scroll = msg_scroll_save;
        msg_scrolled_ign = 1;

        fileinfo(0, 1, 0);

        msg_scrolled_ign = 0;
    }

    if (command != ((void *)0))
        do_cmdline(command, ((void *)0), ((void *)0), 0x01);






    --RedrawingDisabled;
    if (!skip_redraw)
    {
        n = p_so;
        if (topline == 0 && command == ((void *)0))
            p_so = 999;
        update_topline();

        curwin->w_scbind_pos = curwin->w_topline;

        p_so = n;
        redraw_curbuf_later(40);
    }

    if (p_im)
        need_start_insertmode = 1;



    if (p_acd && curbuf->b_ffname != ((void *)0)
                                     && vim_chdirfile(curbuf->b_ffname) == 1)
        shorten_fnames(1);

    if (gui.in_use && curbuf->b_fname != ((void *)0))
    {





        if (usingNetbeans)
            netbeans_file_opened((char *)curbuf->b_ffname);

    }


theend:

    vim_free(browse_file);

    vim_free(free_fname);
    return retval;
}
# 3144 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    static void delbuf_msg(name)
    char_u *name;
{
    emsg2((char_u *)(((char *)("E143: Autocommands unexpectedly deleted new buffer %s"))), (char_u *)(name == ((void *)0) ? (char_u *)"" : name));

    vim_free(name);
    au_new_curbuf = ((void *)0);
}
# 3158 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_append(eap)
    exarg_T *eap;
{
    char_u *theline;
    int did_undo = 0;
    linenr_T lnum = eap->line2;

    if (eap->cmdidx != CMD_append)
        --lnum;

    State = 0x10;
    if (curbuf->b_p_iminsert == 1)
        State |= 0x20;
    while (1)
    {
        msg_scroll = 1;
        need_wait_return = 0;
        if (eap->getline == ((void *)0))
            theline = getcmdline(

                    eap->cstack->cs_whilelevel > 0 ? -1 :

                    '\000', 0L, 0);
        else
            theline = eap->getline(

                    eap->cstack->cs_whilelevel > 0 ? -1 :

                    '\000', eap->cookie, 0);
        lines_left = Rows - 1;
        if (theline == ((void *)0) || (theline[0] == '.' && theline[1] == '\000'))
            break;

        if (!did_undo && u_save(lnum, lnum + 1) == 0)
            break;
        did_undo = 1;
        ml_append(lnum, theline, (colnr_T)0, 0);
        appended_lines_mark(lnum, 1L);

        vim_free(theline);
        ++lnum;
        msg_didout = 1;
    }
    State = 0x01;





    curbuf->b_op_start.lnum = (eap->line2 < curbuf->b_ml.ml_line_count) ?
        eap->line2 + 1 : curbuf->b_ml.ml_line_count;
    if (eap->cmdidx != CMD_append)
        --curbuf->b_op_start.lnum;
    curbuf->b_op_end.lnum = (eap->line2 < lnum)
                                             ? lnum : curbuf->b_op_start.lnum;
    curbuf->b_op_start.col = curbuf->b_op_end.col = 0;
    curwin->w_cursor.lnum = lnum;
    check_cursor_lnum();
    beginline(2 | 4);

    need_wait_return = 0;
    ex_no_reprint = 1;
}
# 3226 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_change(eap)
    exarg_T *eap;
{
    linenr_T lnum;

    if (eap->line2 >= eap->line1
            && u_save(eap->line1 - 1, eap->line2 + 1) == 0)
        return;

    for (lnum = eap->line2; lnum >= eap->line1; --lnum)
    {
        if (curbuf->b_ml.ml_flags & 1)
            break;
        ml_delete(eap->line1, 0);
    }
    deleted_lines_mark(eap->line1, (long)(eap->line2 - lnum));


    eap->line2 = eap->line1;
    ex_append(eap);
}
# 3249 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_z(eap)
    exarg_T *eap;
{
    char_u *x;
    int bigness = curwin->w_height - 3;
    char_u kind;
    int numbered = 0;
    int minus = 0;
    linenr_T start, end, curs, i;
    int j;
    linenr_T lnum = eap->line2;

    if (bigness < 1)
        bigness = 1;

    x = eap->arg;
    if (*x == '#')
    {
        numbered = 1;
        ++x;
    }

    kind = *x;
    if (kind == '-' || kind == '+' || kind == '=' || kind == '^' || kind == '.')
        ++x;

    if (*x != 0)
    {
        if (!(__ctype_b[(int) ((*x))] & (unsigned short int) _ISdigit))
        {
            emsg((char_u *)(((char *)("E144: non-numeric argument to :z"))));
            return;
        }
        else
            bigness = atoi((char *)x);
    }

    switch (kind)
    {
        case '-':
            start = lnum - bigness;
            end = lnum;
            curs = lnum;
            break;

        case '=':
            start = lnum - bigness / 2 + 1;
            end = lnum + bigness / 2 - 1;
            curs = lnum;
            minus = 1;
            break;

        case '^':
            start = lnum - bigness * 2;
            end = lnum - bigness;
            curs = lnum - bigness;
            break;

        case '.':
            start = lnum - bigness / 2;
            end = lnum + bigness / 2;
            curs = end;
            break;

        default:
            start = lnum;
            end = lnum + bigness;
            curs = end;
            break;
    }

    if (start < 1)
        start = 1;

    if (end > curbuf->b_ml.ml_line_count)
        end = curbuf->b_ml.ml_line_count;

    if (curs > curbuf->b_ml.ml_line_count)
        curs = curbuf->b_ml.ml_line_count;

    for (i = start; i <= end; i++)
    {
        if (minus && i == lnum)
        {
            msg_putchar('\n');

            for (j = 1; j < Columns; j++)
                msg_putchar('-');
        }

        print_line(i, numbered);

        if (minus && i == lnum)
        {
            msg_putchar('\n');

            for (j = 1; j < Columns; j++)
                msg_putchar('-');
        }
    }

    curwin->w_cursor.lnum = curs;
    ex_no_reprint = 1;
}
# 3360 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    int check_restricted()
{
    if (restricted)
    {
        emsg((char_u *)(((char *)("E145: Shell commands not allowed in rvim"))));
        return 1;
    }
    return 0;
}
# 3376 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    int check_secure()
{
    if (secure)
    {
        secure = 2;
        emsg((char_u *)(((char *)(e_curdir))));
        return 1;
    }





    if (sandbox != 0)
    {
        emsg((char_u *)(((char *)(e_sandbox))));
        return 1;
    }

    return 0;
}
# 3398 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static char_u *old_sub = ((void *)0);
# 3399 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static int global_need_beginline;
# 3405 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static long sub_nsubs;
# 3406 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static linenr_T sub_nlines;
# 3418 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void do_sub(eap)
    exarg_T *eap;
{
    linenr_T lnum;
    long i = 0;
    regmmatch_T regmatch;
    static int do_all = 0;
    static int do_ask = 0;
    static int do_error = 1;
    static int do_print = 0;
    static int do_ic = 0;
    char_u *pat = ((void *)0), *sub = ((void *)0);
    int delimiter;
    int sublen;
    int got_quit = 0;
    int got_match = 0;
    int temp;
    int which_pat;
    char_u *cmd;
    int save_State;
    linenr_T first_line = 0;
    linenr_T last_line= 0;

    linenr_T old_line_count = curbuf->b_ml.ml_line_count;
    linenr_T line2;
    long nmatch;
    linenr_T sub_firstlnum;
    char_u *sub_firstline;

    cmd = eap->arg;
    if (!global_busy)
    {
        sub_nsubs = 0;
        sub_nlines = 0;
    }






    if (eap->cmdidx == CMD_tilde)
        which_pat = 2;
    else
        which_pat = 1;


    if (eap->cmd[0] == 's' && *cmd != '\000' && !((*cmd) == ' ' || (*cmd) == '\t')
                && vim_strchr((char_u *)"0123456789cegriIp|\"", *cmd) == ((void *)0))
    {

        if ((__ctype_b[(int) ((*cmd))] & (unsigned short int) _ISalpha))
        {
            emsg((char_u *)(((char *)("E146: Regular expressions can't be delimited by letters"))));
            return;
        }





        if (*cmd == '\\')
        {
            ++cmd;
            if (vim_strchr((char_u *)"/?&", *cmd) == ((void *)0))
            {
                emsg((char_u *)(((char *)(e_backslash))));
                return;
            }
            if (*cmd != '&')
                which_pat = 0;
            pat = (char_u *)"";
            delimiter = *cmd++;
        }
        else
        {
            which_pat = 2;
            delimiter = *cmd++;
            pat = cmd;
            cmd = skip_regexp(cmd, delimiter, p_magic, &eap->arg);
            if (cmd[0] == delimiter)
                *cmd++ = '\000';
        }





        sub = cmd;

        while (cmd[0])
        {
            if (cmd[0] == delimiter)
            {
                *cmd++ = '\000';
                break;
            }
            if (cmd[0] == '\\' && cmd[1] != 0)
                ++cmd;





                ++cmd;
        }

        if (!eap->skip)
        {
            vim_free(old_sub);
            old_sub = vim_strsave(sub);
        }
    }
    else if (!eap->skip)
    {
        if (old_sub == ((void *)0))
        {
            emsg((char_u *)(((char *)(e_nopresub))));
            return;
        }
        pat = ((void *)0);
        sub = old_sub;
    }




    if (*cmd == '&')
        ++cmd;
    else
    {
        if (!p_ed)
        {
            if (p_gd)
                do_all = 1;
            else
                do_all = 0;
            do_ask = 0;
        }
        do_error = 1;
        do_print = 0;
        do_ic = 0;
    }
    while (*cmd)
    {




        if (*cmd == 'g')
            do_all = !do_all;
        else if (*cmd == 'c')
            do_ask = !do_ask;
        else if (*cmd == 'e')
            do_error = !do_error;
        else if (*cmd == 'r')
            which_pat = 2;
        else if (*cmd == 'p')
            do_print = 1;
        else if (*cmd == 'i')
            do_ic = 'i';
        else if (*cmd == 'I')
            do_ic = 'I';
        else
            break;
        ++cmd;
    }




    cmd = skipwhite(cmd);
    if ((__ctype_b[(int) ((*cmd))] & (unsigned short int) _ISdigit))
    {
        i = getdigits(&cmd);
        if (i <= 0 && !eap->skip && do_error)
        {
            emsg((char_u *)(((char *)(e_zerocount))));
            return;
        }
        eap->line1 = eap->line2;
        eap->line2 += i - 1;
        if (eap->line2 > curbuf->b_ml.ml_line_count)
            eap->line2 = curbuf->b_ml.ml_line_count;
    }




    cmd = skipwhite(cmd);
    if (*cmd && *cmd != '"')
    {
        eap->nextcmd = check_nextcmd(cmd);
        if (eap->nextcmd == ((void *)0))
        {
            emsg((char_u *)(((char *)(e_trailing))));
            return;
        }
    }

    if (eap->skip)
        return;

    if (search_regcomp(pat, 1, which_pat, 0x20, &regmatch) == 0)
    {
        if (do_error)
            emsg((char_u *)(((char *)(e_invcmd))));
        return;
    }


    if (do_ic == 'i')
        regmatch.rmm_ic = 1;
    else if (do_ic == 'I')
        regmatch.rmm_ic = 0;

    sub_firstline = ((void *)0);






    if (!(sub[0] == '\\' && sub[1] == '='))
        sub = regtilde(sub, p_magic);




    line2 = eap->line2;
    for (lnum = eap->line1; lnum <= line2 && !(got_quit

                || aborting()

                ); ++lnum)
    {
        sub_firstlnum = lnum;
        nmatch = vim_regexec_multi(&regmatch, curwin, curbuf, lnum, (colnr_T)0);
        if (nmatch)
        {
            colnr_T copycol;
            colnr_T matchcol;
            colnr_T prev_matchcol = (0x7fffffffL);
            char_u *new_end, *new_start = ((void *)0);
            unsigned new_start_len = 0;
            char_u *p1;
            int did_sub = 0;
            int lastone;
            unsigned len, needed_len;
            long nmatch_tl = 0;
            int do_again;
            sub_firstline = vim_strsave(ml_get(sub_firstlnum));
            if (sub_firstline == ((void *)0))
            {
                vim_free(new_start);
                goto outofmem;
            }
            copycol = 0;
            matchcol = 0;


            if (!got_match)
            {
                setpcmark();
                got_match = 1;
            }
            for (;;)
            {


                curwin->w_cursor.lnum = lnum;
                do_again = 0;






                if (matchcol == prev_matchcol
                        && regmatch.endpos[0].lnum == 0
                        && matchcol == regmatch.endpos[0].col)
                {
                    ++matchcol;
                    goto skip;
                }



                matchcol = regmatch.endpos[0].col;
                prev_matchcol = matchcol;




                if (do_ask)
                {


                    save_State = State;
                    State = 0x800;

                    setmouse();

                    curwin->w_cursor.col = regmatch.startpos[0].col;



                    if (vim_strchr(p_cpo, 'u') != ((void *)0))
                        ++no_u_sync;




                    while (do_ask)
                    {

                        int save_p_fen = curwin->w_onebuf_opt.wo_fen;

                        curwin->w_onebuf_opt.wo_fen = 0;



                        temp = RedrawingDisabled;
                        RedrawingDisabled = 0;

                        search_match_lines = regmatch.endpos[0].lnum;
                        search_match_endcol = regmatch.endpos[0].col;
                        highlight_match = 1;

                        update_topline();
                        validate_cursor();
                        update_screen(40);
                        highlight_match = 0;
                        redraw_later(40);


                        curwin->w_onebuf_opt.wo_fen = save_p_fen;

                        if (msg_row == Rows - 1)
                            msg_didout = 0;
                        msg_starthere();
                        i = msg_scroll;
                        msg_scroll = 0;
                        msg_no_more = 1;

                        smsg_attr(highlight_attr[(int)(HLF_R)],
                            (char_u *)((char *)("replace with %s (y/n/a/q/l/^E/^Y)?")),
                                sub);
                        msg_no_more = 0;
                        msg_scroll = i;
                        showruler(1);
                        windgoto(msg_row, msg_col);
                        RedrawingDisabled = temp;




                        ++no_mapping;
                        ++allow_keys;
                        i = safe_vgetc();
                        --allow_keys;
                        --no_mapping;


                        msg_didout = 0;
                        msg_col = 0;
                        gotocmdline(1);
                        need_wait_return = 0;
                        if (i == 'q' || i == '\033' || i == 3

                                || i == intr_char

                                )
                        {
                            got_quit = 1;
                            break;
                        }
                        if (i == 'n')
                            break;
                        if (i == 'y')
                            break;
                        if (i == 'l')
                        {

                            do_all = 0;
                            line2 = lnum;
                            break;
                        }
                        if (i == 'a')
                        {
                            do_ask = 0;
                            break;
                        }

                        if (i == 5)
                            scrollup_clamp();
                        else if (i == 25)
                            scrolldown_clamp();

                    }
                    State = save_State;

                    setmouse();

                    if (vim_strchr(p_cpo, 'u') != ((void *)0))
                        --no_u_sync;

                    if (i == 'n')
                    {




                        if (nmatch > 1)
                        {
                            matchcol = strlen((char *)(sub_firstline));
                            nmatch = 1;
                        }
                        goto skip;
                    }
                    if (got_quit)
                        break;
                }



                curwin->w_cursor.col = 0;





                sublen = vim_regsub_multi(&regmatch, sub_firstlnum,
                                    sub, sub_firstline, 0, p_magic, 1);







                if (nmatch == 1)
                    p1 = sub_firstline;
                else
                {
                    p1 = ml_get(sub_firstlnum + nmatch - 1);
                    nmatch_tl += nmatch - 1;
                }
                i = regmatch.startpos[0].col - copycol;
                needed_len = i + ((unsigned)strlen((char *)(p1)) - regmatch.endpos[0].col)
                                                                 + sublen + 1;
                if (new_start == ((void *)0))
                {





                    new_start_len = needed_len + 50;
                    if ((new_start = alloc_check(new_start_len)) == ((void *)0))
                        goto outofmem;
                    *new_start = '\000';
                    new_end = new_start;
                }
                else
                {





                    len = (unsigned)strlen((char *)(new_start));
                    needed_len += len;
                    if (needed_len > new_start_len)
                    {
                        new_start_len = needed_len + 50;
                        if ((p1 = alloc_check(new_start_len)) == ((void *)0))
                        {
                            vim_free(new_start);
                            goto outofmem;
                        }
                        memmove((char *)(p1), (char *)(new_start), (size_t)(len + 1));
                        vim_free(new_start);
                        new_start = p1;
                    }
                    new_end = new_start + len;
                }




                memmove((char *)(new_end), (char *)(sub_firstline + copycol), (size_t)i);
                new_end += i;

                (void)vim_regsub_multi(&regmatch, sub_firstlnum,
                                           sub, new_end, 1, p_magic, 1);
                sub_nsubs++;
                did_sub = 1;



                if (nmatch > 1)
                {
                    sub_firstlnum += nmatch - 1;
                    vim_free(sub_firstline);
                    sub_firstline = vim_strsave(ml_get(sub_firstlnum));

                    if (sub_firstlnum <= line2)
                        do_again = 1;
                    else
                        do_all = 0;
                }


                copycol = regmatch.endpos[0].col;
                for (p1 = new_end; *p1; ++p1)
                {
                    if (p1[0] == '\\' && p1[1] != '\000')
                        memmove((char *)(p1), (char *)(p1 + 1), strlen((char *)(p1)));
                    else if (*p1 == '\015')
                    {
                        if (u_inssub(lnum) == 1)
                        {
                            *p1 = '\000';
                            ml_append(lnum - 1, new_start,
                                        (colnr_T)(p1 - new_start + 1), 0);
                            mark_adjust(lnum + 1, (linenr_T)(0x7fffffffL), 1L, 0L);
                            if (do_ask)
                                appended_lines(lnum - 1, 1L);
                            else
                            {
                                if (first_line == 0)
                                    first_line = lnum;
                                last_line = lnum + 1;
                            }

                            ++sub_firstlnum;
                            ++lnum;
                            ++line2;

                            ++curwin->w_cursor.lnum;
                            strcpy((char *)(new_start), (char *)(p1 + 1));
                            p1 = new_start - 1;
                        }
                    }




                }







skip:
                lastone = ((sub_firstline[matchcol] == '\000' && nmatch <= 1)
                             || got_int || got_quit || !(do_all || do_again));
                nmatch = -1;



                if (lastone
                        || do_ask
                        || nmatch_tl > 0
                        || (nmatch = vim_regexec_multi(&regmatch, curwin,
                                       curbuf, sub_firstlnum, matchcol)) == 0)
                {
                    if (new_start != ((void *)0))
                    {






                        strcat((char *)(new_start), (char *)(sub_firstline + copycol));
                        matchcol = (colnr_T)strlen((char *)(sub_firstline)) - matchcol;

                        if (u_savesub(lnum) != 1)
                            break;
                        ml_replace(lnum, new_start, 1);

                        if (nmatch_tl > 0)
                        {






                            ++lnum;
                            if (u_savedel(lnum, nmatch_tl) != 1)
                                break;
                            for (i = 0; i < nmatch_tl; ++i)
                                ml_delete(lnum, (int)0);
                            mark_adjust(lnum, lnum + nmatch_tl - 1,
                                                   (long)(0x7fffffffL), -nmatch_tl);
                            if (do_ask)
                                deleted_lines(lnum, nmatch_tl);
                            --lnum;
                            line2 -= nmatch_tl;
                            nmatch_tl = 0;
                        }



                        if (do_ask)
                            changed_bytes(lnum, 0);
                        else
                        {
                            if (first_line == 0)
                                first_line = lnum;
                            last_line = lnum + 1;
                        }

                        sub_firstlnum = lnum;
                        vim_free(sub_firstline);
                        sub_firstline = new_start;
                        new_start = ((void *)0);
                        matchcol = (colnr_T)strlen((char *)(sub_firstline)) - matchcol;
                        copycol = 0;
                    }
                    if (nmatch == -1 && !lastone)
                        nmatch = vim_regexec_multi(&regmatch, curwin, curbuf,
                                                     sub_firstlnum, matchcol);




                    if (nmatch <= 0)
                        break;
                }

                line_breakcheck();
            }

            if (did_sub)
                ++sub_nlines;
            vim_free(sub_firstline);
            sub_firstline = ((void *)0);
        }

        line_breakcheck();
    }

    if (first_line != 0)
    {



        i = curbuf->b_ml.ml_line_count - old_line_count;
        changed_lines(first_line, 0, last_line - i, i);
    }

outofmem:
    vim_free(sub_firstline);
    if (sub_nsubs)
    {

        curbuf->b_op_start.lnum = eap->line1;
        curbuf->b_op_end.lnum = line2;
        curbuf->b_op_start.col = curbuf->b_op_end.col = 0;

        if (!global_busy)
        {
            beginline(1 | 4);
            if (!do_sub_msg() && do_ask)
                msg((char_u *)(""));
        }
        else
            global_need_beginline = 1;
        if (do_print)
            print_line(curwin->w_cursor.lnum, 0);
    }
    else if (!global_busy)
    {
        if (got_int)
            emsg((char_u *)(((char *)(e_interr))));
        else if (got_match)
            msg((char_u *)(""));
        else if (do_error)
            emsg2((char_u *)(((char *)(e_patnotf2))), (char_u *)(get_search_pat()));
    }

    vim_free(regmatch.regprog);
}
# 4176 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    static int do_sub_msg()
{






    if (sub_nsubs > p_report
            && (KeyTyped || sub_nlines > 1 || p_report < 1)
            && messaging())
    {
        if (got_int)
            strcpy((char *)(msg_buf), (char *)(((char *)("(Interrupted) "))));
        else
            msg_buf[0] = '\000';
        if (sub_nsubs == 1)
            strcat((char *)(msg_buf), (char *)(((char *)("1 substitution"))));
        else
            sprintf((char *)msg_buf + strlen((char *)(msg_buf)), ((char *)("%ld substitutions")),
                                                                   sub_nsubs);
        if (sub_nlines == 1)
            strcat((char *)(msg_buf), (char *)(((char *)(" on 1 line"))));
        else
            sprintf((char *)msg_buf + strlen((char *)(msg_buf)), ((char *)(" on %ld lines")),
                                                            (long)sub_nlines);
        if (msg(msg_buf))
        {

            set_keep_msg(msg_buf);
            keep_msg_attr = 0;
        }
        return 1;
    }
    if (got_int)
    {
        emsg((char_u *)(((char *)(e_interr))));
        return 1;
    }
    return 0;
}
# 4235 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_global(eap)
    exarg_T *eap;
{
    linenr_T lnum;
    int ndone;
    int type;
    char_u *cmd;

    char_u delim;
    char_u *pat;
    regmmatch_T regmatch;
    int match;
    int which_pat;

    if (global_busy)
    {
        emsg((char_u *)(((char *)("E147: Cannot do :global recursive"))));
        return;
    }

    if (eap->forceit)
        type = 'v';
    else
        type = *eap->cmd;
    cmd = eap->arg;
    which_pat = 2;
    sub_nsubs = 0;
    sub_nlines = 0;






    if (*cmd == '\\')
    {
        ++cmd;
        if (vim_strchr((char_u *)"/?&", *cmd) == ((void *)0))
        {
            emsg((char_u *)(((char *)(e_backslash))));
            return;
        }
        if (*cmd == '&')
            which_pat = 1;
        else
            which_pat = 0;
        ++cmd;
        pat = (char_u *)"";
    }
    else if (*cmd == '\000')
    {
        emsg((char_u *)(((char *)("E148: Regular expression missing from global"))));
        return;
    }
    else
    {
        delim = *cmd;
        if (delim)
            ++cmd;
        pat = cmd;
        cmd = skip_regexp(cmd, delim, p_magic, &eap->arg);
        if (cmd[0] == delim)
            *cmd++ = '\000';
    }






    if (search_regcomp(pat, 2, which_pat, 0x20, &regmatch) == 0)
    {
        emsg((char_u *)(((char *)(e_invcmd))));
        return;
    }




    ndone = 0;
    for (lnum = eap->line1; lnum <= eap->line2 && !got_int; ++lnum)
    {

        match = vim_regexec_multi(&regmatch, curwin, curbuf, lnum, (colnr_T)0);
        if ((type == 'g' && match) || (type == 'v' && !match))
        {
            ml_setmarked(lnum);
            ndone++;
        }
        line_breakcheck();
    }




    if (got_int)
        msg((char_u *)(((char *)(e_interr))));
    else if (ndone == 0)
    {
        if (type == 'v')
            msg_str((char_u *)((char *)("Pattern found in every line: %s")), pat);
        else
            msg_str((char_u *)((char *)(e_patnotf2)), pat);
    }
    else
        global_exe(cmd);

    ml_clearmarked();
    vim_free(regmatch.regprog);
}
# 4350 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void global_exe(cmd)
    char_u *cmd;
{
    linenr_T old_lcount;
    linenr_T lnum;






    setpcmark();


    msg_didout = 1;

    global_need_beginline = 0;
    global_busy = 1;
    old_lcount = curbuf->b_ml.ml_line_count;
    while (!got_int && (lnum = ml_firstmarked()) != 0 && global_busy == 1)
    {
        curwin->w_cursor.lnum = lnum;
        curwin->w_cursor.col = 0;
        if (*cmd == '\000' || *cmd == '\n')
            do_cmdline((char_u *)"p", ((void *)0), ((void *)0), 0x02);
        else
            do_cmdline(cmd, ((void *)0), ((void *)0), 0x02);
        ui_breakcheck();
    }

    global_busy = 0;
    if (global_need_beginline)
        beginline(1 | 4);
    else
        check_cursor();



    if (msg_col == 0 && msg_scrolled == 0)
        msg_didout = 0;



    if (!do_sub_msg())
        msgmore(curbuf->b_ml.ml_line_count - old_lcount);
}
# 4399 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    int read_viminfo_sub_string(virp, force)
    vir_T *virp;
    int force;
{
    if (old_sub != ((void *)0) && force)
        vim_free(old_sub);
    if (force || old_sub == ((void *)0))
        old_sub = viminfo_readstring(virp, 1, 1);
    return viminfo_readline(virp);
}
# 4411 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void write_viminfo_sub_string(fp)
    FILE *fp;
{
    if (get_viminfo_parameter('/') != 0 && old_sub != ((void *)0))
    {
        fprintf(fp, ((char *)("\n# Last Substitute String:\n$")));
        viminfo_writestring(fp, old_sub);
    }
}
# 4427 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void prepare_tagpreview()
{
    win_T *wp;


    need_mouse_correct = 1;





    if (!curwin->w_onebuf_opt.wo_pvw)
    {
        for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
            if (wp->w_onebuf_opt.wo_pvw)
                break;
        if (wp != ((void *)0))
            win_enter(wp, 1);
        else
        {



            if (win_split(g_do_tagpreview > 0 ? g_do_tagpreview : 0, 0)
                                                                      == 0)
                return;
            curwin->w_onebuf_opt.wo_pvw = 1;
            curwin->w_onebuf_opt.wo_wfh = 1;

            curwin->w_onebuf_opt.wo_scb = 0;


            curwin->w_onebuf_opt.wo_diff = 0;


            curwin->w_onebuf_opt.wo_fdc = 0;

        }
    }
}
# 4475 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_help(eap)
    exarg_T *eap;
{
    char_u *arg;
    FILE *helpfd;
    int n;

    win_T *wp;

    int num_matches;
    char_u **matches;
    int need_free = 0;
    char_u *p;
    int empty_fnum = 0;
    int alt_fnum = 0;
    buf_T *buf;

    if (eap != ((void *)0))
    {




        for (arg = eap->arg; *arg; ++arg)
        {
            if (*arg == '\n' || *arg == '\r'
                    || (*arg == '|' && arg[1] != '\000' && arg[1] != '|'))
            {
                *arg++ = '\000';
                eap->nextcmd = arg;
                break;
            }
        }
        arg = eap->arg;

        if (eap->skip)
            return;
    }
    else
        arg = (char_u *)"";




    if (*arg != '\000')
    {

        p = arg + strlen((char *)(arg)) - 1;
        while (p > arg && ((*p) == ' ' || (*p) == '\t') && p[-1] != '\\')
            *p-- = '\000';

        n = find_help_tags(arg, &num_matches, &matches);
        if (num_matches == 0 || n == 0)
        {
            emsg2((char_u *)(((char *)("E149: Sorry, no help for %s"))), (char_u *)(arg));
            return;
        }


        arg = vim_strsave(matches[0]);
        need_free = 1;
        FreeWild(num_matches, matches);
    }


    need_mouse_correct = 1;





    if (!curwin->w_buffer->b_help)
    {

        for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
            if (wp->w_buffer != ((void *)0) && wp->w_buffer->b_help)
                break;
        if (wp != ((void *)0) && wp->w_buffer->b_nwindows > 0)
            win_enter(wp, 1);
        else

        {




            if ((helpfd = fopen(((char *)p_hf), ("r"))) == ((void *)0))
            {
                msg_str((char_u *)((char *)("Sorry, help file \"%s\" not found")),
                                                                        p_hf);
                goto erret;
            }
            fclose(helpfd);




            n = 16;

            if (cmdmod.split == 0 && curwin->w_width != Columns
                                                      && curwin->w_width < 80)
                n |= 4;

            if (win_split(0, n) == 0)




                goto erret;


            if (curwin->w_height < p_hh)
                win_setheight((int)p_hh);







            alt_fnum = curbuf->b_fnum;
            (void)do_ecmd(0, ((void *)0), ((void *)0), ((void *)0), (linenr_T)0,
                                                   0x01 + 0x02);
            curwin->w_alt_fnum = alt_fnum;
            empty_fnum = curbuf->b_fnum;
        }
    }

    if (!p_im)
        restart_edit = 0;

    if (arg == ((void *)0) || *arg == '\000')
    {
        arg = (char_u *)"help.txt";
        need_free = 0;
    }
    do_tag(arg, 8, 1, 0, 1);


    if (empty_fnum != 0 && curbuf->b_fnum != empty_fnum)
    {
        buf = buflist_findnr(empty_fnum);
        if (buf != ((void *)0))
            wipe_buffer(buf, 1);
    }


    if (alt_fnum != 0 && curwin->w_alt_fnum == empty_fnum)
        curwin->w_alt_fnum = alt_fnum;







    p =



            (char_u *)"!-~,^*,^|,^\"";

    if (strcmp((char *)(curbuf->b_p_isk), (char *)(p)) != 0)
    {
        set_string_option_direct((char_u *)"isk", -1, p, 1|4);
        check_buf_options(curbuf);
        (void)buf_init_chartab(curbuf, 0);
    }

    curbuf->b_p_ts = 8;
    curwin->w_onebuf_opt.wo_list = 0;

erret:
    if (need_free)
        vim_free(arg);
}
# 4665 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    int help_heuristic(matched_string, offset, wrong_case)
    char_u *matched_string;
    int offset;
    int wrong_case;
{
    int num_letters;
    char_u *p;

    num_letters = 0;
    for (p = matched_string; *p; p++)
        if (((*p) < 0x7f && (__ctype_b[(int) ((*p))] & (unsigned short int) _ISalnum)))
            num_letters++;
    if (((matched_string[offset]) < 0x7f && (__ctype_b[(int) ((matched_string[offset]))] & (unsigned short int) _ISalnum)) && offset > 0
                                 && ((matched_string[offset - 1]) < 0x7f && (__ctype_b[(int) ((matched_string[offset - 1]))] & (unsigned short int) _ISalnum)))
        offset += 10000;
    else if (offset > 2)
        offset *= 200;
    if (wrong_case)
        offset += 5000;


    if (matched_string[0] == '+' && matched_string[1] != '\000')
        offset += 100;
    return (int)(100 * num_letters + strlen((char *)(matched_string)) + offset);
}
# 4709 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    static int help_compare(s1, s2)
    const void *s1;
    const void *s2;
{
    char *p1;
    char *p2;

    p1 = *(char **)s1 + strlen(*(char **)s1) + 1;
    p2 = *(char **)s2 + strlen(*(char **)s2) + 1;
    return strcmp(p1, p2);
}
# 4727 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    int find_help_tags(arg, num_matches, matches)
    char_u *arg;
    int *num_matches;
    char_u ***matches;
{
    char_u *s, *d;
    int i;
    static char *(mtable[]) = {"*", "g*", "[*", "]*", ":*",
                               "/*", "/\\*", "\"*", "/\\(\\)",
                               "?", ":?", "?<CR>", "g?", "g?g?", "g??",
                               "/\\?", "/\\z(\\)",
                               "[count]", "[quotex]", "[range]",
                               "[pattern]", "\\|", "\\%$"};
    static char *(rtable[]) = {"star", "gstar", "[star", "]star", ":star",
                               "/star", "/\\\\star", "quotestar", "/\\\\(\\\\)",
                               "?", ":?", "?<CR>", "g?", "g?g?", "g??",
                               "/\\\\?", "/\\\\z(\\\\)",
                               "\\[count]", "\\[quotex]", "\\[range]",
                               "\\[pattern]", "\\\\bar", "/\\\\%\\$"};

    d = IObuff;





    for (i = sizeof(mtable) / sizeof(char *); --i >= 0; )
        if (strcmp((char *)(arg), (char *)(mtable[i])) == 0)
        {
            strcpy((char *)(d), (char *)(rtable[i]));
            break;
        }

    if (i < 0)
    {




        if (arg[0] == '\\'
                && ((arg[1] != '\000' && arg[2] == '\000')
                    || ((arg[1] == '%' || arg[1] == '_')
                                          && arg[2] != '\000' && arg[3] == '\000')))
        {
            strcpy((char *)(d), (char *)("/\\\\"));
            strcpy((char *)(d + 3), (char *)(arg + 1));

            if (d[3] == '_' && d[4] == '$')
                strcpy((char *)(d + 4), (char *)("\\$"));
        }
        else
        {

            if (arg[0] == '[' && (arg[1] == ':'
                                         || (arg[1] == '+' && arg[2] == '+')))
              *d++ = '\\';

          for (s = arg; *s; ++s)
          {
            if (d - IObuff > (1024+1) - 10)
                break;
            switch (*s)
            {
                case '|': strcpy((char *)(d), (char *)("bar"));
                            d += 3;
                            continue;
                case '"': strcpy((char *)(d), (char *)("quote"));
                            d += 5;
                            continue;
                case '*': *d++ = '.';
                            break;
                case '?': *d++ = '.';
                            continue;
                case '$':
                case '.':
                case '~': *d++ = '\\';
                            break;
            }






            if (*s < ' ' || (*s == '^' && s[1] && (((s[1]) < 0x7f && (__ctype_b[(int) ((s[1]))] & (unsigned short int) _ISalpha))
                           || vim_strchr((char_u *)"?@[\\]^", s[1]) != ((void *)0))))
            {
                if (d > IObuff && d[-1] != '_')
                    *d++ = '_';
                strcpy((char *)(d), (char *)("CTRL-"));
                d += 5;
                if (*s < ' ')
                {



                    *d++ = *s + '@';

                    if (d[-1] == '\\')
                        *d++ = '\\';
                }
                else
                    *d++ = *++s;
                if (s[1] != '\000' && s[1] != '_')
                    *d++ = '_';
                continue;
            }
            else if (*s == '^')
                *d++ = '\\';





            else if (s[0] == '\\' && s[1] != '\\'
                                               && *arg == '/' && s == arg + 1)
                *d++ = '\\';



            if (strncasecmp((char *)(s), (char *)("CTRL-\\_"), (size_t)(7)) == 0)
            {
                strcpy((char *)(d), (char *)("CTRL-\\\\"));
                d += 7;
                s += 6;
            }

            *d++ = *s;





            if (*s == '\'' && s > arg && *arg == '\'')
                break;
          }
          *d = '\000';
        }
    }

    *matches = (char_u **)"";
    *num_matches = 0;
    if (find_tags(IObuff, num_matches, matches,
        1 | 4 | 2 | 32, (int)(0x7fffffffL)) == 1)




        qsort((void *)*matches, (size_t)*num_matches,
                                              sizeof(char_u *), help_compare)
        ;
    return 1;
}
# 4894 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void fix_help_buffer()
{
    linenr_T lnum;
    char_u *line;
    int in_example = 0;
    int len;
    char_u *p;
    char_u *rt;
    int mustfree;


    set_option_value((char_u *)"ft", 0L, (char_u *)"help", 4);


    if (!syntax_present(curbuf))

    {
        for (lnum = 1; lnum <= curbuf->b_ml.ml_line_count; ++lnum)
        {
            line = ml_get_buf(curbuf, lnum, 0);
            len = (int)strlen((char *)(line));
            if (in_example && len > 0 && !((line[0]) == ' ' || (line[0]) == '\t'))
            {

                if (line[0] == '<')
                {

                    line = ml_get_buf(curbuf, lnum, 1);
                    line[0] = ' ';
                }
                in_example = 0;
            }
            if (!in_example && len > 0)
            {
                if (line[len - 1] == '>' && (len == 1 || line[len - 2] == ' '))
                {

                    line = ml_get_buf(curbuf, lnum, 1);
                    line[len - 1] = ' ';
                    in_example = 1;
                }
                else if (line[len - 1] == '~')
                {

                    line = ml_get_buf(curbuf, lnum, 1);
                    line[len - 1] = ' ';
                }
            }
        }
    }





    if (strcmp((char *)(gettail(curbuf->b_fname)), (char *)("help.txt")) == 0)
    {
        for (lnum = 1; lnum < curbuf->b_ml.ml_line_count; ++lnum)
        {
            line = ml_get_buf(curbuf, lnum, 0);
            if (strstr((char *)line, "*local-additions*") != ((void *)0))
            {


                p = p_rtp;
                while (*p != '\000')
                {
                    copy_option_part(&p, NameBuff, 1024, ",");
                    mustfree = 0;
                    rt = vim_getenv((char_u *)"VIMRUNTIME", &mustfree);
                    if (strcmp((char *)(NameBuff), (char *)(rt)) != 0)
                    {
                        int fcount;
                        char_u **fnames;
                        FILE *fd;
                        char_u *s;
                        int fi;


                        add_pathsep(NameBuff);
                        strcat((char *)(NameBuff), (char *)("doc/*.txt"));
                        if (gen_expand_wildcards(1, &NameBuff, &fcount,
                                             &fnames, 2|32) == 1
                                && fcount > 0)
                        {
                            for (fi = 0; fi < fcount; ++fi)
                            {
                                fd = fopen((char *)fnames[fi], "r");
                                if (fd != ((void *)0))
                                {
                                    vim_fgets(IObuff, (1024+1), fd);
                                    if (IObuff[0] == '*'
                                            && (s = vim_strchr(IObuff + 1, '*'))
                                                                      != ((void *)0))
                                    {


                                        IObuff[0] = '|';
                                        *s = '|';
                                        while (*s != '\000')
                                        {
                                            if (*s == '\r' || *s == '\n')
                                                *s = '\000';
                                            ++s;
                                        }
                                        ml_append(lnum, IObuff, (colnr_T)0,
                                                                       0);
                                        ++lnum;
                                    }
                                    fclose(fd);
                                }
                            }
                            FreeWild(fcount, fnames);
                        }
                    }
                    if (mustfree)
                        vim_free(rt);
                }
                break;
            }
        }
    }
}
# 5023 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_helptags(eap)
    exarg_T *eap;
{
    FILE *fd_tags;
    FILE *fd;
    garray_T ga;
    int filecount;
    char_u **files;
    char_u *p1, *p2;
    int fi;
    char_u *s;
    int i;
    char_u *fname;

    if (!mch_isdir(eap->arg))
    {
        emsg2((char_u *)(((char *)("E150: Not a directory: %s"))), (char_u *)(eap->arg));
        return;
    }




    strcpy((char *)(NameBuff), (char *)(eap->arg));
    add_pathsep(NameBuff);
    strcat((char *)(NameBuff), (char *)("*.txt"));
    if (gen_expand_wildcards(1, &NameBuff, &filecount, &files,
                                                    2|32) == 0
            || filecount == 0)
    {
        emsg2((char_u *)("E151: No match: %s"), (char_u *)(NameBuff));
        return;
    }





    strcpy((char *)(NameBuff), (char *)(eap->arg));
    add_pathsep(NameBuff);
    strcat((char *)(NameBuff), (char *)("tags"));
    fd_tags = fopen((char *)NameBuff, "w");
    if (fd_tags == ((void *)0))
    {
        emsg2((char_u *)(((char *)("E152: Cannot open %s for writing"))), (char_u *)(NameBuff));
        FreeWild(filecount, files);
        return;
    }




    ga_init2(&ga, (int)sizeof(char_u *), 100);
    if (fullpathcmp((char_u *)"$VIMRUNTIME/doc", eap->arg, 0) == 1)
    {
        if (ga_grow(&ga, 1) == 0)
            got_int = 1;
        else
        {
            s = vim_strsave((char_u *)"help-tags\ttags\t1\n");
            if (s == ((void *)0))
                got_int = 1;
            else
            {
                ((char_u **)ga.ga_data)[ga.ga_len] = s;
                ++ga.ga_len;
                --ga.ga_room;
            }
        }
    }




    for (fi = 0; fi < filecount && !got_int; ++fi)
    {
        fd = fopen((char *)files[fi], "r");
        if (fd == ((void *)0))
        {
            emsg2((char_u *)(((char *)("E153: Unable to open %s for reading"))), (char_u *)(files[fi]));
            continue;
        }
        fname = gettail(files[fi]);

        while (!vim_fgets(IObuff, (1024+1), fd) && !got_int)
        {
            p1 = vim_strchr(IObuff, '*');
            while (p1 != ((void *)0))
            {
                p2 = vim_strchr(p1 + 1, '*');
                if (p2 != ((void *)0) && p2 > p1 + 1)
                {
                    for (s = p1 + 1; s < p2; ++s)
                        if (*s == ' ' || *s == '\t' || *s == '|')
                            break;






                    if (s == p2
                            && (p1 == IObuff || p1[-1] != '-')
                            && (vim_strchr((char_u *)" \t\n\r", s[1]) != ((void *)0)
                                || s[1] == '\0'))
                    {
                        *p2 = '\0';
                        ++p1;
                        if (ga_grow(&ga, 1) == 0)
                        {
                            got_int = 1;
                            break;
                        }
                        s = alloc((unsigned)(p2 - p1 + strlen((char *)(fname)) + 2));
                        if (s == ((void *)0))
                        {
                            got_int = 1;
                            break;
                        }
                        ((char_u **)ga.ga_data)[ga.ga_len] = s;
                        ++ga.ga_len;
                        --ga.ga_room;
                        sprintf((char *)s, "%s\t%s", p1, fname);


                        p2 = vim_strchr(p2 + 1, '*');
                    }
                }
                p1 = p2;
            }
            line_breakcheck();
        }

        fclose(fd);
    }

    FreeWild(filecount, files);

    if (!got_int)
    {



        sort_strings((char_u **)ga.ga_data, ga.ga_len);




        for (i = 1; i < ga.ga_len; ++i)
        {
            p1 = ((char_u **)ga.ga_data)[i - 1];
            p2 = ((char_u **)ga.ga_data)[i];
            while (*p1 == *p2)
            {
                if (*p2 == '\t')
                {
                    *p2 = '\000';
                    sprintf((char *)NameBuff,
                            ((char *)("E154: Duplicate tag \"%s\" in file %s")),
                            ((char_u **)ga.ga_data)[i], p2 + 1);
                    emsg((char_u *)(NameBuff));
                    *p2 = '\t';
                    break;
                }
                ++p1;
                ++p2;
            }
        }




        for (i = 0; i < ga.ga_len; ++i)
        {
            s = ((char_u **)ga.ga_data)[i];
            if (strncmp((char *)(s), (char *)("help-tags\t"), (size_t)(10)) == 0)

                fprintf(fd_tags, (char *)s);
            else
            {
                fprintf(fd_tags, "%s\t/*", s);
                for (p1 = s; *p1 != '\t'; ++p1)
                {

                    if (*p1 == '\\' || *p1 == '/')
                        _IO_putc ('\\', fd_tags);
                    _IO_putc (*p1, fd_tags);
                }
                fprintf(fd_tags, "*\n");
            }
        }
    }

    for (i = 0; i < ga.ga_len; ++i)
        vim_free(((char_u **)ga.ga_data)[i]);
    ga_clear(&ga);
    fclose(fd_tags);
}
# 5246 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static sign_T *first_sign = ((void *)0);
# 5247 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static int last_sign_typenr = 255;
# 5249 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
static void sign_list_defined (sign_T *sp);
# 5255 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_sign(eap)
    exarg_T *eap;
{
    char_u *arg = eap->arg;
    char_u *p;
    int idx;
    sign_T *sp;
    sign_T *sp_prev;
    buf_T *buf;
    static char *cmds[] = {
                        "define",

                        "undefine",

                        "list",

                        "place",

                        "unplace",

                        "jump",


    };


    p = skiptowhite(arg);
    if (*p != '\000')
        *p++ = '\000';
    for (idx = 0; ; ++idx)
    {
        if (idx == 6)
        {
            emsg2((char_u *)(((char *)("E160: Unknown sign command: %s"))), (char_u *)(arg));
            return;
        }
        if (strcmp((char *)(arg), (char *)(cmds[idx])) == 0)
            break;
    }
    arg = skipwhite(p);

    if (idx <= 2)
    {



        if (idx == 2 && *arg == '\000')
        {

            for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
                sign_list_defined(sp);
        }
        else if (*arg == '\000')
            emsg((char_u *)(((char *)("E156: Missing sign name"))));
        else
        {
            p = skiptowhite(arg);
            if (*p != '\000')
                *p++ = '\000';
            sp_prev = ((void *)0);
            for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
            {
                if (strcmp((char *)(sp->sn_name), (char *)(arg)) == 0)
                    break;
                sp_prev = sp;
            }
            if (idx == 0)
            {

                if (sp == ((void *)0))
                {

                    sp = (sign_T *)alloc_clear((unsigned)sizeof(sign_T));
                    if (sp == ((void *)0))
                        return;
                    if (sp_prev == ((void *)0))
                        first_sign = sp;
                    else
                        sp_prev->sn_next = sp;
                    sp->sn_name = vim_strnsave(arg, (int)(p - arg));



                    if ((__ctype_b[(int) ((*arg))] & (unsigned short int) _ISdigit))
                        sp->sn_typenr = atoi((char *)arg);
                    else
                    {
                        sign_T *lp;
                        int start = last_sign_typenr;

                        for (lp = first_sign; lp != ((void *)0); lp = lp->sn_next)
                        {
                            if (lp->sn_typenr == last_sign_typenr)
                            {
                                --last_sign_typenr;
                                if (last_sign_typenr == 0)
                                    last_sign_typenr = 255;
                                if (last_sign_typenr == start)
                                {
                                    emsg((char_u *)(((char *)("E612: Too many signs defined"))));
                                    return;
                                }
                                lp = first_sign;
                                continue;
                            }
                        }

                        sp->sn_typenr = last_sign_typenr--;
                        if (last_sign_typenr == 0)
                            last_sign_typenr = 255;
                    }
                }


                for (;;)
                {
                    arg = skipwhite(p);
                    if (*arg == '\000')
                        break;
                    p = skiptowhite_esc(arg);
                    if (strncmp((char *)(arg), (char *)("icon="), (size_t)(5)) == 0)
                    {
                        arg += 5;
                        vim_free(sp->sn_icon);
                        sp->sn_icon = vim_strnsave(arg, (int)(p - arg));
                        backslash_halve(sp->sn_icon);

                        if (gui.in_use)
                        {
                            if (sp->sn_image != ((void *)0))
                                gui_mch_destroy_sign(sp->sn_image);
                            sp->sn_image = gui_mch_register_sign(sp->sn_icon);
                        }

                    }
                    else if (strncmp((char *)(arg), (char *)("text="), (size_t)(5)) == 0)
                    {
                        char_u *s;
                        int cells;
                        int len;

                        arg += 5;
                        {
                            for (s = arg; s < p; ++s)
                                if (!vim_isprintc(*s))
                                    break;
                            cells = s - arg;
                        }

                        if (s != p || cells < 1 || cells > 2)
                        {
                            *p = '\000';
                            emsg2((char_u *)(((char *)("E239: Invalid sign text: %s"))), (char_u *)(arg));
                            return;
                        }

                        vim_free(sp->sn_text);


                        len = p - arg + ((cells == 1) ? 1 : 0);
                        sp->sn_text = vim_strnsave(arg, len);

                        if (sp->sn_text != ((void *)0) && cells == 1)
                            strcpy((char *)(sp->sn_text + len - 1), (char *)(" "));
                    }
                    else if (strncmp((char *)(arg), (char *)("linehl="), (size_t)(7)) == 0)
                    {
                        arg += 7;
                        sp->sn_line_hl = syn_check_group(arg, (int)(p - arg));
                    }
                    else if (strncmp((char *)(arg), (char *)("texthl="), (size_t)(7)) == 0)
                    {
                        arg += 7;
                        sp->sn_text_hl = syn_check_group(arg, (int)(p - arg));
                    }
                    else
                    {
                        emsg2((char_u *)(((char *)(e_invarg2))), (char_u *)(arg));
                        return;
                    }
                }
            }
            else if (sp == ((void *)0))
                emsg2((char_u *)(((char *)("E155: Unknown sign: %s"))), (char_u *)(arg));
            else if (idx == 2)

                sign_list_defined(sp);
            else
            {

                vim_free(sp->sn_name);
                vim_free(sp->sn_icon);

                if (sp->sn_image != ((void *)0))
                    gui_mch_destroy_sign(sp->sn_image);

                vim_free(sp->sn_text);
                if (sp_prev == ((void *)0))
                    first_sign = sp->sn_next;
                else
                    sp_prev->sn_next = sp->sn_next;
                vim_free(sp);
            }
        }
    }
    else
    {
        int id = -1;
        linenr_T lnum = -1;
        char_u *sign_name = ((void *)0);
        char_u *arg1;

        if (*arg == '\000')
        {
            if (idx == 3)
            {

                sign_list_placed(((void *)0));
            }
            else if (idx == 4)
            {

                id = buf_findsign_id(curwin->w_buffer, curwin->w_cursor.lnum);
                if (id > 0)
                {
                    buf_delsign(curwin->w_buffer, id);
                    update_debug_sign(curwin->w_buffer, curwin->w_cursor.lnum);
                }
                else
                    emsg((char_u *)(((char *)("E159: Missing sign number"))));
            }
            else
                emsg((char_u *)(((char *)(e_argreq))));
            return;
        }

        if (idx == 4 && arg[0] == '*' && arg[1] == '\000')
        {

            buf_delete_all_signs();
            return;
        }


        arg1 = arg;
        if ((__ctype_b[(int) ((*arg))] & (unsigned short int) _ISdigit))
        {
            id = getdigits(&arg);
            if (!((*arg) == ' ' || (*arg) == '\t') && *arg != '\000')
            {
                id = -1;
                arg = arg1;
            }
            else
            {
                arg = skipwhite(arg);
                if (idx == 4 && *arg == '\000')
                {

                    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
                        if ((lnum = buf_delsign(buf, id)) != 0)
                            update_debug_sign(buf, lnum);
                    return;
                }
            }
        }





        for (;;)
        {
            if (strncmp((char *)(arg), (char *)("line="), (size_t)(5)) == 0)
            {
                arg += 5;
                lnum = atoi((char *)arg);
                arg = skiptowhite(arg);
            }
            else if (strncmp((char *)(arg), (char *)("name="), (size_t)(5)) == 0)
            {
                arg += 5;
                sign_name = arg;
                arg = skiptowhite(arg);
                if (*arg != '\000')
                    *arg++ = '\000';
            }
            else if (strncmp((char *)(arg), (char *)("file="), (size_t)(5)) == 0)
            {
                arg += 5;
                buf = buflist_findname(arg);
                break;
            }
            else if (strncmp((char *)(arg), (char *)("buffer="), (size_t)(7)) == 0)
            {
                arg += 7;
                buf = buflist_findnr(atoi((char *)arg));
                break;
            }
            else
            {
                emsg((char_u *)(((char *)(e_invarg))));
                return;
            }
            arg = skipwhite(arg);
        }

        if (buf == ((void *)0))
        {
            emsg2((char_u *)(((char *)("E158: Invalid buffer name: %s"))), (char_u *)(arg));
        }
        else if (id <= 0)
        {
            if (lnum >= 0 || sign_name != ((void *)0))
                emsg((char_u *)(((char *)(e_invarg))));
            else

                sign_list_placed(buf);
        }
        else if (idx == 5)
        {

            if (lnum >= 0 || sign_name != ((void *)0))
                emsg((char_u *)(((char *)(e_invarg))));
            else if ((lnum = buf_findsign(buf, id)) > 0)
            {
                if (buf_jump_open_win(buf) != ((void *)0))
                {
                    curwin->w_cursor.lnum = lnum;
                    check_cursor_lnum();
                    beginline(1);
                }
                else
                {
                    char_u *cmd;

                    cmd = alloc((unsigned)strlen((char *)(buf->b_fname)) + 25);
                    if (cmd == ((void *)0))
                        return;
                    sprintf((char *)cmd, "e +%ld %s", (long)lnum, buf->b_fname);
                    do_cmdline_cmd(cmd);
                    vim_free(cmd);
                }

                foldOpenCursor();

            }
            else
                emsgn((char_u *)(((char *)("E157: Invalid sign ID: %ld"))), (long)(id));
        }
        else if (idx == 4)
        {

            if (lnum >= 0 || sign_name != ((void *)0))
                emsg((char_u *)(((char *)(e_invarg))));
            else
            {
                lnum = buf_delsign(buf, id);
                update_debug_sign(buf, lnum);
            }
        }

        else if (sign_name != ((void *)0))
        {
            for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
                if (strcmp((char *)(sp->sn_name), (char *)(sign_name)) == 0)
                    break;
            if (sp == ((void *)0))
            {
                emsg2((char_u *)(((char *)("E155: Unknown sign: %s"))), (char_u *)(sign_name));
                return;
            }
            if (lnum > 0)


                buf_addsign(buf, id, lnum, sp->sn_typenr);
            else

                lnum = buf_change_sign_type(buf, id, sp->sn_typenr);
            update_debug_sign(buf, lnum);
        }
        else
            emsg((char_u *)(((char *)(e_invarg))));
    }
}
# 5661 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void sign_gui_started()
{
    sign_T *sp;

    for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
        if (sp->sn_icon != ((void *)0))
            sp->sn_image = gui_mch_register_sign(sp->sn_icon);
}
# 5675 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    static void sign_list_defined(sp)
    sign_T *sp;
{
    char_u *p;

    smsg((char_u *)"sign %s", sp->sn_name);
    if (sp->sn_icon != ((void *)0))
    {
        msg_puts((char_u *)(" icon="));
        msg_outtrans(sp->sn_icon);

        if (sp->sn_image == ((void *)0))
            msg_puts((char_u *)(" (NOT FOUND)"));



    }
    if (sp->sn_text != ((void *)0))
    {
        msg_puts((char_u *)(" text="));
        msg_outtrans(sp->sn_text);
    }
    if (sp->sn_line_hl > 0)
    {
        msg_puts((char_u *)(" linehl="));
        p = get_highlight_name(((void *)0), sp->sn_line_hl - 1);
        if (p == ((void *)0))
            msg_puts((char_u *)("NONE"));
        else
            msg_puts(p);
    }
    if (sp->sn_text_hl > 0)
    {
        msg_puts((char_u *)(" texthl="));
        p = get_highlight_name(((void *)0), sp->sn_text_hl - 1);
        if (p == ((void *)0))
            msg_puts((char_u *)("NONE"));
        else
            msg_puts(p);
    }
}
# 5722 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    int sign_get_attr(typenr, line)
    int typenr;
    int line;
{
    sign_T *sp;

    for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
        if (sp->sn_typenr == typenr)
        {
            if (line)
            {
                if (sp->sn_line_hl > 0)
                    return syn_id2attr(sp->sn_line_hl);
            }
            else
            {
                if (sp->sn_text_hl > 0)
                    return syn_id2attr(sp->sn_text_hl);
            }
            break;
        }
    return 0;
}
# 5751 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    char_u * sign_get_text(typenr)
    int typenr;
{
    sign_T *sp;

    for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
        if (sp->sn_typenr == typenr)
            return sp->sn_text;
    return ((void *)0);
}
# 5764 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void * sign_get_image(typenr)
    int typenr;
{
    sign_T *sp;

    for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
        if (sp->sn_typenr == typenr)
            return sp->sn_image;
    return ((void *)0);
}
# 5780 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    char_u * sign_typenr2name(typenr)
    int typenr;
{
    sign_T *sp;

    for (sp = first_sign; sp != ((void *)0); sp = sp->sn_next)
        if (sp->sn_typenr == typenr)
            return sp->sn_name;
    return (char_u *)((char *)("[Deleted]"));
}
# 5800 "/h/27/yijun/software/vim62/src/ex_cmds.cpp.c"
    void ex_drop(eap)
    exarg_T *eap;
{
    int split = 0;
    int incurwin = 0;
    char_u *arg;
    char_u *first = ((void *)0);
    win_T *wp;
    buf_T *buf;
    arg = vim_strsave(eap->arg);
    if (arg != ((void *)0))
    {

        first = fix_fname(arg);
        if (first != ((void *)0))
        {
            buf = buflist_findname(first);
            for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
            {
                if (wp->w_buffer == buf)
                {
                    incurwin = 1;

                    win_enter(wp, 1);
                    break;

                }
            }
            vim_free(first);

            if (incurwin)
            {

                set_arglist(eap->arg);
                curwin->w_arg_idx = 0;
                vim_free(arg);
                return;
            }
        }
        vim_free(arg);
    }







    if (!(buf_hide(curbuf)))
    {

        ++emsg_off;

        split = check_changed(curbuf, 1, 0, 0, 0);

        --emsg_off;




    }


    if (split)
    {
        eap->cmdidx = CMD_snext;
        eap->cmd[0] = 's';
    }
    else
        eap->cmdidx = CMD_next;
    ex_next(eap);
}
