#include "view.h"
# 21 "/h/27/yijun/software/vim62/src/proto/buffer.pro"
char_u *buflist_nr2name (int n, int fullname, int helptail);
# 62 "/h/27/yijun/software/vim62/src/proto/buffer.pro"
void sign_mark_adjust (linenr_T line1, linenr_T line2, long amount, long amount_after);
# 6 "/h/27/yijun/software/vim62/src/proto/diff.pro"
void diff_mark_adjust (linenr_T line1, linenr_T line2, long amount, long amount_after);
# 36 "/h/27/yijun/software/vim62/src/proto/fold.pro"
void foldMarkAdjust (win_T *wp, linenr_T line1, linenr_T line2, long amount, long amount_after);
# 6 "/h/27/yijun/software/vim62/src/proto/quickfix.pro"
void qf_mark_adjust (linenr_T line1, linenr_T line2, long amount, long amount_after);
# 1211 "/h/27/yijun/software/vim62/src/globals.h"
extern char_u e_markinval[] ;
# 1212 "/h/27/yijun/software/vim62/src/globals.h"
extern char_u e_marknotset[] ;
# 1306 "/h/27/yijun/software/vim62/src/globals.h"
extern char_u e_umark[] ;
# 28 "/h/27/yijun/software/vim62/src/mark.cpp.c"
static xfmark_T namedfm[('z' - 'a' + 1) + 10];
# 30 "/h/27/yijun/software/vim62/src/mark.cpp.c"
static void fname2fnum (xfmark_T *fm);
# 31 "/h/27/yijun/software/vim62/src/mark.cpp.c"
static void fmarks_check_one (xfmark_T *fm, char_u *name, buf_T *buf);
# 32 "/h/27/yijun/software/vim62/src/mark.cpp.c"
static char_u *mark_line (pos_T *mp, int lead_len);
# 33 "/h/27/yijun/software/vim62/src/mark.cpp.c"
static void show_one_mark (int, char_u *, pos_T *, char_u *, int current);
# 35 "/h/27/yijun/software/vim62/src/mark.cpp.c"
static void cleanup_jumplist (void);
# 38 "/h/27/yijun/software/vim62/src/mark.cpp.c"
static void write_one_filemark (FILE *fp, xfmark_T *fm, int c1, int c2);
# 46 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    int setmark(c)
    int c;
{
    int i;


    if (c < 0)
        return 0;

    if (c == '\'' || c == '`')
    {
        setpcmark();

        curwin->w_prev_pcmark = curwin->w_pcmark;
        return 1;
    }


    if (c > 'z')

        return 0;

    if ((__ctype_b[(int) ((c))] & (unsigned short int) _ISlower))
    {
        i = c - 'a';
        curbuf->b_namedm[i] = curwin->w_cursor;
        return 1;
    }
    if ((__ctype_b[(int) ((c))] & (unsigned short int) _ISupper))
    {
        i = c - 'A';
        namedfm[i].fmark.mark = curwin->w_cursor;
        namedfm[i].fmark.fnum = curbuf->b_fnum;
        vim_free(namedfm[i].fname);
        namedfm[i].fname = ((void *)0);
        return 1;
    }
    return 0;
}
# 91 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    void setpcmark()
{

    int i;
    xfmark_T *fm;






    if (global_busy || listcmd_busy)
        return;

    curwin->w_prev_pcmark = curwin->w_pcmark;
    curwin->w_pcmark = curwin->w_cursor;
    if (++curwin->w_jumplistlen > 100)
    {
        curwin->w_jumplistlen = 100;
        vim_free(curwin->w_jumplist[0].fname);
        for (i = 1; i < 100; ++i)
            curwin->w_jumplist[i - 1] = curwin->w_jumplist[i];
    }
    curwin->w_jumplistidx = curwin->w_jumplistlen;
    fm = &curwin->w_jumplist[curwin->w_jumplistlen - 1];

    fm->fmark.mark = curwin->w_pcmark;
    fm->fmark.fnum = curbuf->b_fnum;
    fm->fname = ((void *)0);

}
# 151 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    void checkpcmark()
{
    if (curwin->w_prev_pcmark.lnum != 0
            && ((((curwin->w_pcmark).lnum == (curwin->w_cursor).lnum) && ((curwin->w_pcmark).col == (curwin->w_cursor).col) && ((curwin->w_pcmark).coladd == (curwin->w_cursor).coladd))
                || curwin->w_pcmark.lnum == 0))
    {
        curwin->w_pcmark = curwin->w_prev_pcmark;
        curwin->w_prev_pcmark.lnum = 0;
    }
}
# 167 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    pos_T * movemark(count)
    int count;
{
    pos_T *pos;
    xfmark_T *jmp;

    cleanup_jumplist();

    if (curwin->w_jumplistlen == 0)
        return (pos_T *)((void *)0);

    for (;;)
    {
        if (curwin->w_jumplistidx + count < 0
                || curwin->w_jumplistidx + count >= curwin->w_jumplistlen)
            return (pos_T *)((void *)0);






        if (curwin->w_jumplistidx == curwin->w_jumplistlen)
        {
            setpcmark();
            --curwin->w_jumplistidx;
            if (curwin->w_jumplistidx + count < 0)
                return (pos_T *)((void *)0);
        }

        curwin->w_jumplistidx += count;

        jmp = curwin->w_jumplist + curwin->w_jumplistidx;
        if (jmp->fmark.fnum == 0)
            fname2fnum(jmp);
        if (jmp->fmark.fnum != curbuf->b_fnum)
        {

            if (buflist_findnr(jmp->fmark.fnum) == ((void *)0))
            {
                count += count < 0 ? -1 : 1;
                continue;
            }
            if (buflist_getfile(jmp->fmark.fnum, jmp->fmark.mark.lnum,
                                                            0, 0) == 0)
                return (pos_T *)((void *)0);

            curwin->w_cursor = jmp->fmark.mark;
            pos = (pos_T *)-1;
        }
        else
            pos = &(jmp->fmark.mark);
        return pos;
    }
}
# 233 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    pos_T * getmark(c, changefile)
    int c;
    int changefile;
{
    pos_T *posp;

    pos_T *startp, *endp;

    static pos_T pos_copy;

    posp = ((void *)0);



    if (c < 0)
        return posp;

    if (c > '~')
        ;
    else

        if (c == '\'' || c == '`')
    {
        pos_copy = curwin->w_pcmark;
        posp = &pos_copy;
    }
    else if (c == '"')
        posp = &(curbuf->b_last_cursor);
    else if (c == '^')
        posp = &(curbuf->b_last_insert);
    else if (c == '.')
        posp = &(curbuf->b_last_change);
    else if (c == '[')
        posp = &(curbuf->b_op_start);
    else if (c == ']')
        posp = &(curbuf->b_op_end);
    else if (c == '{' || c == '}')
    {
        pos_T pos;
        oparg_T oa;

        pos = curwin->w_cursor;
        if (findpar(&oa, c == '}' ? 1 : (-1), 1L, '\000', 0))
        {
            pos_copy = curwin->w_cursor;
            posp = &pos_copy;
        }
        curwin->w_cursor = pos;
    }
    else if (c == '(' || c == ')')
    {
        pos_T pos;

        pos = curwin->w_cursor;
        if (findsent(c == ')' ? 1 : (-1), 1L))
        {
            pos_copy = curwin->w_cursor;
            posp = &pos_copy;
        }
        curwin->w_cursor = pos;
    }

    else if (c == '<' || c == '>')
    {
        startp = &curbuf->b_visual_start;
        endp = &curbuf->b_visual_end;
        if ((c == '<') == (((*startp).lnum != (*endp).lnum) ? (*startp).lnum < (*endp).lnum : (*startp).col != (*endp).col ? (*startp).col < (*endp).col : (*startp).coladd < (*endp).coladd))
            posp = startp;
        else
            posp = endp;



        if (curbuf->b_visual_mode == 'V')
        {
            pos_copy = *posp;
            posp = &pos_copy;
            if (c == '<')
                pos_copy.col = 0;
            else
                pos_copy.col = (0x7fffffffL);

            pos_copy.coladd = 0;

        }
    }

    else if (((c) < 0x7f && (__ctype_b[(int) ((c))] & (unsigned short int) _ISlower)))
    {
        posp = &(curbuf->b_namedm[c - 'a']);
    }
    else if (((c) < 0x7f && (__ctype_b[(int) ((c))] & (unsigned short int) _ISupper)) || vim_isdigit(c))
    {
        if (vim_isdigit(c))
            c = c - '0' + ('z' - 'a' + 1);
        else
            c -= 'A';
        posp = &(namedfm[c].fmark.mark);

        if (namedfm[c].fmark.fnum == 0)
            fname2fnum(&namedfm[c]);
        if (namedfm[c].fmark.fnum != curbuf->b_fnum)
        {
            posp = &pos_copy;


            if (namedfm[c].fmark.mark.lnum != 0
                                       && changefile && namedfm[c].fmark.fnum)
            {
                if (buflist_getfile(namedfm[c].fmark.fnum,
                                      (linenr_T)1, 0x01, 0) == 1)
                {

                    curwin->w_cursor = namedfm[c].fmark.mark;
                    return (pos_T *)-1;
                }
                pos_copy.lnum = -1;
            }
            else
                pos_copy.lnum = 0;

        }
    }

    return posp;
}
# 366 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    pos_T * getnextmark(startpos, dir, begin_line)
    pos_T *startpos;
    int dir;
    int begin_line;
{
    int i;
    pos_T *result = ((void *)0);
    pos_T pos;

    pos = *startpos;





    if (dir == (-1) && begin_line)
        pos.col = 0;
    else if (dir == 1 && begin_line)
        pos.col = (0x7fffffffL);

    for (i = 0; i < ('z' - 'a' + 1); i++)
    {
        if (curbuf->b_namedm[i].lnum > 0)
        {
            if (dir == 1)
            {
                if ((result == ((void *)0) || (((curbuf->b_namedm[i]).lnum != (*result).lnum) ? (curbuf->b_namedm[i]).lnum < (*result).lnum : (curbuf->b_namedm[i]).col != (*result).col ? (curbuf->b_namedm[i]).col < (*result).col : (curbuf->b_namedm[i]).coladd < (*result).coladd))
                        && (((pos).lnum != (curbuf->b_namedm[i]).lnum) ? (pos).lnum < (curbuf->b_namedm[i]).lnum : (pos).col != (curbuf->b_namedm[i]).col ? (pos).col < (curbuf->b_namedm[i]).col : (pos).coladd < (curbuf->b_namedm[i]).coladd))
                    result = &curbuf->b_namedm[i];
            }
            else
            {
                if ((result == ((void *)0) || (((*result).lnum != (curbuf->b_namedm[i]).lnum) ? (*result).lnum < (curbuf->b_namedm[i]).lnum : (*result).col != (curbuf->b_namedm[i]).col ? (*result).col < (curbuf->b_namedm[i]).col : (*result).coladd < (curbuf->b_namedm[i]).coladd))
                        && (((curbuf->b_namedm[i]).lnum != (pos).lnum) ? (curbuf->b_namedm[i]).lnum < (pos).lnum : (curbuf->b_namedm[i]).col != (pos).col ? (curbuf->b_namedm[i]).col < (pos).col : (curbuf->b_namedm[i]).coladd < (pos).coladd))
                    result = &curbuf->b_namedm[i];
            }
        }
    }

    return result;
}
# 414 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    static void fname2fnum(fm)
    xfmark_T *fm;
{
    char_u *p;

    if (fm->fname != ((void *)0))
    {




        expand_env(fm->fname, NameBuff, 1024);
        mch_dirname(IObuff, (1024+1));
        p = shorten_fname(NameBuff, IObuff);


        (void)buflist_new(NameBuff, p, (linenr_T)1, 0);
    }
}
# 440 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    void fmarks_check_names(buf)
    buf_T *buf;
{
    char_u *name;
    int i;

    win_T *wp;


    if (buf->b_ffname == ((void *)0))
        return;

    name = home_replace_save(buf, buf->b_ffname);
    if (name == ((void *)0))
        return;

    for (i = 0; i < ('z' - 'a' + 1) + 10; ++i)
        fmarks_check_one(&namedfm[i], name, buf);


    for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
    {
        for (i = 0; i < wp->w_jumplistlen; ++i)
            fmarks_check_one(&wp->w_jumplist[i], name, buf);
    }


    vim_free(name);
}
# 471 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    static void fmarks_check_one(fm, name, buf)
    xfmark_T *fm;
    char_u *name;
    buf_T *buf;
{
    if (fm->fmark.fnum == 0
            && fm->fname != ((void *)0)
            && strcmp((char *)(name), (char *)(fm->fname)) == 0)
    {
        fm->fmark.fnum = buf->b_fnum;
        vim_free(fm->fname);
        fm->fname = ((void *)0);
    }
}
# 491 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    int check_mark(pos)
    pos_T *pos;
{
    if (pos == ((void *)0))
    {
        emsg((char_u *)(((char *)(e_umark))));
        return 0;
    }
    if (pos->lnum <= 0)
    {


        if (pos->lnum == 0)
            emsg((char_u *)(((char *)(e_marknotset))));
        return 0;
    }
    if (pos->lnum > curbuf->b_ml.ml_line_count)
    {
        emsg((char_u *)(((char *)(e_markinval))));
        return 0;
    }
    return 1;
}
# 521 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    void clrallmarks(buf)
    buf_T *buf;
{
    static int i = -1;

    if (i == -1)
        for (i = 0; i < ('z' - 'a' + 1) + 1; i++)
        {
            namedfm[i].fmark.mark.lnum = 0;
            namedfm[i].fname = ((void *)0);
        }

    for (i = 0; i < ('z' - 'a' + 1); i++)
        buf->b_namedm[i].lnum = 0;
    buf->b_op_start.lnum = 0;
    buf->b_op_end.lnum = 0;
    buf->b_last_cursor.lnum = 1;
    buf->b_last_cursor.col = 0;

    buf->b_last_cursor.coladd = 0;

    buf->b_last_insert.lnum = 0;
    buf->b_last_change.lnum = 0;
}
# 552 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    char_u * fm_getname(fmark, lead_len)
    fmark_T *fmark;
    int lead_len;
{
    if (fmark->fnum == curbuf->b_fnum)
        return mark_line(&(fmark->mark), lead_len);
    return buflist_nr2name(fmark->fnum, 0, 1);
}
# 566 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    static char_u * mark_line(mp, lead_len)
    pos_T *mp;
    int lead_len;
{
    char_u *s, *p;
    int len;

    if (mp->lnum == 0 || mp->lnum > curbuf->b_ml.ml_line_count)
        return vim_strsave((char_u *)"-invalid-");
    s = vim_strnsave(skipwhite(ml_get(mp->lnum)), (int)Columns);
    if (s == ((void *)0))
        return ((void *)0);

    len = 0;
    for (p = s; *p != '\000'; ++p)
    {
        len += ptr2cells(p);
        if (len >= Columns - lead_len)
            break;




    }
    *p = '\000';
    return s;
}
# 598 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    void do_marks(eap)
    exarg_T *eap;
{
    char_u *arg = eap->arg;
    int i;
    char_u *name;

    if (arg != ((void *)0) && *arg == '\000')
        arg = ((void *)0);

    show_one_mark('\'', arg, &curwin->w_pcmark, ((void *)0), 1);
    for (i = 0; i < ('z' - 'a' + 1); ++i)
        show_one_mark(i + 'a', arg, &curbuf->b_namedm[i], ((void *)0), 1);
    for (i = 0; i < ('z' - 'a' + 1) + 10; ++i)
    {
        if (namedfm[i].fmark.fnum != 0)
            name = fm_getname(&namedfm[i].fmark, 15);
        else
            name = namedfm[i].fname;
        if (name != ((void *)0))
        {
            show_one_mark(i >= ('z' - 'a' + 1) ? i - ('z' - 'a' + 1) + '0' : i + 'A',
                    arg, &namedfm[i].fmark.mark, name,
                    namedfm[i].fmark.fnum == curbuf->b_fnum);
            if (namedfm[i].fmark.fnum != 0)
                vim_free(name);
        }
    }
    show_one_mark('"', arg, &curbuf->b_last_cursor, ((void *)0), 1);
    show_one_mark('[', arg, &curbuf->b_op_start, ((void *)0), 1);
    show_one_mark(']', arg, &curbuf->b_op_end, ((void *)0), 1);
    show_one_mark('^', arg, &curbuf->b_last_insert, ((void *)0), 1);
    show_one_mark('.', arg, &curbuf->b_last_change, ((void *)0), 1);

    show_one_mark('<', arg, &curbuf->b_visual_start, ((void *)0), 1);
    show_one_mark('>', arg, &curbuf->b_visual_end, ((void *)0), 1);

    show_one_mark(-1, arg, ((void *)0), ((void *)0), 0);
}
# 639 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    static void show_one_mark(c, arg, p, name, current)
    int c;
    char_u *arg;
    pos_T *p;
    char_u *name;
    int current;
{
    static int did_title = 0;
    int mustfree = 0;

    if (c == -1)
    {
        if (did_title)
            did_title = 0;
        else
        {
            if (arg == ((void *)0))
                msg((char_u *)(((char *)("No marks set"))));
            else
                emsg2((char_u *)(((char *)("E283: No marks matching \"%s\""))), (char_u *)(arg));
        }
    }

    else if (!got_int
            && (arg == ((void *)0) || vim_strchr(arg, c) != ((void *)0))
            && p->lnum != 0)
    {
        if (!did_title)
        {

            msg_puts_title((char_u *)(((char *)("\nmark line  col file/text"))));
            did_title = 1;
        }
        msg_putchar('\n');
        if (!got_int)
        {
            sprintf((char *)IObuff, " %c %6ld %4d ", c, p->lnum, p->col);
            msg_outtrans(IObuff);
            if (name == ((void *)0) && current)
            {
                name = mark_line(p, 15);
                mustfree = 1;
            }
            if (name != ((void *)0))
            {
                msg_outtrans_attr(name, current ? highlight_attr[(int)(HLF_D)] : 0);
                if (mustfree)
                    vim_free(name);
            }
        }
        out_flush();
    }
}
# 699 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    void ex_jumps(eap)
    exarg_T *eap;
{
    int i;
    char_u *name;

    cleanup_jumplist();

    msg_puts_title((char_u *)(((char *)("\n jump line  col file/text"))));
    for (i = 0; i < curwin->w_jumplistlen && !got_int; ++i)
    {
        if (curwin->w_jumplist[i].fmark.mark.lnum != 0)
        {
            if (curwin->w_jumplist[i].fmark.fnum == 0)
                fname2fnum(&curwin->w_jumplist[i]);
            name = fm_getname(&curwin->w_jumplist[i].fmark, 16);
            if (name == ((void *)0))
                continue;

            msg_putchar('\n');
            if (got_int)
                break;
            sprintf((char *)IObuff, "%c %2d %5ld %4d ",
                i == curwin->w_jumplistidx ? '>' : ' ',
                i > curwin->w_jumplistidx ? i - curwin->w_jumplistidx
                                          : curwin->w_jumplistidx - i,
                curwin->w_jumplist[i].fmark.mark.lnum,
                curwin->w_jumplist[i].fmark.mark.col);
            msg_outtrans(IObuff);
            msg_outtrans_attr(name,
                            curwin->w_jumplist[i].fmark.fnum == curbuf->b_fnum
                                                        ? highlight_attr[(int)(HLF_D)] : 0);
            vim_free(name);
            ui_breakcheck();
        }
        out_flush();
    }
    if (curwin->w_jumplistidx == curwin->w_jumplistlen)
        msg_puts((char_u *)("\n>"));
}
# 782 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    void mark_adjust(line1, line2, amount, amount_after)
    linenr_T line1;
    linenr_T line2;
    long amount;
    long amount_after;
{
    int i;
    int fnum = curbuf->b_fnum;
    linenr_T *lp;
    win_T *win;

    if (line2 < line1 && amount_after == 0L)
        return;


    for (i = 0; i < ('z' - 'a' + 1); i++)
    {
        { lp = &(curbuf->b_namedm[i].lnum); if (*lp >= line1 && *lp <= line2) { if (amount == (0x7fffffffL)) *lp = 0; else *lp += amount; } else if (amount_after && *lp > line2) *lp += amount_after; };
        if (namedfm[i].fmark.fnum == fnum)
            { lp = &(namedfm[i].fmark.mark.lnum); if (*lp >= line1 && *lp <= line2) { if (amount == (0x7fffffffL)) *lp = 0; else *lp += amount; } else if (amount_after && *lp > line2) *lp += amount_after; };
    }
    for (i = ('z' - 'a' + 1); i < ('z' - 'a' + 1) + 10; i++)
    {
        if (namedfm[i].fmark.fnum == fnum)
            { lp = &(namedfm[i].fmark.mark.lnum); if (*lp >= line1 && *lp <= line2) { if (amount == (0x7fffffffL)) *lp = 0; else *lp += amount; } else if (amount_after && *lp > line2) *lp += amount_after; };
    }


    { lp = &(curwin->w_pcmark.lnum); if (*lp >= line1 && *lp <= line2) { if (amount == (0x7fffffffL)) *lp = 0; else *lp += amount; } else if (amount_after && *lp > line2) *lp += amount_after; };


    { lp = &(curwin->w_prev_pcmark.lnum); if (*lp >= line1 && *lp <= line2) { if (amount == (0x7fffffffL)) *lp = 0; else *lp += amount; } else if (amount_after && *lp > line2) *lp += amount_after; };


    { lp = &(curbuf->b_last_insert.lnum); if (*lp >= line1 && *lp <= line2) { if (amount == (0x7fffffffL)) *lp = 0; else *lp += amount; } else if (amount_after && *lp > line2) *lp += amount_after; };


    { lp = &(curbuf->b_last_change.lnum); if (*lp >= line1 && *lp <= line2) { if (amount == (0x7fffffffL)) *lp = 0; else *lp += amount; } else if (amount_after && *lp > line2) *lp += amount_after; };



    { lp = &(curbuf->b_visual_start.lnum); if (*lp >= line1 && *lp <= line2) { if (amount == (0x7fffffffL)) *lp = line1; else *lp += amount; } else if (amount_after && *lp > line2) *lp += amount_after; };
    { lp = &(curbuf->b_visual_end.lnum); if (*lp >= line1 && *lp <= line2) { if (amount == (0x7fffffffL)) *lp = line1; else *lp += amount; } else if (amount_after && *lp > line2) *lp += amount_after; };




    qf_mark_adjust(line1, line2, amount, amount_after);





    for (win = firstwin; win != ((void *)0); win = win->w_next)
    {



        for (i = 0; i < win->w_jumplistlen; ++i)
            if (win->w_jumplist[i].fmark.fnum == fnum)
                { lp = &(win->w_jumplist[i].fmark.mark.lnum); if (*lp >= line1 && *lp <= line2) { if (amount == (0x7fffffffL)) *lp = line1; else *lp += amount; } else if (amount_after && *lp > line2) *lp += amount_after; };


        if (win->w_buffer == curbuf)
        {

            for (i = 0; i < win->w_tagstacklen; i++)
                if (win->w_tagstack[i].fmark.fnum == fnum)
                    { lp = &(win->w_tagstack[i].fmark.mark.lnum); if (*lp >= line1 && *lp <= line2) { if (amount == (0x7fffffffL)) *lp = line1; else *lp += amount; } else if (amount_after && *lp > line2) *lp += amount_after; };



            if (win->w_old_cursor_lnum != 0)
            {
                { lp = &(win->w_old_cursor_lnum); if (*lp >= line1 && *lp <= line2) { if (amount == (0x7fffffffL)) *lp = line1; else *lp += amount; } else if (amount_after && *lp > line2) *lp += amount_after; };
                { lp = &(win->w_old_visual_lnum); if (*lp >= line1 && *lp <= line2) { if (amount == (0x7fffffffL)) *lp = line1; else *lp += amount; } else if (amount_after && *lp > line2) *lp += amount_after; };
            }




            if (win != curwin)
            {
                if (win->w_topline >= line1 && win->w_topline <= line2)
                {
                    if (amount == (0x7fffffffL))
                    {
                        if (line1 <= 1)
                            win->w_topline = 1;
                        else
                            win->w_topline = line1 - 1;
                    }
                    else
                        win->w_topline += amount;

                    win->w_topfill = 0;

                }
                else if (amount_after && win->w_topline > line2)
                {
                    win->w_topline += amount_after;

                    win->w_topfill = 0;

                }
                if (win->w_cursor.lnum >= line1 && win->w_cursor.lnum <= line2)
                {
                    if (amount == (0x7fffffffL))
                    {
                        if (line1 <= 1)
                            win->w_cursor.lnum = 1;
                        else
                            win->w_cursor.lnum = line1 - 1;
                        win->w_cursor.col = 0;
                    }
                    else
                        win->w_cursor.lnum += amount;
                }
                else if (amount_after && win->w_cursor.lnum > line2)
                    win->w_cursor.lnum += amount_after;
            }



            foldMarkAdjust(win, line1, line2, amount, amount_after);

        }
    }



    diff_mark_adjust(line1, line2, amount, amount_after);



    sign_mark_adjust(line1, line2, amount, amount_after);

}
# 927 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    static void cleanup_jumplist()
{
    int i;
    int from, to;

    to = 0;
    for (from = 0; from < curwin->w_jumplistlen; ++from)
    {
        if (curwin->w_jumplistidx == from)
            curwin->w_jumplistidx = to;
        for (i = from + 1; i < curwin->w_jumplistlen; ++i)
            if (curwin->w_jumplist[i].fmark.fnum
                                        == curwin->w_jumplist[from].fmark.fnum
                    && curwin->w_jumplist[from].fmark.fnum != 0
                    && curwin->w_jumplist[i].fmark.mark.lnum
                                  == curwin->w_jumplist[from].fmark.mark.lnum)
                break;
        if (i >= curwin->w_jumplistlen)
            curwin->w_jumplist[to++] = curwin->w_jumplist[from];
        else
            vim_free(curwin->w_jumplist[from].fname);
    }
    if (curwin->w_jumplistidx == curwin->w_jumplistlen)
        curwin->w_jumplistidx = to;
    curwin->w_jumplistlen = to;
}
# 959 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    void copy_jumplist(from, to)
    win_T *from;
    win_T *to;
{
    int i;

    for (i = 0; i < from->w_jumplistlen; ++i)
    {
        to->w_jumplist[i] = from->w_jumplist[i];
        if (from->w_jumplist[i].fname != ((void *)0))
            to->w_jumplist[i].fname = vim_strsave(from->w_jumplist[i].fname);
    }
    to->w_jumplistlen = from->w_jumplistlen;
    to->w_jumplistidx = from->w_jumplistidx;
}
# 979 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    void free_jumplist(wp)
    win_T *wp;
{
    int i;

    for (i = 0; i < wp->w_jumplistlen; ++i)
        vim_free(wp->w_jumplist[i].fname);
}
# 991 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    void set_last_cursor(win)
    win_T *win;
{
    win->w_buffer->b_last_cursor = win->w_cursor;
}
# 999 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    int read_viminfo_filemark(virp, force)
    vir_T *virp;
    int force;
{
    char_u *str;
    xfmark_T *fm;
    int i;



    str = virp->vir_line + 1;
    if (

            *str <= 127 &&

            ((*virp->vir_line == '\'' && ((__ctype_b[(int) ((*str))] & (unsigned short int) _ISdigit) || (__ctype_b[(int) ((*str))] & (unsigned short int) _ISupper)))
             || (*virp->vir_line == '-' && *str == '\'')))
    {
        if (*str == '\'')
        {


            if (curwin->w_jumplistlen == 100)
                fm = ((void *)0);
            else
            {
                for (i = curwin->w_jumplistlen; i > 0; --i)
                    curwin->w_jumplist[i] = curwin->w_jumplist[i - 1];
                ++curwin->w_jumplistidx;
                ++curwin->w_jumplistlen;
                fm = &curwin->w_jumplist[0];
                fm->fmark.mark.lnum = 0;
                fm->fname = ((void *)0);
            }



        }
        else if ((__ctype_b[(int) ((*str))] & (unsigned short int) _ISdigit))
            fm = &namedfm[*str - '0' + ('z' - 'a' + 1)];
        else
            fm = &namedfm[*str - 'A'];
        if (fm != ((void *)0) && (fm->fmark.mark.lnum == 0 || force))
        {
            str = skipwhite(str + 1);
            fm->fmark.mark.lnum = getdigits(&str);
            str = skipwhite(str);
            fm->fmark.mark.col = getdigits(&str);

            fm->fmark.mark.coladd = 0;

            fm->fmark.fnum = 0;
            str = skipwhite(str);
            vim_free(fm->fname);
            fm->fname = viminfo_readstring(virp, (int)(str - virp->vir_line),
                                                                       0);
        }
    }
    return vim_fgets(virp->vir_line, 512, virp->vir_fd);
}
# 1061 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    void write_viminfo_filemarks(fp)
    FILE *fp;
{
    int i;
    char_u *name;
    buf_T *buf;
    xfmark_T *fm;

    if (get_viminfo_parameter('f') == 0)
        return;

    fprintf(fp, ((char *)("\n# File marks:\n")));







    if (curbuf->b_ffname != ((void *)0) && !removable(curbuf->b_ffname))
    {
        name = buflist_nr2name(curbuf->b_fnum, 1, 0);
        for (i = ('z' - 'a' + 1); i < ('z' - 'a' + 1) + 10 - 1; ++i)
            if (namedfm[i].fmark.mark.lnum == curwin->w_cursor.lnum
                    && (namedfm[i].fname == ((void *)0)
                            ? namedfm[i].fmark.fnum == curbuf->b_fnum
                            : (name != ((void *)0)
                                    && strcmp((char *)(name), (char *)(namedfm[i].fname)) == 0)))
                break;
        vim_free(name);

        vim_free(namedfm[i].fname);
        for ( ; i > ('z' - 'a' + 1); --i)
            namedfm[i] = namedfm[i - 1];
        namedfm[('z' - 'a' + 1)].fmark.mark = curwin->w_cursor;
        namedfm[('z' - 'a' + 1)].fmark.fnum = curbuf->b_fnum;
        namedfm[('z' - 'a' + 1)].fname = ((void *)0);
    }


    for (i = 0; i < ('z' - 'a' + 1) + 10; i++)
        write_one_filemark(fp, &namedfm[i], '\'',
                                     i < ('z' - 'a' + 1) ? i + 'A' : i - ('z' - 'a' + 1) + '0');



    fprintf(fp, ((char *)("\n# Jumplist (newest first):\n")));
    setpcmark();
    cleanup_jumplist();
    for (fm = &curwin->w_jumplist[curwin->w_jumplistlen - 1];
                                           fm >= &curwin->w_jumplist[0]; --fm)
    {
        if (fm->fmark.fnum == 0
                || ((buf = buflist_findnr(fm->fmark.fnum)) != ((void *)0)
                    && !removable(buf->b_ffname)))
            write_one_filemark(fp, fm, '-', '\'');
    }

}
# 1122 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    static void write_one_filemark(fp, fm, c1, c2)
    FILE *fp;
    xfmark_T *fm;
    int c1;
    int c2;
{
    char_u *name;

    if (fm->fmark.mark.lnum == 0)
        return;

    if (fm->fmark.fnum != 0)
        name = buflist_nr2name(fm->fmark.fnum, 1, 0);
    else
        name = fm->fname;
    if (name == ((void *)0) || *name == '\000')
        return;

    fprintf(fp, "%c%c  %ld  %ld  ", c1, c2, (long)fm->fmark.mark.lnum,
                                                    (long)fm->fmark.mark.col);
    viminfo_writestring(fp, name);
    if (fm->fmark.fnum != 0)
        vim_free(name);
}
# 1151 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    int removable(name)
    char_u *name;
{
    char_u *p;
    char_u part[51];
    int retval = 0;

    name = home_replace_save(((void *)0), name);
    if (name != ((void *)0))
    {
        for (p = p_viminfo; *p; )
        {
            copy_option_part(&p, part, 51, ", ");
            if (part[0] == 'r'
                        && strncasecmp((char *)((part + 1)), (char *)((name)), (size_t)((strlen((char *)(part + 1))))) == 0)
            {
                retval = 1;
                break;
            }
        }
        vim_free(name);
    }
    return retval;
}
# 1176 "/h/27/yijun/software/vim62/src/mark.cpp.c"
static void write_one_mark (FILE *fp_out, int c, pos_T *pos);
# 1183 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    int write_viminfo_marks(fp_out)
    FILE *fp_out;
{
    int count;
    buf_T *buf;
    int is_mark_set;
    int i;

    win_T *win;




    for (win = firstwin; win != ((void *)0); win = win->w_next)
        set_last_cursor(win);




    fprintf(fp_out, ((char *)("\n# History of marks within files (newest to oldest):\n")));
    count = 0;
    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
    {




        if (buf->b_marks_read)
        {
            if (buf->b_last_cursor.lnum != 0)
                is_mark_set = 1;
            else
            {
                is_mark_set = 0;
                for (i = 0; i < ('z' - 'a' + 1); i++)
                    if (buf->b_namedm[i].lnum != 0)
                    {
                        is_mark_set = 1;
                        break;
                    }
            }
            if (is_mark_set && buf->b_ffname != ((void *)0)
                      && buf->b_ffname[0] != '\000' && !removable(buf->b_ffname))
            {
                home_replace(((void *)0), buf->b_ffname, IObuff, (1024+1), 1);
                fprintf(fp_out, "\n> ");
                viminfo_writestring(fp_out, IObuff);
                write_one_mark(fp_out, '"', &buf->b_last_cursor);
                write_one_mark(fp_out, '^', &buf->b_last_insert);
                write_one_mark(fp_out, '.', &buf->b_last_change);
                for (i = 0; i < ('z' - 'a' + 1); i++)
                    write_one_mark(fp_out, 'a' + i, &buf->b_namedm[i]);
                count++;
            }
        }
    }

    return count;
}
# 1244 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    static void write_one_mark(fp_out, c, pos)
    FILE *fp_out;
    int c;
    pos_T *pos;
{
    if (pos->lnum != 0)
        fprintf(fp_out, "\t%c\t%ld\t%d\n", c, (long)pos->lnum, (int)pos->col);
}
# 1259 "/h/27/yijun/software/vim62/src/mark.cpp.c"
    void copy_viminfo_marks(virp, fp_out, count, eof)
    vir_T *virp;
    FILE *fp_out;
    int count;
    int eof;
{
    char_u *line = virp->vir_line;
    buf_T *buf;
    int num_marked_files;
    int load_marks;
    int copy_marks_out;
    char_u *str;
    int i;
    char_u *p;
    char_u *name_buf;
    pos_T pos;

    if ((name_buf = alloc(512)) == ((void *)0))
        return;
    num_marked_files = get_viminfo_parameter('\'');
    while (!eof && (count < num_marked_files || fp_out == ((void *)0)))
    {
        if (line[0] != '>')
        {
            if (line[0] != '\n' && line[0] != '\r' && line[0] != '#')
            {
                if (viminfo_error("E576: ", ((char *)("Missing '>'")), line))
                    break;
            }
            eof = vim_fgets(line, 512, virp->vir_fd);
            continue;
        }






        str = skipwhite(line + 1);
        str = viminfo_readstring(virp, (int)(str - virp->vir_line), 0);
        if (str == ((void *)0))
            continue;
        p = str + strlen((char *)(str));
        while (p != str && (*p == '\000' || vim_isspace(*p)))
            p--;
        if (*p)
            p++;
        *p = '\000';





        load_marks = copy_marks_out = 0;
        if (fp_out == ((void *)0))
        {
            if (curbuf->b_ffname != ((void *)0))
            {
                home_replace(((void *)0), curbuf->b_ffname, name_buf, 512, 1);
                if (strcmp((char *)(str), (char *)(name_buf)) == 0)
                    load_marks = 1;
            }
        }
        else
        {

            for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
                if (buf->b_ffname != ((void *)0))
                {
                    home_replace(((void *)0), buf->b_ffname, name_buf, 512, 1);
                    if (strcmp((char *)(str), (char *)(name_buf)) == 0)
                        break;
                }




            if (buf == ((void *)0) || !buf->b_marks_read)
            {
                copy_marks_out = 1;
                fputs("\n> ", fp_out);
                viminfo_writestring(fp_out, str);
                count++;
            }
        }
        vim_free(str);


        pos.coladd = 0;

        while (!(eof = viminfo_readline(virp)) && line[0] == '\011')
        {
            if (load_marks)
            {
                if (line[1] != '\000')
                {
                    sscanf((char *)line + 2, "%ld %u", &pos.lnum, &pos.col);
                    switch (line[1])
                    {
                        case '"': curbuf->b_last_cursor = pos; break;
                        case '^': curbuf->b_last_insert = pos; break;
                        case '.': curbuf->b_last_change = pos; break;
                        default: if ((i = line[1] - 'a') >= 0 && i < ('z' - 'a' + 1))
                                      curbuf->b_namedm[i] = pos;
                    }
                }
            }
            else if (copy_marks_out)
                fputs((char *)line, fp_out);
        }
        if (load_marks)
            break;
    }
    vim_free(name_buf);
}
