typedef unsigned char char_u;
char_u *alloc (unsigned size);
int mch_dirname (char_u *buf, int len);
char_u *shorten_fname (char_u *full_path, char_u *dir_name);
extern char *strcat (char *__restrict __dest, __const char *__restrict __src)
            ;
extern int strcmp (__const char *__s1, __const char *__s2)
             __attribute__ ((__pure__));
extern char *strcpy (char *__restrict __dest, __const char *__restrict __src)
            ;
typedef unsigned int size_t;
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
extern char *strncpy (char *__restrict __dest,
                      __const char *__restrict __src, size_t __n) ;
void vim_free (void *x);
char_u *vim_strchr (char_u *string, int c);
char_u *vim_strsave (char_u *string);
enum CMD_index
{
CMD_append,
CMD_abbreviate,
CMD_abclear,
CMD_aboveleft,
CMD_all,
CMD_amenu,
CMD_anoremenu,
CMD_args,
CMD_argadd,
CMD_argdelete,
CMD_argdo,
CMD_argedit,
CMD_argglobal,
CMD_arglocal,
CMD_argument,
CMD_ascii,
CMD_autocmd,
CMD_augroup,
CMD_aunmenu,
CMD_buffer,
CMD_bNext,
CMD_ball,
CMD_badd,
CMD_bdelete,
CMD_behave,
CMD_belowright,
CMD_bfirst,
CMD_blast,
CMD_bmodified,
CMD_bnext,
CMD_botright,
CMD_bprevious,
CMD_brewind,
CMD_break,
CMD_breakadd,
CMD_breakdel,
CMD_breaklist,
CMD_browse,
CMD_buffers,
CMD_bufdo,
CMD_bunload,
CMD_bwipeout,
CMD_change,
CMD_cNext,
CMD_cabbrev,
CMD_cabclear,
CMD_call,
CMD_catch,
CMD_cc,
CMD_cclose,
CMD_cd,
CMD_center,
CMD_cfile,
CMD_cfirst,
CMD_cgetfile,
CMD_chdir,
CMD_checkpath,
CMD_checktime,
CMD_clist,
CMD_clast,
CMD_close,
CMD_cmap,
CMD_cmapclear,
CMD_cmenu,
CMD_cnext,
CMD_cnewer,
CMD_cnfile,
CMD_cnoremap,
CMD_cnoreabbrev,
CMD_cnoremenu,
CMD_copy,
CMD_colder,
CMD_colorscheme,
CMD_command,
CMD_comclear,
CMD_compiler,
CMD_continue,
CMD_confirm,
CMD_copen,
CMD_cprevious,
CMD_cquit,
CMD_crewind,
CMD_cscope,
CMD_cstag,
CMD_cunmap,
CMD_cunabbrev,
CMD_cunmenu,
CMD_cwindow,
CMD_delete,
CMD_debug,
CMD_debuggreedy,
CMD_delcommand,
CMD_delfunction,
CMD_display,
CMD_diffupdate,
CMD_diffget,
CMD_diffpatch,
CMD_diffput,
CMD_diffsplit,
CMD_diffthis,
CMD_digraphs,
CMD_djump,
CMD_dlist,
CMD_doautocmd,
CMD_doautoall,
CMD_drop,
CMD_dsearch,
CMD_dsplit,
CMD_edit,
CMD_echo,
CMD_echoerr,
CMD_echohl,
CMD_echomsg,
CMD_echon,
CMD_else,
CMD_elseif,
CMD_emenu,
CMD_endif,
CMD_endfunction,
CMD_endtry,
CMD_endwhile,
CMD_enew,
CMD_ex,
CMD_execute,
CMD_exit,
CMD_file,
CMD_files,
CMD_filetype,
CMD_find,
CMD_finally,
CMD_finish,
CMD_first,
CMD_fixdel,
CMD_fold,
CMD_foldclose,
CMD_folddoopen,
CMD_folddoclosed,
CMD_foldopen,
CMD_function,
CMD_global,
CMD_goto,
CMD_grep,
CMD_grepadd,
CMD_gui,
CMD_gvim,
CMD_help,
CMD_helpfind,
CMD_helpgrep,
CMD_helptags,
CMD_hardcopy,
CMD_highlight,
CMD_hide,
CMD_history,
CMD_insert,
CMD_iabbrev,
CMD_iabclear,
CMD_if,
CMD_ijump,
CMD_ilist,
CMD_imap,
CMD_imapclear,
CMD_imenu,
CMD_inoremap,
CMD_inoreabbrev,
CMD_inoremenu,
CMD_intro,
CMD_isearch,
CMD_isplit,
CMD_iunmap,
CMD_iunabbrev,
CMD_iunmenu,
CMD_join,
CMD_jumps,
CMD_k,
CMD_list,
CMD_last,
CMD_language,
CMD_lcd,
CMD_lchdir,
CMD_left,
CMD_leftabove,
CMD_let,
CMD_lmap,
CMD_lmapclear,
CMD_lnoremap,
CMD_loadview,
CMD_loadkeymap,
CMD_lunmap,
CMD_ls,
CMD_move,
CMD_mark,
CMD_make,
CMD_map,
CMD_mapclear,
CMD_marks,
CMD_match,
CMD_menu,
CMD_menutranslate,
CMD_messages,
CMD_mkexrc,
CMD_mksession,
CMD_mkvimrc,
CMD_mkview,
CMD_mode,
CMD_next,
CMD_new,
CMD_nmap,
CMD_nmapclear,
CMD_nmenu,
CMD_nnoremap,
CMD_nnoremenu,
CMD_noremap,
CMD_nohlsearch,
CMD_noreabbrev,
CMD_noremenu,
CMD_normal,
CMD_number,
CMD_nunmap,
CMD_nunmenu,
CMD_open,
CMD_omap,
CMD_omapclear,
CMD_omenu,
CMD_only,
CMD_onoremap,
CMD_onoremenu,
CMD_options,
CMD_ounmap,
CMD_ounmenu,
CMD_print,
CMD_pclose,
CMD_perl,
CMD_perldo,
CMD_pedit,
CMD_pop,
CMD_popup,
CMD_ppop,
CMD_preserve,
CMD_previous,
CMD_promptfind,
CMD_promptrepl,
CMD_psearch,
CMD_ptag,
CMD_ptNext,
CMD_ptfirst,
CMD_ptjump,
CMD_ptlast,
CMD_ptnext,
CMD_ptprevious,
CMD_ptrewind,
CMD_ptselect,
CMD_put,
CMD_pwd,
CMD_python,
CMD_pyfile,
CMD_quit,
CMD_quitall,
CMD_qall,
CMD_read,
CMD_recover,
CMD_redo,
CMD_redir,
CMD_redraw,
CMD_registers,
CMD_resize,
CMD_retab,
CMD_return,
CMD_rewind,
CMD_right,
CMD_rightbelow,
CMD_runtime,
CMD_ruby,
CMD_rubydo,
CMD_rubyfile,
CMD_rviminfo,
CMD_substitute,
CMD_sNext,
CMD_sargument,
CMD_sall,
CMD_saveas,
CMD_sbuffer,
CMD_sbNext,
CMD_sball,
CMD_sbfirst,
CMD_sblast,
CMD_sbmodified,
CMD_sbnext,
CMD_sbprevious,
CMD_sbrewind,
CMD_scriptnames,
CMD_scriptencoding,
CMD_scscope,
CMD_set,
CMD_setfiletype,
CMD_setglobal,
CMD_setlocal,
CMD_sfind,
CMD_sfirst,
CMD_shell,
CMD_simalt,
CMD_sign,
CMD_silent,
CMD_sleep,
CMD_slast,
CMD_smagic,
CMD_snext,
CMD_sniff,
CMD_snomagic,
CMD_source,
CMD_split,
CMD_sprevious,
CMD_srewind,
CMD_stop,
CMD_stag,
CMD_startinsert,
CMD_stopinsert,
CMD_stjump,
CMD_stselect,
CMD_sunhide,
CMD_suspend,
CMD_sview,
CMD_swapname,
CMD_syntax,
CMD_syncbind,
CMD_t,
CMD_tNext,
CMD_tag,
CMD_tags,
CMD_tcl,
CMD_tcldo,
CMD_tclfile,
CMD_tearoff,
CMD_tfirst,
CMD_throw,
CMD_tjump,
CMD_tlast,
CMD_tmenu,
CMD_tnext,
CMD_topleft,
CMD_tprevious,
CMD_trewind,
CMD_try,
CMD_tselect,
CMD_tunmenu,
CMD_undo,
CMD_unabbreviate,
CMD_unhide,
CMD_unlet,
CMD_unmap,
CMD_unmenu,
CMD_update,
CMD_vglobal,
CMD_version,
CMD_verbose,
CMD_vertical,
CMD_visual,
CMD_view,
CMD_vmap,
CMD_vmapclear,
CMD_vmenu,
CMD_vnoremap,
CMD_vnew,
CMD_vnoremenu,
CMD_vsplit,
CMD_vunmap,
CMD_vunmenu,
CMD_write,
CMD_wNext,
CMD_wall,
CMD_while,
CMD_winsize,
CMD_wincmd,
CMD_windo,
CMD_winpos,
CMD_wnext,
CMD_wprevious,
CMD_wq,
CMD_wqall,
CMD_wsverb,
CMD_wviminfo,
CMD_xit,
CMD_xall,
CMD_yank,
CMD_z,
CMD_bang,
CMD_pound,
CMD_and,
CMD_star,
CMD_lshift,
CMD_equal,
CMD_rshift,
CMD_at,
CMD_Next,
CMD_Print,
CMD_X,
CMD_tilde,
    CMD_SIZE,
    CMD_USER = -1,
    CMD_USER_BUF = -2
};
typedef enum CMD_index cmdidx_T;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef struct window win_T;
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef void (*GVoidFunc) (void);
typedef void (*GtkSignalFunc) ();
typedef struct eslist_elem eslist_T;
typedef struct exarg exarg_T;
struct eslist_elem
{
    int saved_emsg_silent;
    eslist_T *next;
};
struct condstack
{
    char cs_flags[50];
    char cs_pending[50];
    union {
        void *cs_pend_rv[50];
        void *cs_pend_ex[50];
    } cs_pend;
    int cs_line[50];
    int cs_idx;
    int cs_whilelevel;
    int cs_trylevel;
    eslist_T *cs_emsg_silent_list;
    char cs_had_while;
    char cs_had_continue;
    char cs_had_endwhile;
    char cs_had_finally;
};
struct exarg
{
    char_u *arg;
    char_u *nextcmd;
    char_u *cmd;
    char_u **cmdlinep;
    cmdidx_T cmdidx;
    long argt;
    int skip;
    int forceit;
    int addr_count;
    linenr_T line1;
    linenr_T line2;
    char_u *do_ecmd_cmd;
    linenr_T do_ecmd_lnum;
    int append;
    int usefilter;
    int amount;
    int regname;
    int force_ff;
    int useridx;
    char_u *errmsg;
    char_u *(*getline) (int, void *, int);
    void *cookie;
    struct condstack *cstack;
};
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
typedef struct frame frame_T;
struct frame
{
    char fr_layout;
    int fr_width;
    int fr_height;
    int fr_newheight;
    frame_T *fr_parent;
    frame_T *fr_next;
    frame_T *fr_prev;
    frame_T *fr_child;
    win_T *fr_win;
};
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef struct
{
    regprog_T *regprog;
    lpos_T startpos[10];
    lpos_T endpos[10];
    int rmm_ic;
} regmmatch_T;
typedef struct filemark
{
    pos_T mark;
    int fnum;
} fmark_T;
typedef struct arglist
{
    garray_T al_ga;
    int al_refcount;
} alist_T;
typedef struct w_line
{
    linenr_T wl_lnum;
    short_u wl_size;
    char wl_valid;
    char wl_folded;
    linenr_T wl_lastlnum;
} wline_T;
typedef struct xfilemark
{
    fmark_T fmark;
    char_u *fname;
} xfmark_T;
typedef struct taggy
{
    char_u *tagname;
    fmark_T fmark;
    int cur_match;
} taggy_T;
struct window
{
    buf_T *w_buffer;
    win_T *w_prev;
    win_T *w_next;
    frame_T *w_frame;
    pos_T w_cursor;
    colnr_T w_curswant;
    int w_set_curswant;
    char w_old_visual_mode;
    linenr_T w_old_cursor_lnum;
    colnr_T w_old_cursor_fcol;
    colnr_T w_old_cursor_lcol;
    linenr_T w_old_visual_lnum;
    colnr_T w_old_curswant;
    linenr_T w_topline;
    int w_topfill;
    int w_old_topfill;
    int w_botfill;
    int w_old_botfill;
    colnr_T w_leftcol;
    colnr_T w_skipcol;
    int w_winrow;
    int w_height;
    int w_status_height;
    int w_wincol;
    int w_width;
    int w_vsep_width;
    int w_valid;
    pos_T w_valid_cursor;
    colnr_T w_valid_leftcol;
    int w_cline_height;
    int w_cline_folded;
    int w_cline_row;
    colnr_T w_virtcol;
    int w_wrow, w_wcol;
    linenr_T w_botline;
    int w_empty_rows;
    int w_filler_rows;
    int w_lines_valid;
    wline_T *w_lines;
    garray_T w_folds;
    char w_fold_manual;
    char w_foldinvalid;
    int w_redr_type;
    int w_upd_rows;
    linenr_T w_redraw_top;
    linenr_T w_redraw_bot;
    int w_redr_status;
    pos_T w_ru_cursor;
    colnr_T w_ru_virtcol;
    linenr_T w_ru_topline;
    int w_ru_topfill;
    char w_ru_empty;
    int w_alt_fnum;
    alist_T *w_alist;
    int w_arg_idx;
    int w_arg_idx_invalid;
    char_u *w_localdir;
    winopt_T w_onebuf_opt;
    winopt_T w_allbuf_opt;
    long w_scbind_pos;
    garray_T w_vars;
    pos_T w_pcmark;
    pos_T w_prev_pcmark;
    xfmark_T w_jumplist[100];
    int w_jumplistlen;
    int w_jumplistidx;
    regmmatch_T w_match;
    int w_match_id;
    taggy_T w_tagstack[20];
    int w_tagstackidx;
    int w_tagstacklen;
    int w_fraction;
    int w_prev_fraction_row;
    scrollbar_T w_scrollbars[2];
};
extern win_T *curwin;
int do_cmdline_cmd (char_u *cmd);
extern int p_ic;
void add_pathsep (char_u *p);
extern char_u *p_go;
extern colnr_T preedit_start_col ;
guint gtk_main_level (void);
void gtk_main_quit (void);
int gui_find_bitmap (char_u *name, char_u *buffer, char *ext);
void gui_mch_update (void);
typedef struct VimMenu vimmenu_T;
struct VimMenu
{
    int modes;
    int enabled;
    char_u *name;
    char_u *dname;
    int mnemonic;
    char_u *actext;
    int priority;
    void (*cb)();
    char_u *iconfile;
    int iconidx;
    int icon_builtin;
    char_u *strings[6];
    int noremap[6];
    char silent[6];
    vimmenu_T *children;
    vimmenu_T *parent;
    vimmenu_T *next;
    GtkWidget *id;
    GtkWidget *submenu_id;
    GtkWidget *tearoff_handle;
    GtkWidget *label;
};
extern vimmenu_T *root_menu ;
typedef struct _GdkIC GdkIC;
typedef signed char gint8;
typedef double gdouble;
typedef struct _GList GList;
typedef struct _GdkEventKey GdkEventKey;
typedef enum {
  GDK_VISIBILITY_UNOBSCURED,
  GDK_VISIBILITY_PARTIAL,
  GDK_VISIBILITY_FULLY_OBSCURED
} GdkVisibilityState;
typedef enum
{
  GDK_NOTHING = -1,
  GDK_DELETE = 0,
  GDK_DESTROY = 1,
  GDK_EXPOSE = 2,
  GDK_MOTION_NOTIFY = 3,
  GDK_BUTTON_PRESS = 4,
  GDK_2BUTTON_PRESS = 5,
  GDK_3BUTTON_PRESS = 6,
  GDK_BUTTON_RELEASE = 7,
  GDK_KEY_PRESS = 8,
  GDK_KEY_RELEASE = 9,
  GDK_ENTER_NOTIFY = 10,
  GDK_LEAVE_NOTIFY = 11,
  GDK_FOCUS_CHANGE = 12,
  GDK_CONFIGURE = 13,
  GDK_MAP = 14,
  GDK_UNMAP = 15,
  GDK_PROPERTY_NOTIFY = 16,
  GDK_SELECTION_CLEAR = 17,
  GDK_SELECTION_REQUEST = 18,
  GDK_SELECTION_NOTIFY = 19,
  GDK_PROXIMITY_IN = 20,
  GDK_PROXIMITY_OUT = 21,
  GDK_DRAG_ENTER = 22,
  GDK_DRAG_LEAVE = 23,
  GDK_DRAG_MOTION = 24,
  GDK_DRAG_STATUS = 25,
  GDK_DROP_START = 26,
  GDK_DROP_FINISHED = 27,
  GDK_CLIENT_EVENT = 28,
  GDK_VISIBILITY_NOTIFY = 29,
  GDK_NO_EXPOSE = 30
} GdkEventType;
GdkColormap* gtk_widget_get_colormap (GtkWidget *widget);
struct _GList
{
  gpointer data;
  GList *next;
  GList *prev;
};
struct _GdkEventKey
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  guint32 time;
  guint state;
  guint keyval;
  gint length;
  gchar *string;
};
typedef gint gboolean;
typedef const void *gconstpointer;
typedef void (*__gconv_trans_end_fct) (void *);
typedef int __io_close_fn (void *__cookie);
typedef gpointer (*GCacheNewFunc) (gpointer key);
typedef gpointer (*GCacheDupFunc) (gpointer value);
typedef void (*GCacheDestroyFunc) (gpointer value);
typedef gchar* (*GCompletionFunc) (gpointer);
typedef void (*GDestroyNotify) (gpointer data);
typedef guint (*GHashFunc) (gconstpointer key);
typedef void (*GFreeFunc) (gpointer data);
typedef void (*GHookFunc) (gpointer data);
typedef gboolean (*GHookCheckFunc) (gpointer data);
typedef gboolean (*GSourceFunc) (gpointer data);
typedef void (*GdkDestroyNotify) (gpointer data);
typedef void (*GtkClassInitFunc) (gpointer klass);
typedef gint (*GtkFunction) (gpointer data);
typedef void (*GtkDestroyNotify) (gpointer data);
typedef long glong;
typedef unsigned char guchar;
typedef float gfloat;
typedef enum
{
  G_LOG_FLAG_RECURSION = 1 << 0,
  G_LOG_FLAG_FATAL = 1 << 1,
  G_LOG_LEVEL_ERROR = 1 << 2,
  G_LOG_LEVEL_CRITICAL = 1 << 3,
  G_LOG_LEVEL_WARNING = 1 << 4,
  G_LOG_LEVEL_MESSAGE = 1 << 5,
  G_LOG_LEVEL_INFO = 1 << 6,
  G_LOG_LEVEL_DEBUG = 1 << 7,
  G_LOG_LEVEL_MASK = ~(G_LOG_FLAG_RECURSION | G_LOG_FLAG_FATAL)
} GLogLevelFlags;
void g_free (gpointer mem);
typedef enum
{
  GTK_TYPE_INVALID,
  GTK_TYPE_NONE,
  GTK_TYPE_CHAR,
  GTK_TYPE_UCHAR,
  GTK_TYPE_BOOL,
  GTK_TYPE_INT,
  GTK_TYPE_UINT,
  GTK_TYPE_LONG,
  GTK_TYPE_ULONG,
  GTK_TYPE_FLOAT,
  GTK_TYPE_DOUBLE,
  GTK_TYPE_STRING,
  GTK_TYPE_ENUM,
  GTK_TYPE_FLAGS,
  GTK_TYPE_BOXED,
  GTK_TYPE_POINTER,
  GTK_TYPE_SIGNAL,
  GTK_TYPE_ARGS,
  GTK_TYPE_CALLBACK,
  GTK_TYPE_C_CALLBACK,
  GTK_TYPE_FOREIGN,
  GTK_TYPE_OBJECT
} GtkFundamentalType;
typedef guint GtkType;
typedef struct _GtkTypeObject GtkTypeObject;
typedef struct _GtkTypeClass GtkTypeClass;
typedef struct _GtkArg GtkArg;
typedef enum
{
  GTK_TOPLEVEL = 1 << 4,
  GTK_NO_WINDOW = 1 << 5,
  GTK_REALIZED = 1 << 6,
  GTK_MAPPED = 1 << 7,
  GTK_VISIBLE = 1 << 8,
  GTK_SENSITIVE = 1 << 9,
  GTK_PARENT_SENSITIVE = 1 << 10,
  GTK_CAN_FOCUS = 1 << 11,
  GTK_HAS_FOCUS = 1 << 12,
  GTK_CAN_DEFAULT = 1 << 13,
  GTK_HAS_DEFAULT = 1 << 14,
  GTK_HAS_GRAB = 1 << 15,
  GTK_RC_STYLE = 1 << 16,
  GTK_COMPOSITE_CHILD = 1 << 17,
  GTK_NO_REPARENT = 1 << 18,
  GTK_APP_PAINTABLE = 1 << 19,
  GTK_RECEIVES_DEFAULT = 1 << 20
} GtkWidgetFlags;
typedef struct _GtkContainer GtkContainer;
typedef struct _GtkForm GtkForm;
guint gtk_signal_connect (GtkObject *object,
                                           const gchar *name,
                                           GtkSignalFunc func,
                                           gpointer func_data);
void g_log (const gchar *log_domain,
                                         GLogLevelFlags log_level,
                                         const gchar *format,
                                         ...) __attribute__((format (printf, 3, 4)));
typedef void (*GtkCallbackMarshal) (GtkObject *object,
                                    gpointer data,
                                    guint n_args,
                                    GtkArg *args);
struct _GtkTypeObject
{
  GtkTypeClass *klass;
};
struct _GtkContainer
{
  GtkWidget widget;
  GtkWidget *focus_child;
  guint border_width : 16;
  guint need_resize : 1;
  guint resize_mode : 2;
  guint reallocate_redraws : 1;
  GSList *resize_widgets;
};
GtkType gtk_container_get_type (void);
GtkType gtk_form_get_type(void);
GtkTypeObject* gtk_type_check_object_cast (GtkTypeObject *type_object,
                                                 GtkType cast_type);
struct _GtkForm
{
    GtkContainer container;
    GList *children;
    guint width;
    guint height;
    GdkWindow *bin_window;
    GdkVisibilityState visibility;
    gulong configure_serial;
    gint freeze_count;
};
struct _GtkArg
{
  GtkType type;
  gchar *name;
  union {
    gchar char_data;
    guchar uchar_data;
    gboolean bool_data;
    gint int_data;
    guint uint_data;
    glong long_data;
    gulong ulong_data;
    gfloat float_data;
    gdouble double_data;
    gchar *string_data;
    gpointer pointer_data;
    GtkObject *object_data;
    struct {
      GtkSignalFunc f;
      gpointer d;
    } signal_data;
    struct {
      gint n_args;
      GtkArg *args;
    } args_data;
    struct {
      GtkCallbackMarshal marshal;
      gpointer data;
      GtkDestroyNotify notify;
    } callback_data;
    struct {
      GtkFunction func;
      gpointer func_data;
    } c_callback_data;
    struct {
      gpointer data;
      GtkDestroyNotify notify;
    } foreign_data;
  } d;
};
struct _GtkObjectClass
{
  GtkType type;
  guint *signals;
  guint nsignals;
  guint n_args;
  GSList *construct_args;
  void (*set_arg) (GtkObject *object,
                   GtkArg *arg,
                   guint arg_id);
  void (*get_arg) (GtkObject *object,
                   GtkArg *arg,
                   guint arg_id);
  void (* shutdown) (GtkObject *object);
  void (* destroy) (GtkObject *object);
  void (* finalize) (GtkObject *object);
};
GList* g_list_remove_link (GList *list,
                                 GList *llink);
struct _GtkTypeClass
{
  GtkType type;
}
;
gboolean gtk_type_is_a (GtkType type,
                                                 GtkType is_a_type);
typedef enum
{
  GTK_ACCEL_VISIBLE = 1 << 0,
  GTK_ACCEL_SIGNAL_VISIBLE = 1 << 1,
  GTK_ACCEL_LOCKED = 1 << 2,
  GTK_ACCEL_MASK = 0x07
} GtkAccelFlags;
GtkType gtk_widget_get_type (void);
void gtk_widget_unparent (GtkWidget *widget);
void gtk_widget_realize (GtkWidget *widget);
void gtk_widget_size_request (GtkWidget *widget,
                                           GtkRequisition *requisition);
gchar* g_strdup (const gchar *str);
void gdk_window_raise (GdkWindow *window);
void gdk_window_get_size (GdkWindow *window,
                                          gint *width,
                                          gint *height);
GdkPixmap* gdk_pixmap_colormap_create_from_xpm (
                                         GdkWindow *window,
                                         GdkColormap *colormap,
                                         GdkBitmap **mask,
                                         GdkColor *transparent_color,
                                         const gchar *filename);
GdkFont* gdk_font_ref (GdkFont *font);
void gdk_font_unref (GdkFont *font);
typedef enum
{
  GTK_ORIENTATION_HORIZONTAL,
  GTK_ORIENTATION_VERTICAL
} GtkOrientation;
typedef enum
{
  GTK_RELIEF_NORMAL,
  GTK_RELIEF_HALF,
  GTK_RELIEF_NONE
} GtkReliefStyle;
typedef enum
{
  GTK_TOOLBAR_ICONS,
  GTK_TOOLBAR_TEXT,
  GTK_TOOLBAR_BOTH
} GtkToolbarStyle;
typedef enum
{
  GTK_WINDOW_TOPLEVEL,
  GTK_WINDOW_DIALOG,
  GTK_WINDOW_POPUP
} GtkWindowType;
typedef struct _GtkData GtkData;
void gtk_widget_destroy (GtkWidget *widget);
void gtk_widget_show (GtkWidget *widget);
void gtk_widget_hide (GtkWidget *widget);
void gtk_widget_grab_focus (GtkWidget *widget);
void gtk_widget_set_sensitive (GtkWidget *widget,
                                           gboolean sensitive);
void gtk_widget_set_uposition (GtkWidget *widget,
                                           gint x,
                                           gint y);
void gtk_widget_set_usize (GtkWidget *widget,
                                           gint width,
                                           gint height);
void gtk_container_set_border_width (GtkContainer *container,
                                          guint border_width);
void gtk_container_add (GtkContainer *container,
                                          GtkWidget *widget);
void gtk_form_put(GtkForm * form, GtkWidget * widget,
        gint x, gint y);
typedef struct _GtkBin GtkBin;typedef struct _GtkBox GtkBox;
GtkType gtk_box_get_type (void);
guint gtk_signal_connect_after (GtkObject *object,
                                           const gchar *name,
                                           GtkSignalFunc func,
                                           gpointer func_data);
typedef struct _GtkWindow GtkWindow;
GtkType gtk_window_get_type (void);
GtkWidget* gtk_vbox_new (gboolean homogeneous,
                              gint spacing);
gint gtk_main_iteration_do (gboolean blocking);
typedef struct _GtkTooltips GtkTooltips;
typedef struct _GtkTooltipsData GtkTooltipsData;
typedef enum
{
  GTK_TOOLBAR_SPACE_EMPTY,
  GTK_TOOLBAR_SPACE_LINE
} GtkToolbarSpaceStyle;
typedef struct _GtkToolbar GtkToolbar;
GtkType gtk_toolbar_get_type (void);
extern long p_ghr;
extern char_u *p_wak;
void gui_focus_change (int in_focus);
void gui_gtk_synch_fonts (void);
void gui_mch_mousehide (int hide);
struct _GtkData
{
  GtkObject object;
};
struct _GtkBin
{
  GtkContainer container;
  GtkWidget *child;
};
struct _GtkBox
{
  GtkContainer container;
  GList *children;
  gint16 spacing;
  guint homogeneous : 1;
};
GtkWidget* gtk_window_new (GtkWindowType type);
struct _GtkTooltipsData
{
  GtkTooltips *tooltips;
  GtkWidget *widget;
  gchar *tip_text;
  gchar *tip_private;
  GdkFont *font;
  gint width;
  GList *row;
};
void gtk_box_pack_start (GtkBox *box,
                                        GtkWidget *child,
                                        gboolean expand,
                                        gboolean fill,
                                        guint padding);
void gtk_box_pack_end (GtkBox *box,
                                        GtkWidget *child,
                                        gboolean expand,
                                        gboolean fill,
                                        guint padding);
struct _GtkWindow
{
  GtkBin bin;
  gchar *title;
  gchar *wmclass_name;
  gchar *wmclass_class;
  GtkWindowType type;
  GtkWidget *focus_widget;
  GtkWidget *default_widget;
  GtkWindow *transient_parent;
  gushort resize_count;
  guint allow_shrink : 1;
  guint allow_grow : 1;
  guint auto_shrink : 1;
  guint handling_resize : 1;
  guint position : 2;
  guint use_uposition : 1;
  guint modal : 1;
  guint window_has_focus : 1;
  guint window_has_pointer_focus : 1;
};
struct _GtkTooltips
{
  GtkData data;
  GtkWidget *tip_window;
  GtkTooltipsData *active_tips_data;
  GList *tips_data_list;
  GdkGC *gc;
  GdkColor *foreground;
  GdkColor *background;
  guint delay : 30;
  guint enabled : 1;
  gint timer_tag;
};
void gtk_window_set_title (GtkWindow *window,
                                                const gchar *title);
void gtk_window_set_transient_for (GtkWindow *window,
                                                GtkWindow *parent);
void gtk_window_set_modal (GtkWindow *window,
                                                gboolean modal);
struct _GtkToolbar
{
  GtkContainer container;
  gint num_children;
  GList *children;
  GtkOrientation orientation;
  GtkToolbarStyle style;
  gint space_size;
  GtkToolbarSpaceStyle space_style;
  GtkTooltips *tooltips;
  gint button_maxw;
  gint button_maxh;
  GtkReliefStyle relief;
};
typedef struct _GdkCursor GdkCursor;
typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
typedef struct _GtkAccelGroup GtkAccelGroup;
struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
typedef enum
{
GDK_NUM_GLYPHS = 154,
GDK_X_CURSOR = 0,
GDK_ARROW = 2,
GDK_BASED_ARROW_DOWN = 4,
GDK_BASED_ARROW_UP = 6,
GDK_BOAT = 8,
GDK_BOGOSITY = 10,
GDK_BOTTOM_LEFT_CORNER = 12,
GDK_BOTTOM_RIGHT_CORNER = 14,
GDK_BOTTOM_SIDE = 16,
GDK_BOTTOM_TEE = 18,
GDK_BOX_SPIRAL = 20,
GDK_CENTER_PTR = 22,
GDK_CIRCLE = 24,
GDK_CLOCK = 26,
GDK_COFFEE_MUG = 28,
GDK_CROSS = 30,
GDK_CROSS_REVERSE = 32,
GDK_CROSSHAIR = 34,
GDK_DIAMOND_CROSS = 36,
GDK_DOT = 38,
GDK_DOTBOX = 40,
GDK_DOUBLE_ARROW = 42,
GDK_DRAFT_LARGE = 44,
GDK_DRAFT_SMALL = 46,
GDK_DRAPED_BOX = 48,
GDK_EXCHANGE = 50,
GDK_FLEUR = 52,
GDK_GOBBLER = 54,
GDK_GUMBY = 56,
GDK_HAND1 = 58,
GDK_HAND2 = 60,
GDK_HEART = 62,
GDK_ICON = 64,
GDK_IRON_CROSS = 66,
GDK_LEFT_PTR = 68,
GDK_LEFT_SIDE = 70,
GDK_LEFT_TEE = 72,
GDK_LEFTBUTTON = 74,
GDK_LL_ANGLE = 76,
GDK_LR_ANGLE = 78,
GDK_MAN = 80,
GDK_MIDDLEBUTTON = 82,
GDK_MOUSE = 84,
GDK_PENCIL = 86,
GDK_PIRATE = 88,
GDK_PLUS = 90,
GDK_QUESTION_ARROW = 92,
GDK_RIGHT_PTR = 94,
GDK_RIGHT_SIDE = 96,
GDK_RIGHT_TEE = 98,
GDK_RIGHTBUTTON = 100,
GDK_RTL_LOGO = 102,
GDK_SAILBOAT = 104,
GDK_SB_DOWN_ARROW = 106,
GDK_SB_H_DOUBLE_ARROW = 108,
GDK_SB_LEFT_ARROW = 110,
GDK_SB_RIGHT_ARROW = 112,
GDK_SB_UP_ARROW = 114,
GDK_SB_V_DOUBLE_ARROW = 116,
GDK_SHUTTLE = 118,
GDK_SIZING = 120,
GDK_SPIDER = 122,
GDK_SPRAYCAN = 124,
GDK_STAR = 126,
GDK_TARGET = 128,
GDK_TCROSS = 130,
GDK_TOP_LEFT_ARROW = 132,
GDK_TOP_LEFT_CORNER = 134,
GDK_TOP_RIGHT_CORNER = 136,
GDK_TOP_SIDE = 138,
GDK_TOP_TEE = 140,
GDK_TREK = 142,
GDK_UL_ANGLE = 144,
GDK_UMBRELLA = 146,
GDK_UR_ANGLE = 148,
GDK_WATCH = 150,
GDK_XTERM = 152,
 GDK_LAST_CURSOR,
  GDK_CURSOR_IS_PIXMAP = -1
} GdkCursorType;
typedef long guicolor_T;
  typedef GdkFont *GuiFont;
struct _GdkCursor
{
  GdkCursorType type;
};
typedef struct Gui
{
    int in_focus;
    int in_use;
    int starting;
    int shell_created;
    int dying;
    int dofork;
    int dragged_sb;
    win_T *dragged_wp;
    int pointer_hidden;
    int col;
    int row;
    int cursor_col;
    int cursor_row;
    char cursor_is_valid;
    int num_cols;
    int num_rows;
    int scroll_region_top;
    int scroll_region_bot;
    int scroll_region_left;
    int scroll_region_right;
    int highlight_mask;
    int scrollbar_width;
    int scrollbar_height;
    int left_sbar_x;
    int right_sbar_x;
    char menu_is_active;
    scrollbar_T bottom_sbar;
    int which_scrollbars[3];
    int prev_wrap;
    int char_width;
    int char_height;
    int char_ascent;
    int border_width;
    int border_offset;
    GuiFont norm_font;
    GuiFont bold_font;
    GuiFont ital_font;
    GuiFont boldital_font;
    GuiFont menu_font;
    guicolor_T back_pixel;
    guicolor_T norm_pixel;
    guicolor_T def_back_pixel;
    guicolor_T def_norm_pixel;
    int visibility;
    GdkCursor *blank_pointer;
    char_u *geom;
    GtkWidget *mainwin;
    GtkWidget *formwin;
    GtkWidget *drawarea;
    GtkWidget *menubar;
    GtkWidget *toolbar;
    GdkColor *fgcolor;
    GdkColor *bgcolor;
    GuiFont current_font;
    GdkGC *text_gc;
    GtkAccelGroup *accel_group;
    GtkWidget *fontdlg;
    char_u *fontname;
    GtkWidget *filedlg;
    char_u *browse_fname;
    char *rsrc_input_method;
    char *rsrc_preedit_type_name;
} gui_T;
extern gui_T gui;
typedef struct _GdkRectangle GdkRectangle;
typedef enum
{
  GDK_EXPOSURE_MASK = 1 << 1,
  GDK_POINTER_MOTION_MASK = 1 << 2,
  GDK_POINTER_MOTION_HINT_MASK = 1 << 3,
  GDK_BUTTON_MOTION_MASK = 1 << 4,
  GDK_BUTTON1_MOTION_MASK = 1 << 5,
  GDK_BUTTON2_MOTION_MASK = 1 << 6,
  GDK_BUTTON3_MOTION_MASK = 1 << 7,
  GDK_BUTTON_PRESS_MASK = 1 << 8,
  GDK_BUTTON_RELEASE_MASK = 1 << 9,
  GDK_KEY_PRESS_MASK = 1 << 10,
  GDK_KEY_RELEASE_MASK = 1 << 11,
  GDK_ENTER_NOTIFY_MASK = 1 << 12,
  GDK_LEAVE_NOTIFY_MASK = 1 << 13,
  GDK_FOCUS_CHANGE_MASK = 1 << 14,
  GDK_STRUCTURE_MASK = 1 << 15,
  GDK_PROPERTY_CHANGE_MASK = 1 << 16,
  GDK_VISIBILITY_NOTIFY_MASK = 1 << 17,
  GDK_PROXIMITY_IN_MASK = 1 << 18,
  GDK_PROXIMITY_OUT_MASK = 1 << 19,
  GDK_SUBSTRUCTURE_MASK = 1 << 20,
  GDK_ALL_EVENTS_MASK = 0x0FFFFF
} GdkEventMask;
struct _GdkRectangle
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
typedef struct _GdkPoint GdkPoint;
typedef struct _GdkICAttr GdkICAttr;
typedef enum
{
  GDK_IM_PREEDIT_AREA = 0x0001,
  GDK_IM_PREEDIT_CALLBACKS = 0x0002,
  GDK_IM_PREEDIT_POSITION = 0x0004,
  GDK_IM_PREEDIT_NOTHING = 0x0008,
  GDK_IM_PREEDIT_NONE = 0x0010,
  GDK_IM_PREEDIT_MASK = 0x001f,
  GDK_IM_STATUS_AREA = 0x0100,
  GDK_IM_STATUS_CALLBACKS = 0x0200,
  GDK_IM_STATUS_NOTHING = 0x0400,
  GDK_IM_STATUS_NONE = 0x0800,
  GDK_IM_STATUS_MASK = 0x0f00
} GdkIMStyle;
struct _GdkPoint
{
  gint16 x;
  gint16 y;
};
struct _GdkICAttr
{
  GdkIMStyle style;
  GdkWindow *client_window;
  GdkWindow *focus_window;
  GdkEventMask filter_events;
  GdkPoint spot_location;
  gint line_spacing;
  GdkCursor *cursor;
  GdkFont *preedit_fontset;
  GdkRectangle preedit_area;
  GdkRectangle preedit_area_needed;
  GdkColor preedit_foreground;
  GdkColor preedit_background;
  GdkPixmap *preedit_pixmap;
  GdkColormap *preedit_colormap;
  GdkFont *status_fontset;
  GdkRectangle status_area;
  GdkRectangle status_area_needed;
  GdkColor status_foreground;
  GdkColor status_background;
  GdkPixmap *status_pixmap;
  GdkColormap *status_colormap;
};
void g_list_free (GList *list);
typedef guint32 GdkWChar;
typedef enum
{
  GDK_DECOR_ALL = 1 << 0,
  GDK_DECOR_BORDER = 1 << 1,
  GDK_DECOR_RESIZEH = 1 << 2,
  GDK_DECOR_TITLE = 1 << 3,
  GDK_DECOR_MENU = 1 << 4,
  GDK_DECOR_MINIMIZE = 1 << 5,
  GDK_DECOR_MAXIMIZE = 1 << 6
} GdkWMDecoration;
typedef enum
{
  GDK_FUNC_ALL = 1 << 0,
  GDK_FUNC_RESIZE = 1 << 1,
  GDK_FUNC_MOVE = 1 << 2,
  GDK_FUNC_MINIMIZE = 1 << 3,
  GDK_FUNC_MAXIMIZE = 1 << 4,
  GDK_FUNC_CLOSE = 1 << 5
} GdkWMFunction;
gint gdk_window_get_origin (GdkWindow *window,
                                          gint *x,
                                          gint *y);
GdkPixmap* gdk_pixmap_colormap_create_from_xpm_d (
                                         GdkWindow *window,
                                         GdkColormap *colormap,
                                         GdkBitmap **mask,
                                         GdkColor *transparent_color,
                                         gchar **data);
typedef enum
{
  GTK_EXPAND = 1 << 0,
  GTK_SHRINK = 1 << 1,
  GTK_FILL = 1 << 2
} GtkAttachOptions;
typedef enum
{
  GTK_BUTTONBOX_DEFAULT_STYLE,
  GTK_BUTTONBOX_SPREAD,
  GTK_BUTTONBOX_EDGE,
  GTK_BUTTONBOX_START,
  GTK_BUTTONBOX_END
} GtkButtonBoxStyle;
typedef enum
{
  GTK_SCROLL_NONE,
  GTK_SCROLL_STEP_BACKWARD,
  GTK_SCROLL_STEP_FORWARD,
  GTK_SCROLL_PAGE_BACKWARD,
  GTK_SCROLL_PAGE_FORWARD,
  GTK_SCROLL_JUMP
} GtkScrollType;
GtkAccelGroup* gtk_accel_group_new (void);
void gtk_accel_group_unref (GtkAccelGroup *accel_group);
void gtk_accel_group_attach (GtkAccelGroup *accel_group,
                                                 GtkObject *object);
typedef struct _GtkAdjustment GtkAdjustment;
GtkStyle* gtk_style_copy (GtkStyle *style);
void gtk_style_unref (GtkStyle *style);
GtkWidget* gtk_widget_new (GtkType type,
                                           const gchar *first_arg_name,
                                           ...);
void gtk_widget_show_all (GtkWidget *widget);
void gtk_widget_queue_resize (GtkWidget *widget);
void gtk_widget_add_accelerator (GtkWidget *widget,
                                           const gchar *accel_signal,
                                           GtkAccelGroup *accel_group,
                                           guint accel_key,
                                           guint accel_mods,
                                           GtkAccelFlags accel_flags);
void gtk_widget_remove_accelerator (GtkWidget *widget,
                                           GtkAccelGroup *accel_group,
                                           guint accel_key,
                                           guint accel_mods);
void gtk_widget_grab_default (GtkWidget *widget);
void gtk_widget_get_pointer (GtkWidget *widget,
                                         gint *x,
                                         gint *y);
gint gtk_widget_hide_on_delete (GtkWidget *widget);
void gtk_widget_set_style (GtkWidget *widget,
                                         GtkStyle *style);
GtkStyle* gtk_widget_get_style (GtkWidget *widget);
void gtk_form_move_resize(GtkForm * form, GtkWidget * widget,
        gint x, gint y,
        gint w, gint h);
extern char *index (__const char *__s, int __c) __attribute__ ((__pure__));
typedef struct _GtkMisc GtkMisc;
GtkType gtk_misc_get_type (void);
typedef struct _GtkLabel GtkLabel;
typedef struct _GtkLabelWord GtkLabelWord;
GtkType gtk_label_get_type (void);
GtkWidget* gtk_label_new (const gchar *str);
typedef struct _GtkAccelLabel GtkAccelLabel;
GtkType gtk_accel_label_get_type (void);
GtkWidget* gtk_accel_label_new (const gchar *string);
GtkWidget* gtk_frame_new (const gchar *label);
typedef struct _GtkButtonBox GtkButtonBox;
GtkType gtk_button_box_get_type (void);
typedef struct _GtkButton GtkButton;
GtkWidget* gtk_button_new (void);
GtkWidget* gtk_button_new_with_label (const gchar *label);
guint gtk_signal_connect_object (GtkObject *object,
                                           const gchar *name,
                                           GtkSignalFunc func,
                                           GtkObject *slot_object);
void gtk_signal_handler_block (GtkObject *object,
                                           guint handler_id);
void gtk_signal_handler_unblock (GtkObject *object,
                                           guint handler_id);
typedef struct _GtkToggleButton GtkToggleButton;
GtkType gtk_toggle_button_get_type (void);
typedef struct _GtkCheckButton GtkCheckButton;
GtkWidget* gtk_check_button_new_with_label (const gchar *label);
typedef struct _GtkItem GtkItem;typedef struct _GtkMenuItem GtkMenuItem;
GtkType gtk_menu_item_get_type (void);
GtkWidget* gtk_menu_item_new (void);
typedef struct _GtkRange GtkRange;
GtkType gtk_range_get_type (void);
void gtk_window_set_wmclass (GtkWindow *window,
                                                const gchar *wmclass_name,
                                                const gchar *wmclass_class);
void gtk_window_set_focus (GtkWindow *window,
                                                GtkWidget *focus);
typedef struct _GtkEditable GtkEditable;typedef struct _GtkEntry GtkEntry;
GtkType gtk_entry_get_type (void);
GtkWidget* gtk_entry_new (void);
GtkType gtk_hbox_get_type (void);
GtkWidget* gtk_hbox_new (gboolean homogeneous,
                              gint spacing);
void gtk_grab_add (GtkWidget *widget);
typedef struct _GtkTable GtkTable;
typedef struct _GtkTableRowCol GtkTableRowCol;
GtkType gtk_table_get_type (void);
GtkWidget* gtk_table_new (guint rows,
                                       guint columns,
                                       gboolean homogeneous);
typedef struct _GtkFileSelection GtkFileSelection;
GtkType gtk_file_selection_get_type (void);
GtkWidget* gtk_file_selection_new (const gchar *title);
GtkWidget* gtk_hseparator_new (void);
typedef struct _GtkMenuShell GtkMenuShell;
GtkType gtk_menu_shell_get_type (void);
typedef struct _GtkMenu GtkMenu;
GtkType gtk_menu_get_type (void);
GtkWidget* gtk_menu_new (void);
GtkType gtk_menu_bar_get_type (void);
GtkWidget* gtk_pixmap_new (GdkPixmap *pixmap,
                                  GdkBitmap *mask);
typedef struct _GtkRadioButton GtkRadioButton;
GtkType gtk_radio_button_get_type (void);
GtkWidget* gtk_radio_button_new_with_label (GSList *group,
                                              const gchar *label);
GtkWidget* gtk_tearoff_menu_item_new (void);
void gtk_tooltips_set_tip (GtkTooltips *tooltips,
                                            GtkWidget *widget,
                                            const gchar *tip_text,
                                            const gchar *tip_private);
typedef enum
{
  GTK_TOOLBAR_CHILD_SPACE,
  GTK_TOOLBAR_CHILD_BUTTON,
  GTK_TOOLBAR_CHILD_TOGGLEBUTTON,
  GTK_TOOLBAR_CHILD_RADIOBUTTON,
  GTK_TOOLBAR_CHILD_WIDGET
} GtkToolbarChildType;
typedef struct _GtkToolbarChild GtkToolbarChild;
GtkWidget* gtk_toolbar_insert_item (GtkToolbar *toolbar,
                                        const char *text,
                                        const char *tooltip_text,
                                        const char *tooltip_private_text,
                                        GtkWidget *icon,
                                        GtkSignalFunc callback,
                                        gpointer user_data,
                                        gint position);
void gtk_toolbar_insert_space (GtkToolbar *toolbar,
                                        gint position);
GtkWidget *gtk_vbutton_box_new (void);
GtkWidget* gtk_vseparator_new (void);
typedef enum
{
    VW_POS_MOUSE,
    VW_POS_CENTER,
    VW_POS_TOP_CENTER
}
gui_win_pos_T;
vimmenu_T *gui_find_menu (char_u *path_name);
scrollbar_T *gui_find_scrollbar (long ident);
void gui_drag_scrollbar (scrollbar_T *sb, long value, int still_dragging);
void gui_find_iconfile (char_u *name, char_u *buffer, char *ext);
char_u *get_find_dialog_text (char_u *arg, int *wwordp, int *mcasep);
int gui_do_findrepl (int flags, char_u *find_text, char_u *repl_text, int down);
typedef struct _ButtonData
{
    int *status;
    int index;
    GtkWidget *dialog;
} ButtonData;
typedef struct _CancelData
{
    int *status;
    GtkWidget *dialog;
} CancelData;
typedef struct _SharedFindReplace
{
    GtkWidget *dialog;
    GtkWidget *wword;
    GtkWidget *mcase;
    GtkWidget *up;
    GtkWidget *down;
    GtkWidget *what;
    GtkWidget *with;
    GtkWidget *find;
    GtkWidget *replace;
    GtkWidget *all;
} SharedFindReplace;
void gdk_window_set_decorations (GdkWindow *window,
                                          GdkWMDecoration decorations);
void gdk_window_set_functions (GdkWindow *window,
                                          GdkWMFunction functions);
struct _GtkAdjustment
{
  GtkData data;
  gfloat lower;
  gfloat upper;
  gfloat value;
  gfloat step_increment;
  gfloat page_increment;
  gfloat page_size;
};
struct _GtkMisc
{
  GtkWidget widget;
  gfloat xalign;
  gfloat yalign;
  guint16 xpad;
  guint16 ypad;
};
struct _GtkButtonBox
{
  GtkBox box;
  gint spacing;
  gint child_min_width;
  gint child_min_height;
  gint child_ipad_x;
  gint child_ipad_y;
  GtkButtonBoxStyle layout_style;
};
struct _GtkButton
{
  GtkBin bin;
  GtkWidget *child ;
  guint in_button : 1;
  guint button_down : 1;
  guint relief : 2;
};
struct _GtkItem
{
  GtkBin bin;
};
struct _GtkEditable
{
  GtkWidget widget;
  guint current_pos;
  guint selection_start_pos;
  guint selection_end_pos;
  guint has_selection : 1;
  guint editable : 1;
  guint visible : 1;
  GdkIC *ic;
  GdkICAttr *ic_attr;
  gchar *clipboard_text;
};
struct _GtkTable
{
  GtkContainer container;
  GList *children;
  GtkTableRowCol *rows;
  GtkTableRowCol *cols;
  guint16 nrows;
  guint16 ncols;
  guint16 column_spacing;
  guint16 row_spacing;
  guint homogeneous : 1;
};
struct _GtkFileSelection
{
  GtkWindow window;
  GtkWidget *dir_list;
  GtkWidget *file_list;
  GtkWidget *selection_entry;
  GtkWidget *selection_text;
  GtkWidget *main_vbox;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;
  GtkWidget *help_button;
  GtkWidget *history_pulldown;
  GtkWidget *history_menu;
  GList *history_list;
  GtkWidget *fileop_dialog;
  GtkWidget *fileop_entry;
  gchar *fileop_file;
  gpointer cmpl_state;
  GtkWidget *fileop_c_dir;
  GtkWidget *fileop_del_file;
  GtkWidget *fileop_ren_file;
  GtkWidget *button_area;
  GtkWidget *action_area;
};
struct _GtkMenuShell
{
  GtkContainer container;
  GList *children;
  GtkWidget *active_menu_item;
  GtkWidget *parent_menu_shell;
  guint active : 1;
  guint have_grab : 1;
  guint have_xgrab : 1;
  guint button : 2;
  guint ignore_leave : 1;
  guint menu_flag : 1;
  guint ignore_enter : 1;
  guint32 activate_time;
};
typedef void (*GtkMenuPositionFunc) (GtkMenu *menu,
                                     gint *x,
                                     gint *y,
                                     gpointer user_data);
struct _GtkToolbarChild
{
  GtkToolbarChildType type;
  GtkWidget *widget;
  GtkWidget *icon;
  GtkWidget *label;
};
void gui_gtk_position_in_parent (GtkWidget *parent, GtkWidget *child, gui_win_pos_T where);
void gtk_adjustment_changed (GtkAdjustment *adjustment);
void gtk_misc_set_alignment (GtkMisc *misc,
                                gfloat xalign,
                                gfloat yalign);
struct _GtkLabel
{
  GtkMisc misc;
  gchar *label;
  GdkWChar *label_wc;
  gchar *pattern;
  GtkLabelWord *words;
  guint max_width : 16;
  guint jtype : 2;
  gboolean wrap;
};
void gtk_button_box_set_spacing (GtkButtonBox *widget, gint spacing);
void gtk_button_box_set_layout (GtkButtonBox *widget,
                                GtkButtonBoxStyle layout_style);
struct _GtkToggleButton
{
  GtkButton button;
  guint active : 1;
  guint draw_indicator : 1;
  GdkWindow *event_window;
};
struct _GtkMenuItem
{
  GtkItem item;
  GtkWidget *submenu;
  guint accelerator_signal;
  guint16 toggle_size;
  guint16 accelerator_width;
  guint show_toggle_indicator : 1;
  guint show_submenu_indicator : 1;
  guint submenu_placement : 1;
  guint submenu_direction : 1;
  guint right_justify: 1;
  guint timer;
};
struct _GtkRange
{
  GtkWidget widget;
  GdkWindow *trough;
  GdkWindow *slider;
  GdkWindow *step_forw;
  GdkWindow *step_back;
  gint16 x_click_point;
  gint16 y_click_point;
  guint8 button;
  gint8 digits;
  guint policy : 2;
  guint scroll_type : 3;
  guint in_child : 3;
  guint click_child : 3;
  guint need_timer : 1;
  guint32 timer;
  gfloat old_value;
  gfloat old_lower;
  gfloat old_upper;
  gfloat old_page_size;
  GtkAdjustment *adjustment;
};
GtkWidget* gtk_hscrollbar_new (GtkAdjustment *adjustment);GtkWidget* gtk_vscrollbar_new (GtkAdjustment *adjustment);
struct _GtkEntry
{
  GtkEditable editable;
  GdkWindow *text_area;
  GdkPixmap *backing_pixmap;
  GdkCursor *cursor;
  GdkWChar *text;
  guint16 text_size;
  guint16 text_length;
  guint16 text_max_length;
  gint scroll_offset;
  guint visible : 1;
  guint32 timer;
  guint button;
  gint *char_offset;
  gchar *text_mb;
  guint text_mb_dirty : 1;
  guint use_wchar : 1;
};
void gtk_table_attach (GtkTable *table,
                                       GtkWidget *child,
                                       guint left_attach,
                                       guint right_attach,
                                       guint top_attach,
                                       guint bottom_attach,
                                       GtkAttachOptions xoptions,
                                       GtkAttachOptions yoptions,
                                       guint xpadding,
                                       guint ypadding);
void gtk_table_attach_defaults (GtkTable *table,
                                       GtkWidget *widget,
                                       guint left_attach,
                                       guint right_attach,
                                       guint top_attach,
                                       guint bottom_attach);
void gtk_table_set_row_spacings (GtkTable *table,
                                       guint spacing);
void gtk_table_set_col_spacings (GtkTable *table,
                                       guint spacing);
void gtk_file_selection_set_filename (GtkFileSelection *filesel,
                                                   const gchar *filename);
gchar* gtk_file_selection_get_filename (GtkFileSelection *filesel);
void gtk_menu_shell_insert (GtkMenuShell *menu_shell,
                                   GtkWidget *child,
                                   gint position);
struct _GtkMenu
{
  GtkMenuShell menu_shell;
  GtkWidget *parent_menu_item;
  GtkWidget *old_active_menu_item;
  GtkAccelGroup *accel_group;
  GtkMenuPositionFunc position_func;
  gpointer position_func_data;
  GtkWidget *toplevel;
  GtkWidget *tearoff_window;
  guint torn_off : 1;
};
guint gtk_label_parse_uline (GtkLabel *label,
                                     const gchar *string);
struct _GtkAccelLabel
{
  GtkLabel label;
  guint queue_id;
  guint accel_padding;
  GtkWidget *accel_widget;
  gchar *accel_string;
  guint16 accel_string_width;
};
void gtk_toggle_button_set_active (GtkToggleButton *toggle_button,
                                             gboolean is_active);
struct _GtkCheckButton
{
  GtkToggleButton toggle_button;
};
void gtk_menu_item_set_submenu (GtkMenuItem *menu_item,
                                           GtkWidget *submenu);
void gtk_menu_item_right_justify (GtkMenuItem *menu_item);
GtkAdjustment* gtk_range_get_adjustment (GtkRange *range);
void gtk_entry_set_text (GtkEntry *entry,
                                                 const gchar *text);
void gtk_entry_set_position (GtkEntry *entry,
                                                 gint position);
gchar* gtk_entry_get_text (GtkEntry *entry);
void gtk_entry_select_region (GtkEntry *entry,
                                                 gint start,
                                                 gint end);
void gtk_entry_set_max_length (GtkEntry *entry,
                                                 guint16 max);
void gtk_menu_prepend (GtkMenu *menu,
                                           GtkWidget *child);
void gtk_menu_insert (GtkMenu *menu,
                                           GtkWidget *child,
                                           gint position);
void gtk_menu_popup (GtkMenu *menu,
                                           GtkWidget *parent_menu_shell,
                                           GtkWidget *parent_menu_item,
                                           GtkMenuPositionFunc func,
                                           gpointer data,
                                           guint button,
                                           guint32 activate_time);
void gtk_menu_set_accel_group (GtkMenu *menu,
                                           GtkAccelGroup *accel_group);
GtkAccelGroup* gtk_menu_ensure_uline_accel_group (GtkMenu *menu);
void gtk_accel_label_set_accel_widget (GtkAccelLabel *accel_label,
                                              GtkWidget *accel_widget);
struct _GtkRadioButton
{
  GtkCheckButton check_button;
  GSList *group;
};
GSList* gtk_radio_button_group (GtkRadioButton *radio_button);
int menu_is_menubar (char_u *name);
int menu_is_popup (char_u *name);
int menu_is_toolbar (char_u *name);
void gui_menu_cb (vimmenu_T *menu);
int menu_is_separator (char_u *name);
void xim_reset (void);
typedef enum
{
  GTK_STATE_NORMAL,
  GTK_STATE_ACTIVE,
  GTK_STATE_PRELIGHT,
  GTK_STATE_SELECTED,
  GTK_STATE_INSENSITIVE
} GtkStateType;
static char * alert_xpm[] = {
"34 34 4 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconColor6	m white	c #FFFF00",
"o	s bottomShadowColor	m black	c #5D6069",
"                                  ",
"              ...                 ",
"             .XXX.                ",
"            .XXXXX.o              ",
"            .XXXXX.oo             ",
"           .XXXXXXX.oo            ",
"           .XXXXXXX.oo            ",
"          .XXXXXXXXX.oo           ",
"          .XXXXXXXXX.oo           ",
"         .XXXXXXXXXXX.oo          ",
"         .XXXX...XXXX.oo          ",
"        .XXXX.....XXXX.oo         ",
"        .XXXX.....XXXX.oo         ",
"       .XXXXX.....XXXXX.oo        ",
"       .XXXXX.....XXXXX.oo        ",
"      .XXXXXX.....XXXXXX.oo       ",
"      .XXXXXX.....XXXXXX.oo       ",
"     .XXXXXXXX...XXXXXXXX.oo      ",
"     .XXXXXXXX...XXXXXXXX.oo      ",
"    .XXXXXXXXX...XXXXXXXXX.oo     ",
"    .XXXXXXXXXX.XXXXXXXXXX.oo     ",
"   .XXXXXXXXXXX.XXXXXXXXXXX.oo    ",
"   .XXXXXXXXXXXXXXXXXXXXXXX.oo    ",
"  .XXXXXXXXXXXX..XXXXXXXXXXX.oo   ",
"  .XXXXXXXXXXX....XXXXXXXXXX.oo   ",
" .XXXXXXXXXXXX....XXXXXXXXXXX.oo  ",
" .XXXXXXXXXXXXX..XXXXXXXXXXXX.oo  ",
" .XXXXXXXXXXXXXXXXXXXXXXXXXXX.ooo ",
" .XXXXXXXXXXXXXXXXXXXXXXXXXXX.ooo ",
"  .XXXXXXXXXXXXXXXXXXXXXXXXX.oooo ",
"   .........................ooooo ",
"     ooooooooooooooooooooooooooo  ",
"      ooooooooooooooooooooooooo   ",
"                                  "};
static char * error_xpm[] = {
"34 34 4 1 0 0",
" 	s none	m none	c none",
".	s iconColor3	m black	c #FF0000",
"X	s bottomShadowColor	m black	c #5D6069",
"o	s iconColor2	m white	c #FFFFFF",
"                                  ",
"            ........              ",
"          ............            ",
"        ................          ",
"       ..................         ",
"      ....................X       ",
"     ......................X      ",
"    ........................X     ",
"   .......o..........o.......X    ",
"   ......ooo........ooo......X    ",
"  ......ooooo......ooooo......X   ",
"  .......ooooo....ooooo.......X   ",
" .........ooooo..ooooo.........X  ",
" ..........oooooooooo..........X  ",
" ...........oooooooo...........XX ",
" ............oooooo............XX ",
" ............oooooo............XX ",
" ...........oooooooo...........XX ",
" ..........oooooooooo..........XX ",
" .........ooooo..ooooo.........XX ",
"  .......ooooo....ooooo.......XX  ",
"  ......ooooo......ooooo......XX  ",
"   ......ooo........ooo......XXX  ",
"   .......o..........o.......XX   ",
"    ........................XXX   ",
"     ......................XXX    ",
"     X....................XXX     ",
"      X..................XXX      ",
"       X................XXX       ",
"        XX............XXXX        ",
"          XX........XXXXX         ",
"            XXXXXXXXXXX           ",
"              XXXXXXX             ",
"                                  "};
static char * generic_xpm[] = {
"34 34 4 1 0 0",
" 	s none	m none	c none",
".	s bottomShadowColor	m black	c #5D6069",
"X	s iconColor2	m white	c #FFFFFF",
"o	s iconColor1	m black	c #000000",
"                                  ",
"            ........              ",
"         ...XXXXXXXX...           ",
"       ..XXXXXXXXXXXXXX..         ",
"      .XXXXXXXXXXXXXXXXXX.        ",
"     .XXXXXXXXXXXXXXXXXXXXo       ",
"    .XXXXXXXXXXXXXXXXXXXXXXo      ",
"   .XXXXXXXXXXXXXXXXXXXXXXXXo     ",
"  .XXXXXXXXXXXXXXXXXXXXXXXXXXo    ",
"  .XXXXXXXXXXXXXXXXXXXXXXXXXXo.   ",
" .XXXXXXXXXXXXXXXXXXXXXXXXXXXXo.  ",
" .XXXXXXXXXXXXXXXXXXXXXXXXXXXXo.  ",
" .XXXXXXXXXXXXXXXXXXXXXXXXXXXXo.. ",
" .XXXXXXXXXXXXXXXXXXXXXXXXXXXXo.. ",
" .XXXXXXXXXXXXXXXXXXXXXXXXXXXXo.. ",
" .XXXXXXXXXXXXXXXXXXXXXXXXXXXXo.. ",
" .XXXXXXXXXXXXXXXXXXXXXXXXXXXXo.. ",
"  .XXXXXXXXXXXXXXXXXXXXXXXXXXo... ",
"  .XXXXXXXXXXXXXXXXXXXXXXXXXXo... ",
"   .XXXXXXXXXXXXXXXXXXXXXXXXo...  ",
"    oXXXXXXXXXXXXXXXXXXXXXXo....  ",
"     oXXXXXXXXXXXXXXXXXXXXo....   ",
"      oXXXXXXXXXXXXXXXXXXo....    ",
"       ooXXXXXXXXXXXXXXoo....     ",
"        .oooXXXXXXXXooo.....      ",
"         ...oooXXXXo.......       ",
"           ....oXXXo.....         ",
"              .oXXXo..            ",
"                oXXo..            ",
"                 oXo..            ",
"                  oo..            ",
"                   ...            ",
"                    ..            ",
"                                  "};
static char * info_xpm[] = {
"34 34 4 1 0 0",
" 	s none	m none	c none",
".	s bottomShadowColor	m black	c #5D6069",
"X	s iconColor2	m white	c #FFFFFF",
"o	s iconColor1	m black	c #000000",
"                                  ",
"            ........              ",
"         ...XXXXXXXX...           ",
"       ..XXXXXXXXXXXXXX..         ",
"      .XXXXXXXXXXXXXXXXXX.        ",
"     .XXXXXXXXooooXXXXXXXXo       ",
"    .XXXXXXXXooooooXXXXXXXXo      ",
"   .XXXXXXXXXooooooXXXXXXXXXo     ",
"  .XXXXXXXXXXXooooXXXXXXXXXXXo    ",
"  .XXXXXXXXXXXXXXXXXXXXXXXXXXo.   ",
" .XXXXXXXXXXXXXXXXXXXXXXXXXXXXo.  ",
" .XXXXXXXXXXoooooooXXXXXXXXXXXo.  ",
" .XXXXXXXXXXXXoooooXXXXXXXXXXXo.. ",
" .XXXXXXXXXXXXoooooXXXXXXXXXXXo.. ",
" .XXXXXXXXXXXXoooooXXXXXXXXXXXo.. ",
" .XXXXXXXXXXXXoooooXXXXXXXXXXXo.. ",
" .XXXXXXXXXXXXoooooXXXXXXXXXXXo.. ",
"  .XXXXXXXXXXXoooooXXXXXXXXXXo... ",
"  .XXXXXXXXXXXoooooXXXXXXXXXXo... ",
"   .XXXXXXXXXXoooooXXXXXXXXXo...  ",
"    oXXXXXXXoooooooooXXXXXXo....  ",
"     oXXXXXXXXXXXXXXXXXXXXo....   ",
"      oXXXXXXXXXXXXXXXXXXo....    ",
"       ooXXXXXXXXXXXXXXoo....     ",
"        .oooXXXXXXXXooo.....      ",
"         ...oooXXXXo.......       ",
"           ....oXXXo.....         ",
"              .oXXXo..            ",
"                oXXo..            ",
"                 oXo..            ",
"                  oo..            ",
"                   ...            ",
"                    ..            ",
"                                  "};
static char * quest_xpm[] = {
"34 34 4 1 0 0",
" 	s none	m none	c none",
".	s bottomShadowColor	m black	c #5D6069",
"X	s iconColor2	m white	c #FFFFFF",
"o	s iconColor1	m black	c #000000",
"                                  ",
"            ........              ",
"         ...XXXXXXXX...           ",
"       ..XXXXXXXXXXXXXX..         ",
"      .XXXXXXXXXXXXXXXXXX.        ",
"     .XXXXXXXXoooooXXXXXXXo       ",
"    .XXXXXXXXoXXXXooXXXXXXXo      ",
"   .XXXXXXXXoooXXXXooXXXXXXXo     ",
"  .XXXXXXXXXooooXXXooXXXXXXXXo    ",
"  .XXXXXXXXXXooXXXoooXXXXXXXXo.   ",
" .XXXXXXXXXXXXXXXooooXXXXXXXXXo.  ",
" .XXXXXXXXXXXXXXooooXXXXXXXXXXo.  ",
" .XXXXXXXXXXXXXoooooXXXXXXXXXXo.. ",
" .XXXXXXXXXXXXoooooXXXXXXXXXXXo.. ",
" .XXXXXXXXXXXXoooXXXXXXXXXXXXXo.. ",
" .XXXXXXXXXXXXooXXXXXXXXXXXXXXo.. ",
" .XXXXXXXXXXXXoXXXXXXXXXXXXXXXo.. ",
"  .XXXXXXXXXXXoXXXXXXXXXXXXXXo... ",
"  .XXXXXXXXXXXXXXXXXXXXXXXXXXo... ",
"   .XXXXXXXXXXooXXXXXXXXXXXXo...  ",
"    oXXXXXXXXooooXXXXXXXXXXo....  ",
"     oXXXXXXXXooXXXXXXXXXXo....   ",
"      oXXXXXXXXXXXXXXXXXXo....    ",
"       ooXXXXXXXXXXXXXXoo....     ",
"        .oooXXXXXXXXooo.....      ",
"         ...oooXXXXo.......       ",
"           ....oXXXo.....         ",
"              .oXXXo..            ",
"                oXXo..            ",
"                 oXo..            ",
"                  oo..            ",
"                   ...            ",
"                    ..            ",
"                                  "};
static char * tb_new_xpm[] = {
"18 18 5 1 0 0",
" 	s none	m none	c none",
".	s bottomShadowColor	m black	c #5D6069",
"X	s iconColor2	m none	c #FFFFFF",
"o	s iconColor1	m black	c #000000",
"O	s topShadowColor	m none	c #DCDEE5",
"         .  .X.   ",
"         X. .X. X.",
"  ooooooo.X.oXoX.X",
"  oOOOOOOOoXXXXo..",
"  oOOOOOOOXXXXXXXX",
"  oOOXOOOOoXoXXo..",
"  oOXXOOO.OXoXoX  ",
"  oOOOOO.OOXoX..X ",
"  oOOOOOOOOXoX. .X",
"  oOOOOOOOOXo.   .",
"  oOOOOOOOOXo.    ",
"  oOOOOOOOOXo.    ",
"  oOOOOOOOOXo.    ",
"  oOOOOOOOOXo.    ",
"  oOOOOOOOOXo.    ",
"  oXXXXXXXXXo.    ",
"  ooooooooooo.    ",
"    ..........    "};
static char * tb_open_xpm[] = {
"18 18 7 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s bottomShadowColor	m black	c #5D6069",
"o	s iconColor2	m none	c #FFFFFF",
"O	s iconGray1	m none	c #dedede",
"+	s iconGray5	m black	c #737373",
"@	s iconGray3	m none	c #adadad",
"                  ",
"    .........X    ",
"    .oooooo.o.X   ",
"    .oooooo.oo.X  ",
"    .oooooo....X  ",
"  ...ooooooooo... ",
"  .O.OOOOOOOOo.+. ",
".............O.+.X",
".oooooooooooo..+.X",
" .o@@@@@@@@@@+.+.X",
" .o@@@@@@@@@@@.+.X",
"  .o@@@@@@@@@@+..X",
"  .o@@@@@@@@@@@..X",
"   .o+++++++++++.X",
"   ..............X",
"     XXXXXXXXXXXXX",
"                  ",
"                  "};
static char * tb_close_xpm[] = {
"18 18 7 1 0 0",
" 	s none	m none	c none",
".	c #880000	m black",
"X	s iconColor1	m black	c #000000",
"o	s iconColor3	m black	c #FF0000",
"O	s topShadowColor	m none	c #DCDEE5",
"+	s iconColor2	m none	c #FFFFFF",
"@	s bottomShadowColor	m black	c #5D6069",
"                  ",
"  ..XXXXXXXXX.    ",
" .oo.OOOOOOO.o.   ",
"  .oo.O+OOO.oo.   ",
"   .oo.OOO.oo.@   ",
"   X.oo.O.oo.X@   ",
"   XO.oo.oo.+X@   ",
"   XOO.ooo.O+X@   ",
"   XOO.ooo.O+X@   ",
"   XO.oo.oo.+X@   ",
"   X.oo.O.oo.X@   ",
"   .oo.OOO.oo.@   ",
"  .oo.OOOOO.oo.   ",
" .oo.OOOOOOO.oo.  ",
"  ..+++++++++.o.  ",
"   XXXXXXXXXXX.   ",
"      @@@@@@@@@   ",
"                  "};
static char * tb_save_xpm[] = {
"18 18 5 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconGray2	m none	c #bdbdbd",
"o	s iconColor2	m none	c #FFFFFF",
"O	s bottomShadowColor	m black	c #5D6069",
"                  ",
" ..............   ",
" .X.oooooooo.o.   ",
" .X.oooooooo...O  ",
" .X.oooooooo.X.O  ",
" .X.oooooooo.X.O  ",
" .X.oooooooo.X.O  ",
" .X.oooooooo.X.O  ",
" .XX........XX.O  ",
" .XXXXXXXXXXXX.O  ",
" .XX.........X.O  ",
" .XX......oo.X.O  ",
" .XX......oo.X.O  ",
" .XX......oo.X.O  ",
"  .............O  ",
"   OOOOOOOOOOOOO  ",
"                  ",
"                  "};
static char * tb_print_xpm[] = {
"18 18 7 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconColor2	m none 	c #FFFFFF",
"o	s iconGray2	m none 	c #bdbdbd",
"O	s iconGray5	m black	c #737373",
"+	s bottomShadowColor	m black	c #5D6069",
"@	c #FF1144",
"   .......        ",
"   .XXXXX..       ",
"   .X...X.X.      ",
"   .XXXXX....     ",
"   .X...XXXX.O    ",
"   .XXXXXXXX.O    ",
"   .X.....XX.O    ",
"   .XXXXXXXX.O    ",
"................  ",
".XXXXXXXXXXXXXO.  ",
".X@@ooooooooooO.O ",
".XooooooooooooO.O ",
".XooooooooooooO.O ",
"................O ",
" .OOOOOOOOOOOO.OO ",
" ..............O  ",
"   OOOOOOOOOOOOO  ",
"                  "};
static char * tb_cut_xpm[] = {
"18 18 3 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s bottomShadowColor	m black	c #5D6069",
"                  ",
"     .     .X     ",
"     .X    .X     ",
"      .   .X      ",
"      .X  .X      ",
"       . .X       ",
"       .X.X       ",
"        .X        ",
"       ...X       ",
"     X.X  .X      ",
"    ...X  ...     ",
"   .XX.X  .X .    ",
"   .  .X  .X .X   ",
"   .  .X  .X .X   ",
"    ..XX   ..X    ",
"    XX     XX     ",
"                  ",
"                  "};
static char * tb_copy_xpm[] = {
"18 18 4 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconColor2	m none	c #FFFFFF",
"o	s bottomShadowColor	m black	c #5D6069",
"                  ",
"                  ",
" ..........       ",
" .XXXXXXXX.o      ",
" .X.............  ",
" .XXXX.XXXXXXXX.  ",
" .X....X......X.o ",
" .XXXX.XXXXXXXX.o ",
" .X....X......X.o ",
" .XXXX.XXXXXXXX.o ",
" .X..X.X......X.o ",
" .XXXX.XXXXXXXX.o ",
" ......X..XXXXX.o ",
"  oooo.XXXXXXXX.o ",
"      ..........o ",
"        ooooooooo ",
"                  ",
"                  "};
static char * tb_paste_xpm[] = {
"18 18 7 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconGray5	m black	c #737373",
"o	s iconGray2	m none	c #bdbdbd",
"O	s bottomShadowColor	m black	c #5D6069",
"+	s iconGray4	m none	c #949494",
"@	s iconColor2	m none	c #FFFFFF",
"                  ",
"     ....         ",
"     XXXX         ",
"  ...oooo...O     ",
" .o+......++.O    ",
" .o+++++++++.O    ",
" .o+++..........  ",
" .o+++.@@@@@@@@.  ",
" .o+++.@......@.O ",
" .o+++.@@@@@@@@.O ",
" .o+++.@@@@@@@@.O ",
" .o+++.@......@.O ",
" .o+++.@@@@@@@@.O ",
"  .....@..@@@@@.O ",
"   OOO.@@@@@@@@.O ",
"      ..........O ",
"        OOOOOOOOO ",
"                  "};
static char * tb_find_xpm[] = {
"18 18 5 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconColor2	m none	c #FFFFFF",
"O	s iconGray2	m none	c #bdbdbd",
"+	s bottomShadowColor	m black	c #5D6069",
"                  ",
" .........        ",
" .XXXXXXX..       ",
" .XXXXXXX.O.      ",
" .XXXXXXX....     ",
" .XXXXXXXXXX.     ",
" .XXXXXXX....     ",
" .XXXXXX.OOOO.    ",
" .XXXXX.OXXOOO.   ",
" .XXXXX.OXOOOO.   ",
" .XXXXX.OOOOOO.   ",
" .XXXXX.OOOXOO.   ",
" .XXXXXX.OOOO.+   ",
" .XXXXXXX....+..  ",
" .XXXXXXXXXX.+... ",
" ............+ .. ",
"    ++++++++++    ",
"                  "};
static char * tb_find_next_xpm[] = {
"18 18 7 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconColor2	m none	c #FFFFFF",
"o	s iconGray2	m none	c #bdbdbd",
"O	m black	c #880000",
"+	s bottomShadowColor	m black	c #5D6069",
"@	s iconColor3	m black	c #FF0000",
"                  ",
"  .........       ",
"  .XXXXXXX..      ",
"  .XXXXXXX.o.     ",
"  .XOXXXXX....    ",
"  +XOOXXXXXXX.    ",
"OOOOO@OXXX....    ",
"O@@@@@@OX.oooo.   ",
"O@@@@@@@OoXXooo.  ",
"O@@@@@@O.oXoooo.  ",
"OOOOO@OX.oooooo.  ",
"  +XOOXX.oooXoo.  ",
"  .XOXXXX.oooo.+  ",
"  .XXXXXXX....+.. ",
"  .XXXXXXXXXX.+...",
"  ............+ ..",
"     ++++++++++   ",
"                  "};
static char * tb_find_prev_xpm[] = {
"18 18 7 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconColor2	m none	c #FFFFFF",
"o	s iconGray2	m none	c #bdbdbd",
"O	s bottomShadowColor	m black	c #5D6069",
"+	m black	c #880000",
"@	s iconColor3	m black	c #FF0000",
"                  ",
"  .........       ",
"  .XXXXXXX..      ",
"  .XXXXXXX.o.     ",
"  OX+XXXXX....    ",
"  o++XXXXXXXX.    ",
"  +@+++++X....    ",
" +@@@@@@+.oooo.   ",
"+@@@@@@@.oXXooo.  ",
" +@@@@@@.oXoooo.  ",
"  +@++++.oooooo.  ",
"  o++XXX.oooXoo.  ",
"  OX+XXXX.oooo.O  ",
"  .XXXXXXX....O.. ",
"  .XXXXXXXXXX.O...",
"  ............O ..",
"     OOOOOOOOOO   ",
"                  "};
static char * tb_find_help_xpm[] = {
"18 18 5 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s bottomShadowColor	m black	c #5D6069",
"o	s iconGray2	m none	c #bdbdbd",
"O	s iconColor2	m none	c #FFFFFF",
"                  ",
"                  ",
"    .....X        ",
"   ..  X..X       ",
"  ..X   ...       ",
"  ..X   ....      ",
"  X..  .oOOo.     ",
"      .oooOoo.    ",
"      .OOOOoO.    ",
"     ..oOOooo.    ",
"     ...oOOo.X    ",
"        ....X..   ",
"     ..X     ...  ",
"     ..X      ..  ",
"     ..X          ",
"      XX          ",
"                  ",
"                  "};
static char * tb_exit_xpm[] = {
"18 18 9 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconColor2	m none	c #FFFFFF",
"o	s bottomShadowColor	m black	c #5D6069",
"O	s iconColor3	m black	c #FF0000",
"+	s iconGray3	m none	c #adadad",
"@	s iconGray4	m none	c #949494",
"#	s iconGray5	m black	c #737373",
"$	s iconGray6	m black	c #636363",
"                  ",
"                  ",
"        ........  ",
"        .XXXXXX.o ",
"        .XXXXXX.o ",
"      ...XXXXXX.o ",
"      .O.XXXXXX.o ",
" ......OO.XX..X.o ",
" .OOOOOOOO.X..X.o ",
" .OOOOOOOO.XXXX.o ",
" ......OO.XXXXX.o ",
"      .O.XXXXX+.o ",
"      ...XXXX++.o ",
"        .XX++@#.o ",
"        .X+@##$.o ",
"        ........o ",
"          ooooooo ",
"                  "};
static char * tb_undo_xpm[] = {
"18 18 4 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconColor2	m none	c #FFFFFF",
"o	s bottomShadowColor	m black	c #5D6069",
"                  ",
"                  ",
"  ..  .....       ",
"  .X..XXXXX..     ",
"  .XXXXXXXXXX.    ",
"  .XXXX....XX.o   ",
"  .XXXX.ooo.XX.   ",
"  .XXXXX.  .XX.o  ",
"  .......o .XX.o  ",
"   o.ooooo .XX.o  ",
"   .X.     .XX.o  ",
"   .XX.....XX.oo  ",
"    .XXXXXXXX.o   ",
"     .XXXXX..oo   ",
"      .....ooo    ",
"       ooooo      ",
"                  ",
"                  "};
static char * tb_redo_xpm[] = {
"18 18 4 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconColor2	m none	c #FFFFFF",
"o	s bottomShadowColor	m black	c #5D6069",
"                  ",
"                  ",
"      .....  ..   ",
"    ..XXXXX..X.o  ",
"   .XXXXXXXXXX.o  ",
"   .XX....XXXX.o  ",
"  .XX.ooo.XXXX.o  ",
"  .XX.o .XXXXX.o  ",
"  .XX.o .......o  ",
"  .XX.o  ooo.ooo  ",
"  .XX.o    .X.    ",
"   .XX.....XX.o   ",
"   .XXXXXXXX.oo   ",
"    ..XXXXX.oo    ",
"      .....oo     ",
"       ooooo      ",
"                  ",
"                  "};
static char * tb_help_xpm[] = {
"18 18 3 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s bottomShadowColor	m black	c #5D6069",
"                  ",
"                  ",
"      .....X      ",
"     ..  X..X     ",
"    ..X   ...     ",
"    ..X   ...     ",
"    X..  X..X     ",
"         ..X      ",
"        ..        ",
"       ..X        ",
"       ..X        ",
"                  ",
"       ..X        ",
"       ..X        ",
"       ..X        ",
"        XX        ",
"                  ",
"                  "};
static char * tb_macro_xpm[] = {
"18 18 4 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s bottomShadowColor	m black	c #5D6069",
"o	s iconColor2	m none	c #FFFFFF",
"       ..X        ",
"      .oo.X       ",
"     .oooo.X      ",
"     .oooo.X      ",
"      .oo.XX      ",
"       ..XX       ",
"   .....o.X       ",
"  .ooooooo.X      ",
"  .oooooooo.X     ",
"   .....ooo.X     ",
"      ..ooo.X     ",
"     .ooooo.X     ",
"    .ooooooo.X    ",
"   .ooo...ooo.X   ",
"  .ooo.XX..ooo.X  ",
"  .oo.XX  X.oo.X  ",
"   ...X    X...X  ",
"    XX       XXX  "};
static char * tb_make_xpm[] = {
"18 18 4 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconColor2	m none	c #FFFFFF",
"o	s bottomShadowColor	m black	c #5D6069",
"                  ",
"    .. .....      ",
"   .XX.XXXXX.     ",
"   .XXXXXXXXX.    ",
"   .Xo.XXXX..X.   ",
"    .. ....o ..   ",
"        ...   .   ",
"        ...o      ",
"        ...o      ",
"        ...o      ",
"        ...o      ",
"        ...o      ",
"        ...o      ",
"        ...o      ",
"        ...o      ",
"        ...o      ",
"         ooo      ",
"                  "};
static char * tb_save_all_xpm[] = {
"18 18 5 1 0 0",
" 	s iconColor1	m black	c #000000",
".	s none	m none	c none",
"X	s iconGray2	m none	c #bdbdbd",
"o	s iconColor2	m none	c #FFFFFF",
"O	s bottomShadowColor	m black	c #5D6069",
"              ....",
" X oooooooo o ....",
" X oooooooo   O...",
" X               .",
" X  X oooooooo o .",
" X  X oooooooo   O",
" X  X oooooooo X O",
" XX X oooooooo X O",
" XX X oooooooo X O",
" XX X oooooooo X O",
" XX XX        XX O",
" XX XXXXXXXXXXXX O",
" XX XX         X O",
".   XX      oo X O",
"..O XX      oo X O",
"... XX      oo X O",
"....             O",
".....OOOOOOOOOOOO."};
static char * tb_jump_xpm[] = {
"18 18 6 1 0 0",
" 	s none	m none	c none",
".	m black	c #888800",
"X	s bottomShadowColor	m black	c #5D6069",
"o	s iconColor6	m none	c #FFFF00",
"O	s iconColor1	m black	c #000000",
"+	s topShadowColor	m none	c #DCDEE5",
"                  ",
"                  ",
"                  ",
"                  ",
"   .............. ",
"  .XooooooooooooOX",
" .XoooooooooooooOX",
".Xo+X+ooooooooooOX",
".ooXOXooooooooooOX",
"Xoo+X+ooooooooooOX",
"XOooooooooooooooOX",
" XOoooooooooooooOX",
"  XOOOOOOOOOOOOOOX",
"   XXXXXXXXXXXXXXX",
"                  ",
"                  ",
"                  ",
"                  "};
static char * tb_ctags_xpm[] = {
"18 18 7 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconColor2	m none	c #FFFFFF",
"o	s bottomShadowColor	m black	c #5D6069",
"O	m black	c #888800",
"+	s topShadowColor	m none	c #DCDEE5",
"@	s iconColor6	m none	c #FFFF00",
"     .. .....     ",
"    .XX.XXXXX.    ",
"    .XXXXXXXXX.   ",
"    .XX.XXXX..X.  ",
"     .. ....o ..  ",
"   OO++O+...+O+.+ ",
"  Oo@@@@@...o@@@.o",
" Oo@@@@@@...o@@@.o",
"Oo@+o+@@@...o@@@.o",
"O@@o.o@@@...o@@@.o",
"o@@+o+@@@...o@@@.o",
"o.@@@@@@@...o@@@.o",
" o.@@@@@@...o@@@.o",
"  o.........o....o",
"   oooooo...oooooo",
"         ...o     ",
"         ...o     ",
"          ooo     "};
static char * tb_load_session_xpm[] = {
"18 18 9 1 0 0",
" 	s none	m none	c none",
".	m black	c #880000",
"X	s iconColor3	m black	c #FF0000",
"o	s iconColor1	m black	c #000000",
"O	s iconColor2	m none	c #FFFFFF",
"+	s iconGray2	m none	c #bdbdbd",
"@	s iconGray5	m black	c #737373",
"#	s iconGray4	m none	c #949494",
"$	s bottomShadowColor	m black	c #5D6069",
"        ..        ",
"       .XX.       ",
"      .XXXX.      ",
"     ...XX...     ",
"       .XX.       ",
"       .XX.       ",
"       .XX.       ",
"       ....       ",
"   ooooooooooooo  ",
"  oOOOOOOOOOO++@o ",
" oOOOOOOOOOOOO#@o ",
" oO+++++++++XX#@o ",
" oO+++++++++++#@o ",
" oOoooooooooo+#@o$",
" oOOOOOOOOOOO+#@o$",
" o+###########@o$ ",
"  ooooooooooooo$  ",
"    $$$$$$$$$$$   "};
static char * tb_save_session_xpm[] = {
"18 18 9 1 0 0",
" 	s none	m none	c none",
".	m black	c #880000",
"X	s iconColor3	m black	c #FF0000",
"o	s iconColor1	m black	c #000000",
"O	s iconColor2	m none	c #FFFFFF",
"+	s iconGray2	m none	c #bdbdbd",
"@	s iconGray5	m black	c #737373",
"#	s iconGray4	m none	c #949494",
"$	s bottomShadowColor	m black	c #5D6069",
"       ....       ",
"       .XX.       ",
"       .XX.       ",
"       .XX.       ",
"     ...XX...     ",
"      .XXXX.      ",
"       .XX.       ",
"        ..        ",
"   ooooooooooooo  ",
"  oOOOOOOOOOO++@o ",
" oOOOOOOOOOOOO#@o ",
" oO+++++++++XX#@o ",
" oO+++++++++++#@o ",
" oOoooooooooo+#@o$",
" oOOOOOOOOOOO+#@o$",
" o+###########@o$ ",
"  ooooooooooooo$  ",
"    $$$$$$$$$$$   "};
static char * tb_new_session_xpm[] = {
"18 18 8 1 0 0",
" 	s none	m none	c none",
".	s bottomShadowColor	m black	c #5D6069",
"X	s iconColor2	m none	c #FFFFFF",
"o	s iconColor1	m black	c #000000",
"O	s iconGray2	m none	c #bdbdbd",
"+	s iconGray5	m black	c #737373",
"@	s iconGray4	m none	c #949494",
"#	s iconColor3	m black	c #FF0000",
"    .  .X.  .     ",
"     . oXo .      ",
"    ..oXXXo..     ",
"    XXXXXXXXX     ",
"    ..oXXXo..     ",
"     . oXo .      ",
"    .  .X.  .     ",
"        .         ",
"   ooooooooooooo  ",
"  oXXXXXXXXXXOO+o ",
" oXXXXXXXXXXXX@+o ",
" oXOOOOOOOOO##@+o ",
" oXOOOOOOOOOOO@+o ",
" oXooooooooooO@+o.",
" oXXXXXXXXXXXO@+o.",
" oO@@@@@@@@@@@+o. ",
"  ooooooooooooo.  ",
"    ...........   "};
static char * tb_blank_xpm[] = {
"18 18 4 1 0 0",
" 	s iconColor1	m black	c #000000",
".	s none	m none	c none",
"X	s topShadowColor	m none	c #DCDEE5",
"o	s bottomShadowColor	m black	c #5D6069",
"                 .",
" XXXXXXXXXXXXXXX .",
" X.............. o",
" X.............. o",
" X.............. o",
" X.............. o",
" X.............. o",
" X.............. o",
" X.............. o",
" X.............. o",
" X.............. o",
" X.............. o",
" X.............. o",
" X.............. o",
" X.............. o",
" X.............. o",
"                 o",
"..oooooooooooooooo"};
static char * tb_maximize_xpm[] = {
"18 18 5 1 0 0",
" 	s none	m none	c none",
".	s topShadowColor	m none	c #DCDEE5",
"X	s iconColor1	m black	c #000000",
"o	s iconColor2	m none	c #FFFFFF",
"O	s bottomShadowColor	m black	c #5D6069",
"                  ",
"  .XXXXXXXXXXX    ",
"  .X....X...oX    ",
"  .X..oXXX..oXO   ",
"  .X.oXXXXX.oXO   ",
"  .X........oXO   ",
"  .X........oXO   ",
"  .X........oXO   ",
"  .X........oXO   ",
"  .X........oXO   ",
"  .X........oXO   ",
"  .X........oXO   ",
"  .X..XXXXX.oXO   ",
"  .X...XXX..oXO   ",
"  .XooooXooooXO   ",
"  .XXXXXXXXXXXO   ",
"     OOOOOOOOOO   ",
"                  "};
static char * tb_split_xpm[] = {
"18 18 5 1 0 0",
" 	s none	m none	c none",
".	s topShadowColor	m none	c #DCDEE5",
"X	s iconColor1	m black	c #000000",
"o	s iconColor2	m none	c #FFFFFF",
"O	s bottomShadowColor	m black	c #5D6069",
"                  ",
"  .XXXXXXXXXXX    ",
"  .X........oX    ",
"  .X..o.....oXO   ",
"  .X.oo.....oXO   ",
"  .X........oXO   ",
"  .X........oXO   ",
"  .XoooooooooXO   ",
"  .XXXXXXXXXXXO   ",
"  .XOOOOOOOOoXO   ",
"  .X..o.....oXO   ",
"  .X.oo.....oXO   ",
"  .X........oXO   ",
"  .X........oXO   ",
"  .XoooooooooXO   ",
"  .XXXXXXXXXXXO   ",
"     OOOOOOOOOO   ",
"                  "};
static char * tb_minimize_xpm[] = {
"18 18 5 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s topShadowColor	m none	c #DCDEE5",
"o	s iconColor2	m none	c #FFFFFF",
"O	s bottomShadowColor	m black	c #5D6069",
"                  ",
"      .....       ",
"       ...        ",
"        .         ",
"                  ",
" X.............   ",
" X.XXXXXXXXXXo.   ",
" X.XXoXXXXXXXo.O  ",
" X.XXXXXXXXXXo.O  ",
" X.XXXXXXXXXoo.O  ",
" X.ooooooooooo.O  ",
" X.............O  ",
"    OOOOOOOOOOOO  ",
"                  ",
"        .         ",
"       ...        ",
"      .....       ",
"                  "};
static char * tb_shell_xpm[] = {
"18 18 6 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconGray6	m black	c #636363",
"o	s iconGray2	m none	c #bdbdbd",
"O	s iconColor2	m none	c #FFFFFF",
"+	s bottomShadowColor	m black	c #5D6069",
"                  ",
"     ... ...      ",
"    .XoXXXoX.     ",
"   .oOoX.XoOo.    ",
"   .XoOoXoOoX.    ",
"  .Xoooo.ooooX.   ",
" .Xo.XOoXoOX.oX.  ",
" .oooXOo.oOXooo.  ",
" .oOo.XOXOX.oOo.+ ",
" .XoOo.o.o.oOoX.+ ",
"  .XooXoooXoOX.+  ",
"   .XoooOoooX.+   ",
"    .ooOOOoo.+    ",
"    ..XoooX..+    ",
"   .XoooooooX.+   ",
"   ...........+   ",
"     ++++++++++   ",
"                  "};
static char * tb_replace_xpm[] = {
"18 18 9 1 0 0",
" 	s none	m none	c none",
".	s iconColor1	m black	c #000000",
"X	s iconColor2	m none	c #FFFFFF",
"o	s bottomShadowColor	m black	c #5D6069",
"+	s iconGray4	m none	c #949494",
"@	s iconColor3	m black	c #FF0000",
"#	s iconGray3	m none	c #adadad",
"$	s iconGray1	m none	c #dedede",
"%	s iconGray7	m black	c #424242",
"                  ",
"  .........       ",
"  .XXXXXXX..      ",
"  .X..XXXX.X.     ",
"  oX..oXXX....    ",
"  o.X..XXXXXX.    ",
"  +....oXXXXX.o   ",
"  .XXX..XXXXX.o   ",
" ..oXo...XXXX.o   ",
"  +XXXXXXXXXX+o   ",
"  .X@@XX@XXX....  ",
"  .Xo@XX@@XX.#$.. ",
"  .XXo@@@@@X....  ",
"  .XXXXX@@XX.#$.. ",
"  .XXXXX@XXX.#$.. ",
"  ......o..%....  ",
"     ooooooooo    ",
"                  "};
static char * tb_vsplit_xpm[] = {
"18 18 5 1 0 0",
" 	s none	m none	c none",
".	s topShadowColor	m none	c #DCDEE5",
"X	s iconColor1	m black	c #000000",
"o	s iconColor2	m none	c #FFFFFF",
"O	s bottomShadowColor	m black	c #5D6069",
"                  ",
" .XXXXXXXXXXXXXX  ",
" .X....oXO....oX  ",
" .X..o.oXO..o.oXO ",
" .X.oo.oXO.oo.oXO ",
" .X....oXO....oXO ",
" .X....oXO....oXO ",
" .X....oXO....oXO ",
" .X....oXO....oXO ",
" .X....oXO....oXO ",
" .X....oXO....oXO ",
" .X....oXO....oXO ",
" .X....oXO....oXO ",
" .X....oXO....oXO ",
" .XoooooXooooooXO ",
" .XXXXXXXXXXXXXXO ",
"    OOOOOOOOOOOOO ",
"                  "};
static char * tb_maxwidth_xpm[] = {
"18 18 5 1 0 0",
" 	s none	m none	c none",
".	s topShadowColor	m none	c #DCDEE5",
"X	s iconColor1	m black	c #000000",
"o	s iconColor2	m none	c #FFFFFF",
"O	s bottomShadowColor	m black	c #5D6069",
"                  ",
"                  ",
"                  ",
"                  ",
".XXXXXXXXXXXXXXXX ",
".X.............oX ",
".X..X........X.oXO",
".X.XX........XXoXO",
".XXXX........XXXXO",
".X.XX........XXoXO",
".X..X........X.oXO",
".XooooooooooooooXO",
".XXXXXXXXXXXXXXXXO",
"   OOOOOOOOOOOOOOO",
"                  ",
"                  ",
"                  ",
"                  "};
static char * tb_minwidth_xpm[] = {
"18 18 5 1 0 0",
" 	s none	m none	c none",
".	s topShadowColor	m none	c #DCDEE5",
"X	s iconColor1	m black	c #000000",
"o	s iconColor2	m none	c #FFFFFF",
"O	s bottomShadowColor	m black	c #5D6069",
"                  ",
"                  ",
"     .XXXXXX      ",
"     .X...oX      ",
"     .X...oX      ",
"     .X...oX      ",
" X   .X.o.oXO   X ",
" XX  .X...oXO  XX ",
" XXX .X...oXO XXX ",
" XX  .X...oXO  XX ",
" X   .X...oXO   X ",
"     .X...oXO     ",
"     .X..ooXO     ",
"     .XooooXO     ",
"     .XXXXXXO     ",
"        OOOOO     ",
"                  ",
"                  "};
static void entry_activate_cb(GtkWidget *widget, gpointer data);
static void entry_changed_cb(GtkWidget *entry, GtkWidget *dialog);
static void find_direction_cb(GtkWidget *widget, gpointer data);
static void find_replace_cb(GtkWidget *widget, gpointer data);
static void wword_match_cb(GtkWidget *widget, gpointer data);
static void mcase_match_cb(GtkWidget *widget, gpointer data);
static void repl_dir_cb(GtkWidget *widget, gpointer data);
    static char_u * translate_mnemonic_tag(char_u *name, int use_mnemonic)
{
    char_u *buf;
    char_u *psrc;
    char_u *pdest;
    int n_underscores = 0;
    if (name == ((void *)0))
        return ((void *)0);
    for (psrc = name; *psrc != '\000' && *psrc != '\011'; ++psrc)
        if (*psrc == '_')
            ++n_underscores;
    buf = alloc((unsigned)(psrc - name + n_underscores + 1));
    if (buf != ((void *)0))
    {
        pdest = buf;
        for (psrc = name; *psrc != '\000' && *psrc != '\011'; ++psrc)
        {
            if (*psrc == '_')
            {
                *pdest++ = '_';
                *pdest++ = '_';
            }
            else if (*psrc != '&')
            {
                *pdest++ = *psrc;
            }
            else if (*(psrc + 1) == '&')
            {
                *pdest++ = *psrc++;
            }
            else if (use_mnemonic)
            {
                *pdest++ = '_';
            }
        }
        *pdest = '\000';
    }
    return buf;
}
    static void menu_item_new(vimmenu_T *menu, GtkWidget *parent_widget)
{
    GtkWidget *widget;
    GtkWidget *bin;
    GtkWidget *label;
    char_u *name;
    guint accel_key;
    widget = gtk_widget_new((gtk_menu_item_get_type ()),
                            "GtkWidget::visible", (!(0)),
                            "GtkWidget::sensitive", (!(0)),
                            ((void *)0));
    bin = gtk_widget_new((gtk_hbox_get_type ()),
                         "GtkWidget::visible", (!(0)),
                         "GtkWidget::parent", widget,
                         "GtkBox::spacing", 16,
                         ((void *)0));
    label = gtk_widget_new((gtk_accel_label_get_type ()),
                           "GtkWidget::visible", (!(0)),
                           "GtkWidget::parent", bin,
                           "GtkAccelLabel::accel_widget", widget,
                           "GtkMisc::xalign", 0.0,
                           ((void *)0));
    menu->label = label;
    if (menu->actext)
        gtk_widget_new((gtk_label_get_type ()),
                       "GtkWidget::visible", (!(0)),
                       "GtkWidget::parent", bin,
                       "GtkLabel::label", menu->actext,
                       "GtkMisc::xalign", 1.0,
                        ((void *)0));
    name = translate_mnemonic_tag(menu->name,
                (p_wak[0] != 'n' || !(( ((GtkTypeObject*) ((parent_widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((parent_widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((parent_widget)))->klass))->type, (((gtk_menu_bar_get_type ())))) ) ))));
    accel_key = gtk_label_parse_uline((((GtkLabel*) gtk_type_check_object_cast ((GtkTypeObject*) ((label)), ((gtk_label_get_type ()))))), (const char *)name);
    vim_free(name);
    if (accel_key != 0xFFFFFF)
    {
        if ((( ((GtkTypeObject*) ((parent_widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((parent_widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((parent_widget)))->klass))->type, (((gtk_menu_bar_get_type ())))) ) )))
        {
            if (*p_wak != 'n')
                gtk_widget_add_accelerator(widget,
                        "activate_item",
                        gui.accel_group,
                        accel_key, GDK_MOD1_MASK,
                        (GtkAccelFlags)0);
        }
        else
        {
            gtk_widget_add_accelerator(widget,
                    "activate_item",
                    gtk_menu_ensure_uline_accel_group((((GtkMenu*) gtk_type_check_object_cast ((GtkTypeObject*) ((parent_widget)), ((gtk_menu_get_type ())))))),
                    accel_key, 0,
                    (GtkAccelFlags)0);
        }
    }
    menu->id = widget;
}
    void gui_mch_add_menu(vimmenu_T *menu, int idx)
{
    vimmenu_T *parent;
    GtkWidget *parent_widget;
    if (menu->name[0] == ']' || menu_is_popup(menu->name))
    {
        menu->submenu_id = gtk_menu_new();
        return;
    }
    parent = menu->parent;
    if ((parent != ((void *)0) && parent->submenu_id == ((void *)0))
            || !menu_is_menubar(menu->name))
        return;
    parent_widget = (parent != ((void *)0)) ? parent->submenu_id : gui.menubar;
    menu_item_new(menu, parent_widget);
    if (parent != ((void *)0))
        ++idx;
    gtk_menu_shell_insert((((GtkMenuShell*) gtk_type_check_object_cast ((GtkTypeObject*) ((parent_widget)), ((gtk_menu_shell_get_type ()))))), menu->id, idx);
    if (parent == ((void *)0) && menu->priority >= 9999)
        gtk_menu_item_right_justify((((GtkMenuItem*) gtk_type_check_object_cast ((GtkTypeObject*) ((menu->id)), ((gtk_menu_item_get_type ()))))));
    menu->submenu_id = gtk_menu_new();
    gtk_menu_set_accel_group((((GtkMenu*) gtk_type_check_object_cast ((GtkTypeObject*) ((menu->submenu_id)), ((gtk_menu_get_type ()))))), gui.accel_group);
    gtk_menu_item_set_submenu((((GtkMenuItem*) gtk_type_check_object_cast ((GtkTypeObject*) ((menu->id)), ((gtk_menu_item_get_type ()))))), menu->submenu_id);
    menu->tearoff_handle = gtk_tearoff_menu_item_new();
    if (vim_strchr(p_go, 't') != ((void *)0))
        gtk_widget_show(menu->tearoff_handle);
    gtk_menu_prepend((((GtkMenu*) gtk_type_check_object_cast ((GtkTypeObject*) ((menu->submenu_id)), ((gtk_menu_get_type ()))))), menu->tearoff_handle);
}
    static void menu_item_activate(GtkWidget *widget, gpointer data)
{
    gui_menu_cb((vimmenu_T *)data);
    if (!gui.in_focus)
        gui_focus_change((!(0)));
    if (gtk_main_level() > 0)
        gtk_main_quit();
}
static char **(built_in_pixmaps[]) =
{
    tb_new_xpm,
    tb_open_xpm,
    tb_save_xpm,
    tb_undo_xpm,
    tb_redo_xpm,
    tb_cut_xpm,
    tb_copy_xpm,
    tb_paste_xpm,
    tb_print_xpm,
    tb_help_xpm,
    tb_find_xpm,
    tb_save_all_xpm,
    tb_save_session_xpm,
    tb_new_session_xpm,
    tb_load_session_xpm,
    tb_macro_xpm,
    tb_replace_xpm,
    tb_close_xpm,
    tb_maximize_xpm,
    tb_minimize_xpm,
    tb_split_xpm,
    tb_shell_xpm,
    tb_find_prev_xpm,
    tb_find_next_xpm,
    tb_find_help_xpm,
    tb_make_xpm,
    tb_jump_xpm,
    tb_ctags_xpm,
    tb_vsplit_xpm,
    tb_maxwidth_xpm,
    tb_minwidth_xpm,
    tb_exit_xpm
};
    static void pixmap_create_from_xpm(char **xpm, GdkPixmap **pixmap, GdkBitmap **mask)
{
    *pixmap = gdk_pixmap_colormap_create_from_xpm_d(
            ((void *)0),
            gtk_widget_get_colormap(gui.mainwin),
            mask,
            ((void *)0),
            xpm);
}
    static void pixmap_create_by_num(int pixmap_num, GdkPixmap **pixmap, GdkBitmap **mask)
{
    if (pixmap_num >= 0 && pixmap_num < (sizeof(built_in_pixmaps)
                                            / sizeof(built_in_pixmaps[0])))
        pixmap_create_from_xpm(built_in_pixmaps[pixmap_num], pixmap, mask);
}
    static void pixmap_create_by_dir(char_u *name, GdkPixmap **pixmap, GdkBitmap **mask)
{
    char_u full_pathname[1024 + 1];
    if (gui_find_bitmap(name, full_pathname, "xpm") == 1)
        *pixmap = gdk_pixmap_colormap_create_from_xpm(
                ((void *)0),
                gtk_widget_get_colormap(gui.mainwin),
                mask,
                &gui.mainwin->style->bg[GTK_STATE_NORMAL],
                (const char *)full_pathname);
}
    static void pixmap_create_from_file(char_u *fname, GdkPixmap **pixmap, GdkBitmap **mask)
{
    *pixmap = gdk_pixmap_colormap_create_from_xpm(
                ((void *)0),
                gtk_widget_get_colormap(gui.mainwin),
                mask,
                &gui.mainwin->style->bg[GTK_STATE_NORMAL],
                (const char *)fname);
}
    void gui_mch_add_menu_item(vimmenu_T *menu, int idx)
{
    vimmenu_T *parent;
    parent = menu->parent;
    if (menu_is_toolbar(parent->name))
    {
        GtkToolbar *toolbar;
        toolbar = (((GtkToolbar*) gtk_type_check_object_cast ((GtkTypeObject*) ((gui.toolbar)), ((gtk_toolbar_get_type ())))));
        menu->submenu_id = ((void *)0);
        if (menu_is_separator(menu->name))
        {
            gtk_toolbar_insert_space(toolbar, idx);
            menu->id = ((void *)0);
        }
        else
        {
            GdkPixmap *pixmap = ((void *)0);
            GdkBitmap *mask = ((void *)0);
            if (menu->iconfile != ((void *)0))
            {
                char_u buf[1024 + 1];
                gui_find_iconfile(menu->iconfile, buf, "xpm");
                pixmap_create_from_file(buf, &pixmap, &mask);
            }
            if (pixmap == ((void *)0) && !menu->icon_builtin)
                pixmap_create_by_dir(menu->name, &pixmap, &mask);
            if (pixmap == ((void *)0) && menu->iconidx >= 0)
                pixmap_create_by_num(menu->iconidx, &pixmap, &mask);
            if (pixmap == ((void *)0))
                pixmap_create_from_xpm(tb_blank_xpm, &pixmap, &mask);
            if (pixmap == ((void *)0))
                return;
            menu->id = gtk_toolbar_insert_item(
                                    toolbar,
                                    (char *)(menu->dname),
                                    (char *)(menu->strings[5]),
                                    (char *)(menu->dname),
                                    gtk_pixmap_new(pixmap, mask),
                                    ((GtkSignalFunc) menu_item_activate),
                                    (gpointer)menu,
                                    idx);
        }
    }
    else
    {
        if (parent->submenu_id == ((void *)0))
            return;
        ++idx;
        if (menu_is_separator(menu->name))
        {
            menu->id = gtk_menu_item_new();
            gtk_widget_set_sensitive(menu->id, (0));
            gtk_widget_show(menu->id);
            gtk_menu_insert((((GtkMenu*) gtk_type_check_object_cast ((GtkTypeObject*) ((parent->submenu_id)), ((gtk_menu_get_type ()))))), menu->id, idx);
            return;
        }
        menu_item_new(menu, parent->submenu_id);
        gtk_widget_show(menu->id);
        gtk_menu_insert((((GtkMenu*) gtk_type_check_object_cast ((GtkTypeObject*) ((parent->submenu_id)), ((gtk_menu_get_type ()))))), menu->id, idx);
        if (menu->id != ((void *)0))
            gtk_signal_connect(( ( (menu->id) != ((void *)0) && ( (((GtkObject*) (menu->id))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (menu->id))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (menu->id) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (menu->id), GTK_TYPE_OBJECT) ), "activate",
                               ((GtkSignalFunc) menu_item_activate), menu);
    }
}
    void gui_mch_set_text_area_pos(int x, int y, int w, int h)
{
    gtk_form_move_resize((((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((gui.formwin)), ((gtk_form_get_type ()))))), gui.drawarea, x, y, w, h);
}
    void gui_gtk_set_mnemonics(int enable)
{
    vimmenu_T *menu;
    char_u *name;
    guint accel_key;
    for (menu = root_menu; menu != ((void *)0); menu = menu->next)
    {
        if (menu->id == ((void *)0))
            continue;
        name = translate_mnemonic_tag(menu->name, (!(0)));
        if (name != ((void *)0))
        {
            accel_key = gtk_label_parse_uline((((GtkLabel*) gtk_type_check_object_cast ((GtkTypeObject*) ((menu->label)), ((gtk_label_get_type ()))))),
                                              (const char *)name);
            if (accel_key != 0xFFFFFF)
                gtk_widget_remove_accelerator(menu->id, gui.accel_group,
                                              accel_key, GDK_MOD1_MASK);
            if (enable && accel_key != 0xFFFFFF)
                gtk_widget_add_accelerator(menu->id, "activate_item",
                                           gui.accel_group,
                                           accel_key, GDK_MOD1_MASK,
                                           (GtkAccelFlags)0);
            vim_free(name);
        }
        if (!enable)
        {
            name = translate_mnemonic_tag(menu->name, (0));
            gtk_label_parse_uline((((GtkLabel*) gtk_type_check_object_cast ((GtkTypeObject*) ((menu->label)), ((gtk_label_get_type ()))))), (const char *)name);
            vim_free(name);
        }
    }
}
    static void recurse_tearoffs(vimmenu_T *menu, int val)
{
    for (; menu != ((void *)0); menu = menu->next)
    {
        if (menu->submenu_id != ((void *)0) && menu->tearoff_handle != ((void *)0)
                && menu->name[0] != ']' && !menu_is_popup(menu->name))
        {
            if (val)
                gtk_widget_show(menu->tearoff_handle);
            else
                gtk_widget_hide(menu->tearoff_handle);
        }
        recurse_tearoffs(menu->children, val);
    }
}
    void gui_mch_toggle_tearoffs(int enable)
{
    recurse_tearoffs(root_menu, enable);
}
    static void toolbar_remove_item_by_text(GtkToolbar *tb, const char *text)
{
    GtkContainer *container;
    GList *childl;
    GtkToolbarChild *gtbc;
    (void)({ if (!(tb != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk.c", 924, __PRETTY_FUNCTION__, "tb != NULL"); return; }; });
    (void)({ if (!((( ((GtkTypeObject*) ((tb))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((tb)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((tb)))->klass))->type, (((gtk_toolbar_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk.c", 925, __PRETTY_FUNCTION__, "GTK_IS_TOOLBAR(tb)"); return; }; });
    container = (((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) ((&tb->container)), ((gtk_container_get_type ())))));
    for (childl = tb->children; childl; childl = childl->next)
    {
        gtbc = (GtkToolbarChild *)childl->data;
        if (gtbc->type != GTK_TOOLBAR_CHILD_SPACE
                && strcmp((((GtkLabel*) gtk_type_check_object_cast ((GtkTypeObject*) ((gtbc->label)), ((gtk_label_get_type ())))))->label, text) == 0)
        {
            gboolean was_visible;
            was_visible = ((((( ( (gtbc->widget) != ((void *)0) && ( (((GtkObject*) (gtbc->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (gtbc->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (gtbc->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (gtbc->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0);
            gtk_widget_unparent(gtbc->widget);
            tb->children = g_list_remove_link(tb->children, childl);
            g_free(gtbc);
            g_list_free(childl);
            tb->num_children--;
            if (was_visible && ((((( ( (container) != ((void *)0) && ( (((GtkObject*) (container))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (container))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (container) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (container), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0))
                gtk_widget_queue_resize((((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((container)), ((gtk_widget_get_type ()))))));
            break;
        }
    }
}
    void gui_mch_menu_set_tip(vimmenu_T *menu)
{
    if (menu->id != ((void *)0) && menu->parent != ((void *)0)
            && gui.toolbar != ((void *)0) && menu_is_toolbar(menu->parent->name))
    {
        char_u *tooltip;
        tooltip = menu->strings[5];
        gtk_tooltips_set_tip((((GtkToolbar*) gtk_type_check_object_cast ((GtkTypeObject*) ((gui.toolbar)), ((gtk_toolbar_get_type ())))))->tooltips,
                             menu->id, (const char *)tooltip, ((void *)0));
    }
}
    void gui_mch_destroy_menu(vimmenu_T *menu)
{
    if (menu->parent != ((void *)0) && menu_is_toolbar(menu->parent->name))
    {
        toolbar_remove_item_by_text((((GtkToolbar*) gtk_type_check_object_cast ((GtkTypeObject*) ((gui.toolbar)), ((gtk_toolbar_get_type ()))))),
                                    (const char *)menu->dname);
    }
    else
    {
        if (menu->submenu_id != ((void *)0))
            gtk_widget_destroy(menu->submenu_id);
        if (menu->id != ((void *)0))
            gtk_widget_destroy(menu->id);
    }
    menu->submenu_id = ((void *)0);
    menu->id = ((void *)0);
}
    void gui_mch_set_scrollbar_thumb(scrollbar_T *sb, long val, long size, long max)
{
    if (sb->id != ((void *)0))
    {
        GtkAdjustment *adjustment;
        adjustment = gtk_range_get_adjustment((((GtkRange*) gtk_type_check_object_cast ((GtkTypeObject*) ((sb->id)), ((gtk_range_get_type ()))))));
        adjustment->lower = 0.0;
        adjustment->value = val;
        adjustment->upper = max + 1;
        adjustment->page_size = size;
        adjustment->page_increment = size < 3L ? 1L : size - 2L;
        adjustment->step_increment = 1.0;
        gtk_signal_handler_block(( ( (adjustment) != ((void *)0) && ( (((GtkObject*) (adjustment))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (adjustment))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (adjustment) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (adjustment), GTK_TYPE_OBJECT) ),
                                                       (guint)sb->handler_id);
        gtk_adjustment_changed(adjustment);
        gtk_signal_handler_unblock(( ( (adjustment) != ((void *)0) && ( (((GtkObject*) (adjustment))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (adjustment))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (adjustment) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (adjustment), GTK_TYPE_OBJECT) ),
                                                       (guint)sb->handler_id);
    }
}
    void gui_mch_set_scrollbar_pos(scrollbar_T *sb, int x, int y, int w, int h)
{
    if (sb->id != ((void *)0))
        gtk_form_move_resize((((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((gui.formwin)), ((gtk_form_get_type ()))))), sb->id, x, y, w, h);
}
    static void adjustment_value_changed(GtkAdjustment *adjustment, gpointer data)
{
    scrollbar_T *sb;
    long value;
    int dragging = (0);
    if (preedit_start_col != (0x7fffffffL))
        xim_reset();
    sb = gui_find_scrollbar((long)data);
    value = (long)adjustment->value;
    if (sb != ((void *)0))
    {
        dragging = ((((GtkRange*) gtk_type_check_object_cast ((GtkTypeObject*) ((sb->id)), ((gtk_range_get_type ())))))->scroll_type == GTK_SCROLL_NONE);
    }
    gui_drag_scrollbar(sb, value, dragging);
    if (gtk_main_level() > 0)
        gtk_main_quit();
}
    void gui_mch_create_scrollbar(scrollbar_T *sb, int orient)
{
    if (orient == 1)
        sb->id = gtk_hscrollbar_new(((void *)0));
    else if (orient == 0)
        sb->id = gtk_vscrollbar_new(((void *)0));
    if (sb->id != ((void *)0))
    {
        GtkAdjustment *adjustment;
        (void)({ (((( ( (sb->id) != ((void *)0) && ( (((GtkObject*) (sb->id))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (sb->id))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (sb->id) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (sb->id), GTK_TYPE_OBJECT) )->flags)) &= ~(GTK_CAN_FOCUS)); });
        gtk_form_put((((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((gui.formwin)), ((gtk_form_get_type ()))))), sb->id, 0, 0);
        adjustment = gtk_range_get_adjustment((((GtkRange*) gtk_type_check_object_cast ((GtkTypeObject*) ((sb->id)), ((gtk_range_get_type ()))))));
        sb->handler_id = gtk_signal_connect(
                             ( ( (adjustment) != ((void *)0) && ( (((GtkObject*) (adjustment))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (adjustment))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (adjustment) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (adjustment), GTK_TYPE_OBJECT) ), "value_changed",
                             ((GtkSignalFunc) adjustment_value_changed),
                             ((gpointer) (sb->ident)));
        gui_mch_update();
    }
}
    void gui_mch_destroy_scrollbar(scrollbar_T *sb)
{
    if (sb->id != ((void *)0))
    {
        gtk_widget_destroy(sb->id);
        sb->id = ((void *)0);
    }
    gui_mch_update();
}
    static void browse_ok_cb(GtkWidget *widget, gpointer cbdata)
{
    gui_T *vw = (gui_T *)cbdata;
    if (vw->browse_fname != ((void *)0))
        g_free(vw->browse_fname);
    vw->browse_fname = (char_u *)g_strdup(gtk_file_selection_get_filename(
                                        (((GtkFileSelection*) gtk_type_check_object_cast ((GtkTypeObject*) ((vw->filedlg)), ((gtk_file_selection_get_type ())))))));
    gtk_widget_hide(vw->filedlg);
    if (gtk_main_level() > 0)
        gtk_main_quit();
}
    static void browse_cancel_cb(GtkWidget *widget, gpointer cbdata)
{
    gui_T *vw = (gui_T *)cbdata;
    if (vw->browse_fname != ((void *)0))
    {
        g_free(vw->browse_fname);
        vw->browse_fname = ((void *)0);
    }
    gtk_widget_hide(vw->filedlg);
    if (gtk_main_level() > 0)
        gtk_main_quit();
}
    static gboolean browse_destroy_cb(GtkWidget * widget)
{
    if (gui.browse_fname != ((void *)0))
    {
        g_free(gui.browse_fname);
        gui.browse_fname = ((void *)0);
    }
    gui.filedlg = ((void *)0);
    if (gtk_main_level() > 0)
        gtk_main_quit();
    return (0);
}
    char_u * gui_mch_browse(int saving,
               char_u *title,
               char_u *dflt,
               char_u *ext,
               char_u *initdir,
               char_u *filter)
{
    GtkFileSelection *fs;
    char_u dirbuf[1024];
    char_u *p;
    if (!gui.filedlg)
    {
        gui.filedlg = gtk_file_selection_new((const gchar *)title);
        gtk_window_set_modal((((GtkWindow*) gtk_type_check_object_cast ((GtkTypeObject*) (gui.filedlg), ((gtk_window_get_type ()))))), (!(0)));
        gtk_window_set_transient_for((((GtkWindow*) gtk_type_check_object_cast ((GtkTypeObject*) (gui.filedlg), ((gtk_window_get_type ()))))),
                (((GtkWindow*) gtk_type_check_object_cast ((GtkTypeObject*) (gui.mainwin), ((gtk_window_get_type ()))))));
        fs = (((GtkFileSelection*) gtk_type_check_object_cast ((GtkTypeObject*) ((gui.filedlg)), ((gtk_file_selection_get_type ())))));
        gtk_container_set_border_width((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) ((fs)), ((gtk_container_get_type ()))))), 4);
        gtk_signal_connect(( ( (fs->ok_button) != ((void *)0) && ( (((GtkObject*) (fs->ok_button))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (fs->ok_button))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (fs->ok_button) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (fs->ok_button), GTK_TYPE_OBJECT) ),
                "clicked", ((GtkSignalFunc) browse_ok_cb), &gui);
        gtk_signal_connect(( ( (fs->cancel_button) != ((void *)0) && ( (((GtkObject*) (fs->cancel_button))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (fs->cancel_button))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (fs->cancel_button) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (fs->cancel_button), GTK_TYPE_OBJECT) ),
                "clicked", ((GtkSignalFunc) browse_cancel_cb), &gui);
        gtk_signal_connect_object(( ( (gui.filedlg) != ((void *)0) && ( (((GtkObject*) (gui.filedlg))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (gui.filedlg))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (gui.filedlg) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (gui.filedlg), GTK_TYPE_OBJECT) ),
                "destroy", ((GtkSignalFunc) browse_destroy_cb),
                ( ( (gui.filedlg) != ((void *)0) && ( (((GtkObject*) (gui.filedlg))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (gui.filedlg))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (gui.filedlg) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (gui.filedlg), GTK_TYPE_OBJECT) ));
    }
    else
        gtk_window_set_title((((GtkWindow*) gtk_type_check_object_cast ((GtkTypeObject*) (gui.filedlg), ((gtk_window_get_type ()))))), (const gchar *)title);
    gui_mch_mousehide((0));
    if (initdir == ((void *)0) || *initdir == '\000')
        mch_dirname(dirbuf, 1024);
    else if (strlen((char *)(initdir)) + 2 < 1024)
        strcpy((char *)(dirbuf), (char *)(initdir));
    else
        dirbuf[0] = '\000';
    add_pathsep(dirbuf);
    if (dflt != ((void *)0) && *dflt != '\000'
                              && strlen((char *)(dirbuf)) + 2 + strlen((char *)(dflt)) < 1024)
        strcat((char *)(dirbuf), (char *)(dflt));
    gtk_file_selection_set_filename((((GtkFileSelection*) gtk_type_check_object_cast ((GtkTypeObject*) ((gui.filedlg)), ((gtk_file_selection_get_type ()))))),
                                                      (const gchar *)dirbuf);
    gui_gtk_position_in_parent((((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((gui.mainwin)), ((gtk_widget_get_type ()))))),
                                       (((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((gui.filedlg)), ((gtk_widget_get_type ()))))), VW_POS_MOUSE);
    gtk_widget_show(gui.filedlg);
    while (gui.filedlg && (((((( ( (gui.filedlg) != ((void *)0) && ( (((GtkObject*) (gui.filedlg))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (gui.filedlg))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (gui.filedlg) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (gui.filedlg), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0) && ((((( ( (gui.filedlg) != ((void *)0) && ( (((GtkObject*) (gui.filedlg))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (gui.filedlg))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (gui.filedlg) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (gui.filedlg), GTK_TYPE_OBJECT) )->flags)) & GTK_MAPPED) != 0)))
        gtk_main_iteration_do((!(0)));
    if (gui.browse_fname == ((void *)0))
        return ((void *)0);
    mch_dirname(dirbuf, 1024);
    p = shorten_fname(gui.browse_fname, dirbuf);
    if (p == ((void *)0))
        p = gui.browse_fname;
    return vim_strsave(p);
}
static char_u *dialog_textfield = ((void *)0);
static GtkWidget *dialog_textentry;
    static void dlg_destroy(GtkWidget *dlg)
{
    if (dialog_textfield != ((void *)0))
    {
        const char *text;
        text = gtk_entry_get_text((((GtkEntry*) gtk_type_check_object_cast ((GtkTypeObject*) ((dialog_textentry)), ((gtk_entry_get_type ()))))));
        strncpy((char *)(dialog_textfield), (char *)(text), (size_t)((1024+1)));
        dialog_textfield[(1024+1) - 1] = '\000';
    }
    gtk_widget_destroy(dlg);
}
    static void dlg_button_clicked(GtkWidget * widget, ButtonData *data)
{
    *(data->status) = data->index + 1;
    dlg_destroy(data->dialog);
}
    static int dlg_key_press_event(GtkWidget * widget, GdkEventKey * event, CancelData *data)
{
    if (event->keyval != 0xFF1B && event->keyval != 0xFF0D)
        return (0);
    *(data->status) = (event->keyval == 0xFF0D);
    dlg_destroy(data->dialog);
    return (!(0));
}
    static void dlg_destroy_cb(int *p)
{
    *p = (!(0));
    if (gtk_main_level() > 0)
        gtk_main_quit();
}
    int gui_mch_dialog( int type,
                char_u *title,
                char_u *message,
                char_u *buttons,
                int def_but,
                char_u *textfield)
{
    char_u *names;
    char_u *p;
    int i;
    int butcount;
    int dialog_status = -1;
    int dialog_destroyed = (0);
    int vertical;
    GtkWidget *dialog;
    GtkWidget *frame;
    GtkWidget *vbox;
    GtkWidget *table;
    GtkWidget *dialogmessage;
    GtkWidget *action_area;
    GtkWidget *sub_area;
    GtkWidget *separator;
    GtkAccelGroup *accel_group;
    GtkWidget *pixmap;
    GdkPixmap *icon = ((void *)0);
    GdkBitmap *mask = ((void *)0);
    char **icon_data = ((void *)0);
    GtkWidget **button;
    ButtonData *data;
    CancelData cancel_data;
    gui_mch_mousehide((0));
    if (title == ((void *)0))
        title = (char_u *)((char *)("Vim dialog..."));
    if ((type < 0) || (type > 4))
        type = 0;
    vertical = (vim_strchr(p_go, 'v') != ((void *)0));
    dialog = gtk_window_new(GTK_WINDOW_DIALOG);
    gtk_window_set_title((((GtkWindow*) gtk_type_check_object_cast ((GtkTypeObject*) (dialog), ((gtk_window_get_type ()))))), (const gchar *)title);
    gtk_window_set_transient_for((((GtkWindow*) gtk_type_check_object_cast ((GtkTypeObject*) (dialog), ((gtk_window_get_type ()))))), (((GtkWindow*) gtk_type_check_object_cast ((GtkTypeObject*) (gui.mainwin), ((gtk_window_get_type ()))))));
    gtk_widget_realize(dialog);
    gdk_window_set_decorations(dialog->window, GDK_DECOR_BORDER);
    gdk_window_set_functions(dialog->window, GDK_FUNC_MOVE);
    cancel_data.status = &dialog_status;
    cancel_data.dialog = dialog;
    gtk_signal_connect_after(( ( (dialog) != ((void *)0) && ( (((GtkObject*) (dialog))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (dialog))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (dialog) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (dialog), GTK_TYPE_OBJECT) ), "key_press_event",
                    ((GtkSignalFunc) dlg_key_press_event),
                    (gpointer) &cancel_data);
    gtk_signal_connect_object(( ( (dialog) != ((void *)0) && ( (((GtkObject*) (dialog))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (dialog))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (dialog) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (dialog), GTK_TYPE_OBJECT) ), "destroy",
                    ((GtkSignalFunc) dlg_destroy_cb),
                    (gpointer)&dialog_destroyed);
    gtk_grab_add(dialog);
    frame = gtk_frame_new(((void *)0));
    gtk_container_add((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) ((dialog)), ((gtk_container_get_type ()))))), frame);
    gtk_widget_show(frame);
    vbox = gtk_vbox_new((0), 0);
    gtk_container_add((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) ((frame)), ((gtk_container_get_type ()))))), vbox);
    gtk_widget_show(vbox);
    table = gtk_table_new(1, 3, (0));
    gtk_table_set_row_spacings((((GtkTable*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_table_get_type ()))))), 4);
    gtk_table_set_col_spacings((((GtkTable*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_table_get_type ()))))), 8);
    gtk_container_set_border_width((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_container_get_type ()))))), 4);
    gtk_box_pack_start((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((vbox)), ((gtk_box_get_type ()))))), table, 4, 4, 0);
    gtk_widget_show(table);
    switch (type)
    {
    case 0:
        icon_data = generic_xpm;
        break;
    case 1:
        icon_data = error_xpm;
        break;
    case 2:
        icon_data = alert_xpm;
        break;
    case 3:
        icon_data = info_xpm;
        break;
    case 4:
        icon_data = quest_xpm;
        break;
    default:
        icon_data = generic_xpm;
    };
    icon = gdk_pixmap_colormap_create_from_xpm_d(((void *)0),
                                     gtk_widget_get_colormap(dialog),
                                     &mask, ((void *)0), icon_data);
    if (icon)
    {
        pixmap = gtk_pixmap_new(icon, mask);
        gtk_table_attach_defaults((((GtkTable*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_table_get_type ()))))), pixmap, 0, 1, 0, 1);
        gtk_widget_show(pixmap);
    }
    dialogmessage = gtk_label_new((const gchar *)message);
    gtk_table_attach_defaults((((GtkTable*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_table_get_type ()))))), dialogmessage, 1, 2, 0, 1);
    gtk_widget_show(dialogmessage);
    dialog_textfield = textfield;
    if (textfield != ((void *)0))
    {
        dialog_textentry = gtk_entry_new();
        gtk_widget_set_usize(dialog_textentry, 400, -2);
        gtk_box_pack_start((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((vbox)), ((gtk_box_get_type ()))))), dialog_textentry, (!(0)), (!(0)), 0);
        gtk_entry_set_text((((GtkEntry*) gtk_type_check_object_cast ((GtkTypeObject*) ((dialog_textentry)), ((gtk_entry_get_type ()))))),
                                                    (const gchar *)textfield);
        gtk_entry_select_region((((GtkEntry*) gtk_type_check_object_cast ((GtkTypeObject*) ((dialog_textentry)), ((gtk_entry_get_type ()))))), 0,
                                                           strlen((char *)(textfield)));
        gtk_entry_set_max_length((((GtkEntry*) gtk_type_check_object_cast ((GtkTypeObject*) ((dialog_textentry)), ((gtk_entry_get_type ()))))), (1024+1) - 1);
        gtk_entry_set_position((((GtkEntry*) gtk_type_check_object_cast ((GtkTypeObject*) ((dialog_textentry)), ((gtk_entry_get_type ()))))), strlen((char *)(textfield)));
        gtk_widget_show(dialog_textentry);
    }
    action_area = gtk_hbox_new((0), 0);
    gtk_container_set_border_width((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) ((action_area)), ((gtk_container_get_type ()))))), 4);
    gtk_box_pack_end((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((vbox)), ((gtk_box_get_type ()))))), action_area, (0), (!(0)), 0);
    gtk_widget_show(action_area);
    if (vertical)
        sub_area = gtk_vbox_new((0), 0);
    else
        sub_area = gtk_hbox_new((0), 0);
    gtk_container_set_border_width((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) ((sub_area)), ((gtk_container_get_type ()))))), 0);
    gtk_box_pack_start((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((action_area)), ((gtk_box_get_type ()))))), sub_area, (!(0)), (0), 0);
    gtk_widget_show(sub_area);
    i = 1;
    for (p = buttons; *p; ++p)
        if (*p == '_')
            ++i;
    names = alloc(strlen((char *)(buttons)) + i);
    if (names == ((void *)0))
        return -1;
    p = names;
    for (i = 0; buttons[i]; ++i)
    {
        if (buttons[i] == '&')
            *p++ = '_';
        else
        {
            if (buttons[i] == '_')
                *p++ = '_';
            *p++ = buttons[i];
        }
    }
    *p = '\000';
    butcount = 1;
    for (p = names; *p; ++p)
        if (*p == '\n')
            ++butcount;
    button = (GtkWidget **)alloc((unsigned)(butcount * sizeof(GtkWidget *)));
    data = (ButtonData *)alloc((unsigned)(butcount * sizeof(ButtonData)));
    if (button == ((void *)0) || data == ((void *)0))
    {
        vim_free(names);
        vim_free(button);
        vim_free(data);
        return -1;
    }
    accel_group = gtk_accel_group_new();
    gtk_accel_group_attach(accel_group, ( ( (dialog) != ((void *)0) && ( (((GtkObject*) (dialog))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (dialog))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (dialog) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (dialog), GTK_TYPE_OBJECT) ));
    p = names;
    for (butcount = 0; *p; ++butcount)
    {
        char_u *next;
        GtkWidget *label;
        guint accel_key;
        for (next = p; *next; ++next)
        {
            if (*next == '\n')
            {
                *next++ = '\000';
                break;
            }
        }
        button[butcount] = gtk_button_new();
        (void)({ (((( ( (button[butcount]) != ((void *)0) && ( (((GtkObject*) (button[butcount]))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (button[butcount]))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (button[butcount]) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (button[butcount]), GTK_TYPE_OBJECT) )->flags)) |= (GTK_CAN_DEFAULT)); });
        label = gtk_accel_label_new("");
        gtk_accel_label_set_accel_widget((((GtkAccelLabel*) gtk_type_check_object_cast ((GtkTypeObject*) ((label)), ((gtk_accel_label_get_type ()))))), dialog);
        accel_key = gtk_label_parse_uline((((GtkLabel*) gtk_type_check_object_cast ((GtkTypeObject*) ((label)), ((gtk_label_get_type ()))))), (const gchar *)p);
        if (accel_key != 0xFFFFFF)
        {
            gtk_widget_add_accelerator(button[butcount],
                    "clicked",
                    accel_group,
                    accel_key, 0,
                    0);
        }
        gtk_container_add((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) ((button[butcount])), ((gtk_container_get_type ()))))), label);
        gtk_widget_show_all(button[butcount]);
        data[butcount].status = &dialog_status;
        data[butcount].index = butcount;
        data[butcount].dialog = dialog;
        gtk_signal_connect(( ( (button[butcount]) != ((void *)0) && ( (((GtkObject*) (button[butcount]))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (button[butcount]))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (button[butcount]) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (button[butcount]), GTK_TYPE_OBJECT) ),
                           (const char *)"clicked",
                           ((GtkSignalFunc) dlg_button_clicked),
                           (gpointer) &data[butcount]);
        gtk_box_pack_start((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((sub_area)), ((gtk_box_get_type ()))))), button[butcount],
                           (!(0)), (0), 0);
        p = next;
    }
    vim_free(names);
    if (butcount > 0)
    {
        --def_but;
        if (def_but >= butcount)
            def_but = -1;
        if (def_but >= 0)
        {
            gtk_widget_grab_focus(button[def_but]);
            gtk_widget_grab_default(button[def_but]);
        }
    }
    if (textfield != ((void *)0))
        gtk_window_set_focus((((GtkWindow*) gtk_type_check_object_cast ((GtkTypeObject*) (dialog), ((gtk_window_get_type ()))))), dialog_textentry);
    separator = gtk_hseparator_new();
    gtk_box_pack_end((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((vbox)), ((gtk_box_get_type ()))))), separator, (0), (!(0)), 0);
    gtk_widget_show(separator);
    dialog_status = -1;
    gui_gtk_position_in_parent((((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((gui.mainwin)), ((gtk_widget_get_type ()))))),
                                            (((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((dialog)), ((gtk_widget_get_type ()))))), VW_POS_MOUSE);
    gtk_widget_show(dialog);
    while (dialog_status == -1 && !dialog_destroyed
                                               && (((((( ( (dialog) != ((void *)0) && ( (((GtkObject*) (dialog))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (dialog))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (dialog) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (dialog), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0) && ((((( ( (dialog) != ((void *)0) && ( (((GtkObject*) (dialog))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (dialog))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (dialog) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (dialog), GTK_TYPE_OBJECT) )->flags)) & GTK_MAPPED) != 0)))
        gtk_main_iteration_do((!(0)));
    if (dialog_status < 0)
        dialog_status = 0;
    if (dialog_status != 1 && textfield != ((void *)0))
        *textfield = '\000';
    gtk_accel_group_unref(accel_group);
    vim_free(button);
    vim_free(data);
    return dialog_status;
}
    void gui_mch_show_popupmenu(vimmenu_T *menu)
{
    gtk_menu_popup((((GtkMenu*) gtk_type_check_object_cast ((GtkTypeObject*) ((menu->submenu_id)), ((gtk_menu_get_type ()))))),
                   ((void *)0), ((void *)0),
                   (GtkMenuPositionFunc)((void *)0), ((void *)0),
                   3U, (guint32)0L);
}
    static void popup_menu_position_func(GtkMenu *menu,
                         gint *x, gint *y,
                         gpointer user_data)
{
    if (curwin != ((void *)0) && gui.drawarea != ((void *)0) && gui.drawarea->window != ((void *)0))
    {
        gdk_window_get_origin(gui.drawarea->window, x, y);
        *x += (((curwin->w_wincol) + curwin->w_wcol + 1) * gui.char_width + gui.border_offset) + 1;
        *y += (((curwin->w_winrow) + curwin->w_wrow + 1) * gui.char_height + gui.border_offset) + 1;
    }
}
    void gui_make_popup(char_u *path_name)
{
    vimmenu_T *menu;
    menu = gui_find_menu(path_name);
    if (menu != ((void *)0) && menu->submenu_id != ((void *)0))
    {
        gtk_menu_popup((((GtkMenu*) gtk_type_check_object_cast ((GtkTypeObject*) ((menu->submenu_id)), ((gtk_menu_get_type ()))))),
                       ((void *)0), ((void *)0),
                       &popup_menu_position_func, ((void *)0),
                       0U, (guint32)0L);
    }
}
static SharedFindReplace find_widgets = { ((void *)0), };
static SharedFindReplace repl_widgets = { ((void *)0), };
    static int find_key_press_event(
                GtkWidget *widget,
                GdkEventKey *event,
                SharedFindReplace *frdp)
{
    if (event->state & (GDK_CONTROL_MASK | GDK_SHIFT_MASK))
        return (0);
    if (event->keyval == 0xFF1B)
    {
        gtk_widget_hide(frdp->dialog);
        return (!(0));
    }
    if (event->keyval == 0xFF51
            || event->keyval == 0xFF53
            || event->keyval == 0x020)
        return (!(0));
    return (0);
}
    static void find_replace_dialog_create(char_u *arg, int do_replace)
{
    GtkWidget *frame;
    GtkWidget *hbox;
    GtkWidget *actionarea;
    GtkWidget *table;
    GtkWidget *tmp;
    GtkWidget *vbox;
    gboolean sensitive;
    SharedFindReplace *frdp;
    char_u *entry_text;
    int wword = (0);
    int mcase = !p_ic;
    frdp = (do_replace) ? (&repl_widgets) : (&find_widgets);
    entry_text = get_find_dialog_text(arg, &wword, &mcase);
    if (frdp->dialog)
    {
        gui_gtk_position_in_parent((((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((gui.mainwin)), ((gtk_widget_get_type ()))))),
                                      (((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((frdp->dialog)), ((gtk_widget_get_type ()))))), VW_POS_MOUSE);
        gui_gtk_synch_fonts();
        if (!((((( ( (frdp->dialog) != ((void *)0) && ( (((GtkObject*) (frdp->dialog))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->dialog))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->dialog) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->dialog), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0))
        {
            gtk_widget_grab_focus(frdp->what);
            gtk_widget_show(frdp->dialog);
        }
        if (entry_text != ((void *)0))
        {
            gtk_entry_set_text((((GtkEntry*) gtk_type_check_object_cast ((GtkTypeObject*) ((frdp->what)), ((gtk_entry_get_type ()))))), (char *)entry_text);
            gtk_toggle_button_set_active((((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((frdp->wword)), ((gtk_toggle_button_get_type ()))))),
                                                             (gboolean)wword);
            gtk_toggle_button_set_active((((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((frdp->mcase)), ((gtk_toggle_button_get_type ()))))),
                                                             (gboolean)mcase);
        }
        gdk_window_raise(frdp->dialog->window);
        vim_free(entry_text);
        return;
    }
    frdp->dialog = gtk_window_new(GTK_WINDOW_DIALOG);
    if (do_replace)
    {
        gtk_window_set_wmclass((((GtkWindow*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->dialog), ((gtk_window_get_type ()))))), "searchrepl", "gvim");
        gtk_window_set_title((((GtkWindow*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->dialog), ((gtk_window_get_type ()))))),
                             (((char *)("VIM - Search and Replace..."))));
    }
    else
    {
        gtk_window_set_wmclass((((GtkWindow*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->dialog), ((gtk_window_get_type ()))))), "search", "gvim");
        gtk_window_set_title((((GtkWindow*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->dialog), ((gtk_window_get_type ()))))),
                             (((char *)("VIM - Search..."))));
    }
    gtk_widget_realize(frdp->dialog);
    gdk_window_set_decorations(frdp->dialog->window,
            GDK_DECOR_TITLE | GDK_DECOR_BORDER | GDK_DECOR_RESIZEH);
    gdk_window_set_functions(frdp->dialog->window,
            GDK_FUNC_RESIZE | GDK_FUNC_MOVE);
    frame = gtk_frame_new(((void *)0));
    gtk_container_add((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) ((frdp->dialog)), ((gtk_container_get_type ()))))), frame);
    hbox = gtk_hbox_new((0), 0);
    gtk_container_add((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) ((frame)), ((gtk_container_get_type ()))))), hbox);
    if (do_replace)
        table = gtk_table_new(1024, 4, (0));
    else
        table = gtk_table_new(1024, 3, (0));
    gtk_box_pack_start((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((hbox)), ((gtk_box_get_type ()))))), table, (!(0)), (!(0)), 0);
    gtk_container_set_border_width((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_container_get_type ()))))), 4);
    tmp = gtk_label_new((((char *)("Find what:"))));
    gtk_misc_set_alignment((((GtkMisc*) gtk_type_check_object_cast ((GtkTypeObject*) ((tmp)), ((gtk_misc_get_type ()))))), (gfloat)0.0, (gfloat)0.5);
    gtk_table_attach((((GtkTable*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_table_get_type ()))))), tmp, 0, 1, 0, 1,
                     GTK_FILL, GTK_EXPAND, 2, 2);
    frdp->what = gtk_entry_new();
    sensitive = (entry_text != ((void *)0) && entry_text[0] != '\000');
    if (entry_text != ((void *)0))
        gtk_entry_set_text((((GtkEntry*) gtk_type_check_object_cast ((GtkTypeObject*) ((frdp->what)), ((gtk_entry_get_type ()))))), (char *)entry_text);
    gtk_signal_connect(( ( (frdp->what) != ((void *)0) && ( (((GtkObject*) (frdp->what))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->what))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->what) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->what), GTK_TYPE_OBJECT) ), "changed",
                       ((GtkSignalFunc) entry_changed_cb), frdp->dialog);
    gtk_signal_connect_after(( ( (frdp->what) != ((void *)0) && ( (((GtkObject*) (frdp->what))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->what))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->what) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->what), GTK_TYPE_OBJECT) ), "key_press_event",
                                 ((GtkSignalFunc) find_key_press_event),
                                 (gpointer) frdp);
    gtk_table_attach((((GtkTable*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_table_get_type ()))))), frdp->what, 1, 1024, 0, 1,
                     GTK_EXPAND | GTK_FILL, GTK_EXPAND, 2, 2);
    if (do_replace)
    {
        tmp = gtk_label_new((((char *)("Replace with:"))));
        gtk_misc_set_alignment((((GtkMisc*) gtk_type_check_object_cast ((GtkTypeObject*) ((tmp)), ((gtk_misc_get_type ()))))), (gfloat)0.0, (gfloat)0.5);
        gtk_table_attach((((GtkTable*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_table_get_type ()))))), tmp, 0, 1, 1, 2,
                         GTK_FILL, GTK_EXPAND, 2, 2);
        frdp->with = gtk_entry_new();
        gtk_signal_connect(( ( (frdp->with) != ((void *)0) && ( (((GtkObject*) (frdp->with))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->with))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->with) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->with), GTK_TYPE_OBJECT) ), "activate",
                           ((GtkSignalFunc) find_replace_cb),
                           ((gpointer) (2)));
        gtk_signal_connect_after(( ( (frdp->with) != ((void *)0) && ( (((GtkObject*) (frdp->with))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->with))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->with) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->with), GTK_TYPE_OBJECT) ), "key_press_event",
                                 ((GtkSignalFunc) find_key_press_event),
                                 (gpointer) frdp);
        gtk_table_attach((((GtkTable*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_table_get_type ()))))), frdp->with, 1, 1024, 1, 2,
                         GTK_EXPAND | GTK_FILL, GTK_EXPAND, 2, 2);
        gtk_signal_connect(( ( (frdp->what) != ((void *)0) && ( (((GtkObject*) (frdp->what))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->what))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->what) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->what), GTK_TYPE_OBJECT) ), "activate",
                           ((GtkSignalFunc) entry_activate_cb), frdp->with);
    }
    else
    {
        gtk_signal_connect(( ( (frdp->what) != ((void *)0) && ( (((GtkObject*) (frdp->what))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->what))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->what) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->what), GTK_TYPE_OBJECT) ), "activate",
                           ((GtkSignalFunc) find_replace_cb),
                           ((gpointer) (1)));
    }
    frdp->wword = gtk_check_button_new_with_label((((char *)("Match whole word only"))));
    gtk_toggle_button_set_active((((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((frdp->wword)), ((gtk_toggle_button_get_type ()))))),
                                                        (gboolean)wword);
    gtk_signal_connect(( ( (frdp->wword) != ((void *)0) && ( (((GtkObject*) (frdp->wword))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->wword))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->wword) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->wword), GTK_TYPE_OBJECT) ), "clicked",
                       ((GtkSignalFunc) wword_match_cb), ((void *)0));
    if (do_replace)
        gtk_table_attach((((GtkTable*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_table_get_type ()))))), frdp->wword, 0, 1023, 2, 3,
                         GTK_FILL, GTK_EXPAND, 2, 2);
    else
        gtk_table_attach((((GtkTable*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_table_get_type ()))))), frdp->wword, 0, 1023, 1, 2,
                         GTK_FILL, GTK_EXPAND, 2, 2);
    frdp->mcase = gtk_check_button_new_with_label((((char *)("Match case"))));
    gtk_toggle_button_set_active((((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((frdp->mcase)), ((gtk_toggle_button_get_type ()))))),
                                                             (gboolean)mcase);
    gtk_signal_connect(( ( (frdp->mcase) != ((void *)0) && ( (((GtkObject*) (frdp->mcase))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->mcase))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->mcase) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->mcase), GTK_TYPE_OBJECT) ), "clicked",
                       ((GtkSignalFunc) mcase_match_cb), ((void *)0));
    if (do_replace)
        gtk_table_attach((((GtkTable*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_table_get_type ()))))), frdp->mcase, 0, 1023, 3, 4,
                         GTK_FILL, GTK_EXPAND, 2, 2);
    else
        gtk_table_attach((((GtkTable*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_table_get_type ()))))), frdp->mcase, 0, 1023, 2, 3,
                         GTK_FILL, GTK_EXPAND, 2, 2);
    tmp = gtk_frame_new((((char *)("Direction"))));
    if (do_replace)
        gtk_table_attach((((GtkTable*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_table_get_type ()))))), tmp, 1023, 1024, 2, 4,
                         GTK_FILL, GTK_FILL, 2, 2);
    else
        gtk_table_attach((((GtkTable*) gtk_type_check_object_cast ((GtkTypeObject*) ((table)), ((gtk_table_get_type ()))))), tmp, 1023, 1024, 1, 3,
                         GTK_FILL, GTK_FILL, 2, 2);
    vbox = gtk_vbox_new((0), 0);
    gtk_container_set_border_width((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) ((vbox)), ((gtk_container_get_type ()))))), 0);
    gtk_container_add((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) ((tmp)), ((gtk_container_get_type ()))))), vbox);
    frdp->up = gtk_radio_button_new_with_label(((void *)0), (((char *)("Up"))));
    gtk_box_pack_start((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((vbox)), ((gtk_box_get_type ()))))), frdp->up, (!(0)), (!(0)), 0);
    frdp->down = gtk_radio_button_new_with_label(
                        gtk_radio_button_group((((GtkRadioButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((frdp->up)), ((gtk_radio_button_get_type ())))))),
                        (((char *)("Down"))));
    gtk_toggle_button_set_active((((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((frdp->down)), ((gtk_toggle_button_get_type ()))))), (!(0)));
    gtk_signal_connect(( ( (frdp->down) != ((void *)0) && ( (((GtkObject*) (frdp->down))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->down))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->down) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->down), GTK_TYPE_OBJECT) ), "clicked",
                       (do_replace) ? ((GtkSignalFunc) repl_dir_cb)
                                    : ((GtkSignalFunc) find_direction_cb),
                       ((void *)0));
    gtk_box_pack_start((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((vbox)), ((gtk_box_get_type ()))))), frdp->down, (!(0)), (!(0)), 0);
    actionarea = gtk_vbutton_box_new();
    gtk_container_set_border_width((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) ((actionarea)), ((gtk_container_get_type ()))))), 2);
    if (do_replace)
    {
        gtk_button_box_set_layout((((GtkButtonBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((actionarea)), ((gtk_button_box_get_type ()))))),
                                  GTK_BUTTONBOX_END);
        gtk_button_box_set_spacing((((GtkButtonBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((actionarea)), ((gtk_button_box_get_type ()))))), 0);
    }
    gtk_box_pack_end((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((hbox)), ((gtk_box_get_type ()))))), actionarea, (0), (0), 0);
    frdp->find = gtk_button_new_with_label(((char *)("Find Next")));
    gtk_widget_set_sensitive(frdp->find, sensitive);
    gtk_signal_connect(( ( (frdp->find) != ((void *)0) && ( (((GtkObject*) (frdp->find))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->find))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->find) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->find), GTK_TYPE_OBJECT) ), "clicked",
                       ((GtkSignalFunc) find_replace_cb),
                       (do_replace) ? ((gpointer) (2))
                                    : ((gpointer) (1)));
    (void)({ (((( ( (frdp->find) != ((void *)0) && ( (((GtkObject*) (frdp->find))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->find))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->find) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->find), GTK_TYPE_OBJECT) )->flags)) |= (GTK_CAN_DEFAULT)); });
    gtk_box_pack_start((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((actionarea)), ((gtk_box_get_type ()))))), frdp->find, (0), (0), 0);
    gtk_widget_grab_default(frdp->find);
    if (do_replace)
    {
        frdp->replace = gtk_button_new_with_label(((char *)("Replace")));
        gtk_widget_set_sensitive(frdp->replace, sensitive);
        (void)({ (((( ( (frdp->replace) != ((void *)0) && ( (((GtkObject*) (frdp->replace))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->replace))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->replace) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->replace), GTK_TYPE_OBJECT) )->flags)) |= (GTK_CAN_DEFAULT)); });
        gtk_box_pack_start((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((actionarea)), ((gtk_box_get_type ()))))), frdp->replace, (0), (0), 0);
        gtk_signal_connect(( ( (frdp->replace) != ((void *)0) && ( (((GtkObject*) (frdp->replace))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->replace))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->replace) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->replace), GTK_TYPE_OBJECT) ), "clicked",
                           ((GtkSignalFunc) find_replace_cb),
                           ((gpointer) (3)));
        frdp->all = gtk_button_new_with_label(((char *)("Replace All")));
        gtk_widget_set_sensitive(frdp->all, sensitive);
        (void)({ (((( ( (frdp->all) != ((void *)0) && ( (((GtkObject*) (frdp->all))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->all))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->all) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->all), GTK_TYPE_OBJECT) )->flags)) |= (GTK_CAN_DEFAULT)); });
        gtk_box_pack_start((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((actionarea)), ((gtk_box_get_type ()))))), frdp->all, (0), (0), 0);
        gtk_signal_connect(( ( (frdp->all) != ((void *)0) && ( (((GtkObject*) (frdp->all))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->all))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->all) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->all), GTK_TYPE_OBJECT) ), "clicked",
                           ((GtkSignalFunc) find_replace_cb),
                           ((gpointer) (4)));
    }
    tmp = gtk_button_new_with_label(((char *)("Cancel")));
    (void)({ (((( ( (tmp) != ((void *)0) && ( (((GtkObject*) (tmp))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (tmp))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (tmp) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (tmp), GTK_TYPE_OBJECT) )->flags)) |= (GTK_CAN_DEFAULT)); });
    gtk_box_pack_end((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((actionarea)), ((gtk_box_get_type ()))))), tmp, (0), (0), 0);
    gtk_signal_connect_object(( ( (tmp) != ((void *)0) && ( (((GtkObject*) (tmp))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (tmp))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (tmp) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (tmp), GTK_TYPE_OBJECT) ),
                              "clicked", ((GtkSignalFunc) gtk_widget_hide),
                              ( ( (frdp->dialog) != ((void *)0) && ( (((GtkObject*) (frdp->dialog))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->dialog))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->dialog) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->dialog), GTK_TYPE_OBJECT) ));
    gtk_signal_connect_object(( ( (frdp->dialog) != ((void *)0) && ( (((GtkObject*) (frdp->dialog))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->dialog))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->dialog) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->dialog), GTK_TYPE_OBJECT) ),
                              "delete_event", ((GtkSignalFunc) gtk_widget_hide_on_delete),
                              ( ( (frdp->dialog) != ((void *)0) && ( (((GtkObject*) (frdp->dialog))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (frdp->dialog))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (frdp->dialog) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (frdp->dialog), GTK_TYPE_OBJECT) ));
    tmp = gtk_vseparator_new();
    gtk_box_pack_end((((GtkBox*) gtk_type_check_object_cast ((GtkTypeObject*) ((hbox)), ((gtk_box_get_type ()))))), tmp, (0), (!(0)), 0);
    gtk_widget_grab_focus(frdp->what);
    gtk_widget_show_all(frame);
    gui_gtk_position_in_parent((((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((gui.mainwin)), ((gtk_widget_get_type ()))))),
                                      (((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((frdp->dialog)), ((gtk_widget_get_type ()))))), VW_POS_MOUSE);
    gui_gtk_synch_fonts();
    vim_free(entry_text);
}
    void gui_mch_find_dialog(exarg_T *eap)
{
    if (gui.in_use)
        find_replace_dialog_create(eap->arg, (0));
}
    void gui_mch_replace_dialog(exarg_T *eap)
{
    if (gui.in_use)
        find_replace_dialog_create(eap->arg, (!(0)));
}
    void gui_gtk_synch_fonts(void)
{
    SharedFindReplace *frdp;
    int do_replace;
    for (do_replace = 0; do_replace <= 1; ++do_replace)
    {
        frdp = (do_replace) ? (&repl_widgets) : (&find_widgets);
        if (frdp->dialog)
        {
            GtkStyle *style;
            style = gtk_style_copy(gtk_widget_get_style(frdp->what));
            gdk_font_unref(style->font);
                style->font = gui.norm_font;
            gdk_font_ref(style->font);
            gtk_widget_set_style(frdp->what, style);
            gtk_style_unref(style);
            if (do_replace)
            {
                style = gtk_style_copy(gtk_widget_get_style(frdp->with));
                gdk_font_unref(style->font);
                    style->font = gui.norm_font;
                gdk_font_ref(style->font);
                gtk_widget_set_style(frdp->with, style);
                gtk_style_unref(style);
            }
        }
    }
}
    static void find_replace_cb(GtkWidget *widget, gpointer data)
{
    int flags;
    char_u *find_text;
    char_u *repl_text;
    gboolean direction_down;
    SharedFindReplace *sfr;
    int rc;
    flags = (int)(long)data;
    if (flags == 1)
    {
        repl_text = ((void *)0);
        sfr = &find_widgets;
    }
    else
    {
        repl_text = (char_u *)gtk_entry_get_text((((GtkEntry*) gtk_type_check_object_cast ((GtkTypeObject*) ((repl_widgets.with)), ((gtk_entry_get_type ()))))));
        sfr = &repl_widgets;
    }
    find_text = (char_u *)gtk_entry_get_text((((GtkEntry*) gtk_type_check_object_cast ((GtkTypeObject*) ((sfr->what)), ((gtk_entry_get_type ()))))));
    direction_down = (((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((sfr->down)), ((gtk_toggle_button_get_type ())))))->active;
    if ((((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((sfr->wword)), ((gtk_toggle_button_get_type ())))))->active)
        flags |= 0x08;
    if ((((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((sfr->mcase)), ((gtk_toggle_button_get_type ())))))->active)
        flags |= 0x10;
    rc = gui_do_findrepl(flags, find_text, repl_text, direction_down);
    if (rc && gtk_main_level() > 0)
        gtk_main_quit();
}
    static void entry_activate_cb(GtkWidget *widget, gpointer data)
{
    gtk_widget_grab_focus((((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((data)), ((gtk_widget_get_type ()))))));
}
    static void find_direction_cb(GtkWidget * widget, gpointer data)
{
    gboolean direction_down = (((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_toggle_button_get_type ())))))->active;
    if (repl_widgets.dialog)
    {
        GtkWidget *w;
        w = direction_down ? repl_widgets.down : repl_widgets.up;
        if (!(((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((w)), ((gtk_toggle_button_get_type ())))))->active)
            gtk_toggle_button_set_active((((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((w)), ((gtk_toggle_button_get_type ()))))), (!(0)));
    }
}
    static void repl_dir_cb(GtkWidget *widget, gpointer data)
{
    gboolean direction_down = (((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_toggle_button_get_type ())))))->active;
    if (find_widgets.dialog)
    {
        GtkWidget *w;
        w = direction_down ? find_widgets.down : find_widgets.up;
        if (!(((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((w)), ((gtk_toggle_button_get_type ())))))->active)
            gtk_toggle_button_set_active((((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((w)), ((gtk_toggle_button_get_type ()))))), (!(0)));
    }
}
    static void wword_match_cb(GtkWidget * widget, gpointer data)
{
    gboolean active = (((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_toggle_button_get_type ())))))->active;
    if (find_widgets.dialog)
        gtk_toggle_button_set_active((((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((find_widgets.wword)), ((gtk_toggle_button_get_type ()))))),
                                    active);
    if (repl_widgets.dialog)
        gtk_toggle_button_set_active((((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((repl_widgets.wword)), ((gtk_toggle_button_get_type ()))))),
                                    active);
}
    static void mcase_match_cb(GtkWidget * widget, gpointer data)
{
    gboolean active = (((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_toggle_button_get_type ())))))->active;
    if (find_widgets.dialog)
        gtk_toggle_button_set_active((((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((find_widgets.mcase)), ((gtk_toggle_button_get_type ()))))),
                                    active);
    if (repl_widgets.dialog)
        gtk_toggle_button_set_active((((GtkToggleButton*) gtk_type_check_object_cast ((GtkTypeObject*) ((repl_widgets.mcase)), ((gtk_toggle_button_get_type ()))))),
                                    active);
}
    static void entry_changed_cb(GtkWidget * entry, GtkWidget * dialog)
{
    const gchar *entry_text;
    gboolean nonempty;
    entry_text = gtk_entry_get_text((((GtkEntry*) gtk_type_check_object_cast ((GtkTypeObject*) ((entry)), ((gtk_entry_get_type ()))))));
    if (!entry_text)
        return;
    nonempty = (entry_text[0] != '\0');
    if (dialog == find_widgets.dialog)
    {
        gtk_widget_set_sensitive(find_widgets.find, nonempty);
        if (repl_widgets.dialog)
        {
            gtk_widget_set_sensitive(repl_widgets.find, nonempty);
            gtk_widget_set_sensitive(repl_widgets.replace, nonempty);
            gtk_widget_set_sensitive(repl_widgets.all, nonempty);
            if (strcmp(entry_text,
                       gtk_entry_get_text((((GtkEntry*) gtk_type_check_object_cast ((GtkTypeObject*) ((repl_widgets.what)), ((gtk_entry_get_type ()))))))))
                gtk_entry_set_text((((GtkEntry*) gtk_type_check_object_cast ((GtkTypeObject*) ((repl_widgets.what)), ((gtk_entry_get_type ()))))), entry_text);
        }
    }
    if (dialog == repl_widgets.dialog)
    {
        gtk_widget_set_sensitive(repl_widgets.find, nonempty);
        gtk_widget_set_sensitive(repl_widgets.replace, nonempty);
        gtk_widget_set_sensitive(repl_widgets.all, nonempty);
        if (find_widgets.dialog)
        {
            gtk_widget_set_sensitive(find_widgets.find, nonempty);
            if (strcmp(entry_text,
                       gtk_entry_get_text((((GtkEntry*) gtk_type_check_object_cast ((GtkTypeObject*) ((find_widgets.what)), ((gtk_entry_get_type ()))))))))
                gtk_entry_set_text((((GtkEntry*) gtk_type_check_object_cast ((GtkTypeObject*) ((find_widgets.what)), ((gtk_entry_get_type ()))))), entry_text);
        }
    }
}
    void ex_helpfind(eap)
    exarg_T *eap;
{
    do_cmdline_cmd((char_u *)"emenu ToolBar.FindHelp");
}
    void gui_gtk_position_in_parent(
        GtkWidget *parent,
        GtkWidget *child,
        gui_win_pos_T where)
{
    GtkRequisition c_size;
    gint xPm, yPm;
    gint xP, yP, wP, hP, pos_x, pos_y;
    gtk_widget_size_request(child, &c_size);
    gdk_window_get_origin((GdkWindow *)(parent->window), &xP, &yP);
    gdk_window_get_size((GdkWindow *)(parent->window), &wP, &hP);
    if (c_size.width > wP || c_size.height > hP)
    {
        gtk_widget_set_uposition(child , xP + 2 , yP + 2);
        return;
    }
    if (where == VW_POS_MOUSE)
    {
        gtk_widget_get_pointer(parent, &xPm, &yPm);
        pos_x = xP + xPm - (c_size.width) / 2;
        pos_y = yP + yPm - (c_size.height) / 2;
    }
    else
    {
        pos_x = xP + (wP - c_size.width) / 2;
        if (where == VW_POS_TOP_CENTER)
            pos_y = yP + 2;
        else
            pos_y = yP + (hP - c_size.height) / 2;
    }
    if (pos_x < xP)
        pos_x = xP + 2;
    if (pos_y < yP)
        pos_y = yP + 2;
    if ((pos_x + c_size.width) > (wP + xP))
        pos_x = xP + wP - c_size.width - 2;
    if ((pos_y + c_size.height + p_ghr / 2) > (hP + yP))
        pos_y = yP + hP - c_size.height - 2 - p_ghr / 2;
    gtk_widget_set_uposition(child, pos_x, pos_y);
}
